#include "scriptinterface.h"

#include "Fed_3MissionText.h"
#include "Fed_3MissionMaps.h"
/**************************************************************
Things needed to finish LNF

make Neutral team disengage after being 'rescued' - it's in there, but maybe make it more clear?
check for captured ships

the enemy race thing has to be looked at.  It's actually the mirror race
but there is an allied race that needs to be put in here somewhere
**************************************************************/

//***      balance      ***
eClassTypes PlayerShipClass = kClassShuttle;
eClassTypes LargestEnemyShipClass = kClassFrigate;
eClassTypes NewEnemyShipClass( tScript& tScript, eClassTypes LargestEnemyShipClass );
//***                   ***

int32 Neutral_ADestroyed = 0;
int32 Neutral_BDestroyed = 0;
int32 PlayerDestroyed = 0;
int32 Imperial_ADestroyed = 0;
int32 Imperial_BDestroyed = 0;
int32 ListeningPostDestroyed = 0;
int32 MirrorHostile = 0; // if Player is hostile to Mirror
int32 ListeningPostScanned = 0;
int32 MissionStarted = 0;

bool MirrorAttackedNeutral = false;
bool AtWarWithNeutral = false;
bool goalOnNeutral_A = false;
bool goalOnNeutral_B = false;
bool LpAttackedByImperial = false;
bool PlayerUsedESCKey = false; // if the player Ends Mission with the ESC key

int32 Neutral_A_Attacked = 0;
int32 Neutral_B_Attacked = 0;
int32 NeutralAttacked = 0; // imperial team attacks neutral team
bool Neutral_AHostile = false; // player attacks Neutral
bool Neutral_BHostile = false; // player attacks Neutral
int32 LpAttacked = 0;
int32 Imperial_A_Attacked = 0;
int32 Imperial_B_Attacked = 0;
bool tryToScanOnce = false;
const float kDeepScanDistance = 10.0;
const float kDamageThreshold = 70.0;
void KlingonCommMessages(tScript& tScript, int32 fEventID, tShipInfo* Ship);
void RomulanCommMessages(tScript& tScript, int32 fEventID, tShipInfo* Ship);
void GornCommMessages(tScript& tScript, int32 fEventID, tShipInfo* Ship);
void setPatrolRoute(tScript& tScript, tTeamInfo* patrolRouteTeam);
const float kPatrolRadius = 1.0;


// include this file after all other includes
#include "DeepScanTracker.h"
tDeepScanTracker DeepScanTracker;

//---------------------------------------------------------------------------------------------
// the following enum is used to identify all non-player teams in the script
// (use kPlayerTeam to access the current players team.)
enum eTeamTypes
{
	// the first 6 team types are reserved for player teams.
	kReserved = kTeam6,

	// add all non-player teams (enemy, allied, monsters, etc...) after this point.

	kImperial_ATeam,
	kImperial_BTeam,
	kNeutral_ATeam,
	kNeutral_BTeam,
	kLpTeam
};
//---------------------------------------------------------------------------------------------
// called by script interface - 
// should return whatever team is considered to be the primary enemy
int32 tScript::mGetEnemyTeamID (void)
{
	return kPlayerTeam;
}

//---------------------------------------------------------------------------------------------
// returns mission specs used by Dynaverse to build campaigns
void tScript::mScriptSpecs (tMissionSpec* Specs)
{
	Specs->fMissionType = kCampaignMission;
	Specs->fMissionTitle = Messages[kMissionTitle_msg].mCharStr();
	Specs->fSectorType = kAllSectors;
	Specs->fPlayerRace = kFedMission;
	Specs->fEnemyRace = kKlingMission | kRomulanMission | kGornMission; // these three should be the ALLIED race not enemy
	Specs->fNumShips = MissSpecAllShips;
	Specs->fMinBPV = 0;
	Specs->fMaxBPV = kMaxBPV;
	Specs->fMinDate = 9999;
	Specs->fMaxDate = 9999;
	Specs->fWait = kUniqueMission;
	Specs->fEnableSupplyDock = kTrue;
}

//---------------------------------------------------------------------------------------------
// called at the start of mission initialization - use to set prestige points 
// and override mission defaults such as:
//		allied race
//		enemy race
//		system name
// and also returns map index to use
int32 tScript::mInitializeStart (tDynaverseScriptInfo& info)
{
	fMission.mSetPrestigePoints (200, 160, 100, 40, 0);

	// must set up the races of the teams in the script
	//info.fEnemyRace = info.fPlayerRace;
	info.fAlliedRace = (fMission.mRandomInt32 (1, 100) < 33) ? kKlingon
					  : (fMission.mRandomInt32 (1, 100) < 66) ? kRomulan : kGorn;
	fMission.mSetTeamRace (kPlayerTeam, info.fPlayerRace);
	fMission.mSetTeamRace (kImperial_ATeam, kMirror);
	fMission.mSetTeamRace (kImperial_BTeam, kMirror);

	// LNF: The Neutral team can vary
	fMission.mSetTeamRace (kNeutral_ATeam, info.fAlliedRace);
	fMission.mSetTeamRace (kNeutral_BTeam, info.fAlliedRace);
	fMission.mSetTeamRace (kLpTeam, info.fAlliedRace);

	// setup team relations and target goals
	fMission.mSetTeamRelations (kPlayerTeam, kImperial_ATeam, kTeamHostile, kGoalIgnore, 1.0, kTrue);
	fMission.mSetTeamRelations (kPlayerTeam, kImperial_BTeam, kTeamHostile, kGoalIgnore, 1.0, kTrue);
	fMission.mSetTeamRelations (kPlayerTeam, kNeutral_ATeam, kTeamHostile, kGoalIgnore, 1.0, kTrue);
	fMission.mSetTeamRelations (kPlayerTeam, kNeutral_BTeam, kTeamHostile, kGoalIgnore, 1.0, kTrue);
	fMission.mSetTeamRelations (kPlayerTeam, kLpTeam, kTeamHostile, kGoalIgnore, 1.0, kTrue);

	fMission.mSetTeamRelations (kImperial_ATeam, kImperial_BTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);
	fMission.mSetTeamRelations (kImperial_ATeam, kNeutral_ATeam, kTeamAtWar, kGoalDestroy, 1.0);
	fMission.mSetTeamRelations (kImperial_ATeam, kNeutral_BTeam, kTeamAtWar, kGoalDestroy, 1.0);
	fMission.mSetTeamRelations (kImperial_ATeam, kLpTeam, kTeamNeutral, kGoalIgnore, 1.0);

	fMission.mSetTeamRelations (kImperial_BTeam, kNeutral_ATeam, kTeamAtWar, kGoalDestroy, 1.0);
	fMission.mSetTeamRelations (kImperial_BTeam, kNeutral_BTeam, kTeamAtWar, kGoalDestroy, 1.0);
	fMission.mSetTeamRelations (kImperial_BTeam, kLpTeam, kTeamNeutral, kGoalIgnore, 1.0);
	
	fMission.mSetTeamRelations (kNeutral_ATeam, kImperial_ATeam, kTeamNeutral, kGoalIgnore, 1.0);
	fMission.mSetTeamRelations (kNeutral_ATeam, kImperial_BTeam, kTeamNeutral, kGoalIgnore, 1.0);
	fMission.mSetTeamRelations (kNeutral_ATeam, kNeutral_BTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);
	fMission.mSetTeamRelations (kNeutral_ATeam, kLpTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);

	fMission.mSetTeamRelations (kNeutral_BTeam, kImperial_ATeam, kTeamNeutral, kGoalIgnore, 1.0);
	fMission.mSetTeamRelations (kNeutral_BTeam, kImperial_BTeam, kTeamNeutral, kGoalIgnore, 1.0);
	fMission.mSetTeamRelations (kNeutral_BTeam, kLpTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);

	fMission.mSetTeamRelations (kLpTeam, kImperial_ATeam, kTeamNeutral, kGoalIgnore, 1.0);
	fMission.mSetTeamRelations (kLpTeam, kImperial_BTeam, kTeamNeutral, kGoalIgnore, 1.0);

	return 1;
}

//---------------------------------------------------------------------------------------------
// return kTrue if players ship should be created for this mission
iTruth tScript::mUsePlayerShip (tShipInGame& Ship)
{
	return kTrue;
}

//---------------------------------------------------------------------------------------------
// called to create ships before or during the mission
// Mode is user supplied value (expect for 0, which is initial setup call)
void tScript::mCreateMissionShips (int32 Mode)
{
	tTeamInfo* PlayerTeam = fMission.mGetTeamHandle (kPlayerTeam);
	tTeamInfo* Imperial_ATeam = fMission.mGetTeamHandle (kImperial_ATeam);
	tTeamInfo* Imperial_BTeam = fMission.mGetTeamHandle (kImperial_BTeam);
	tTeamInfo* Neutral_ATeam = fMission.mGetTeamHandle (kNeutral_ATeam);
	tTeamInfo* Neutral_BTeam = fMission.mGetTeamHandle (kNeutral_BTeam);
	tTeamInfo* LpTeam = fMission.mGetTeamHandle (kLpTeam);

	tShipInfo* Ship = NULL;

	// Get the total BPV of the player and modify by a low and high percentage
	int32 LowBPV = PlayerTeam->mGetCombatBPV() * .75;
	int32 HighBPV = PlayerTeam->mGetCombatBPV() * 1.25;
	int32 TotalBPV = fMission.mRandomInt32 (LowBPV, HighBPV);

	// balance
	int32 NumberOfPlayersShips = PlayerTeam->mGetShipsInPlayCount();
	int32 DifLev = fMission.mGetDifficultyLevel();

	// determine the biggest ship class the player has
	for (Ship = PlayerTeam->mGetFirstShip(); Ship != NULL; Ship = PlayerTeam->mGetNextShip())
	{
		if (PlayerShipClass < Ship->mGetClassType())
		{
			PlayerShipClass = Ship->mGetClassType();
		}
	}

	switch ( DifLev )
	{
		case 0:
			{
				TotalBPV *= 0.60f;

				// set LargestEnemyShipClass to one SMALLER than the player
				if ( PlayerShipClass > kClassFrigate )
				{
					LargestEnemyShipClass = (eClassTypes) ((int32)PlayerShipClass - 1);
				}
			}
			break;
		case 1:
			{
				// do nothing
				LargestEnemyShipClass = PlayerShipClass;
			}
			break;
		case 2:
			{
				TotalBPV *= 1.5f;

				// set LargestEnemyShipClass to one LARGER than the player
				if ( PlayerShipClass < kClassBattleship )
				{
					LargestEnemyShipClass = (eClassTypes) ((int32)PlayerShipClass + 1);
				}
			}
			break;
	}

	int32 AveragePlayerBPV = TotalBPV / NumberOfPlayersShips;

	// create Imperial_A team
	Imperial_ATeam->mCreateFleet (2, LowBPV, kClassFrigate, kClassFrigate, 20, kStartPosition_W);

	// create Imperial_B team
	Imperial_BTeam->mCreateFleet (2, LowBPV, kClassFrigate, kClassFrigate, 20, kStartPosition_Y);

	// create Neutral_A team
	Neutral_ATeam->mCreateShip (LowBPV, kClassLightCruiser, kClassLightCruiser, 20, kStartPosition_J);

	// create Neutral_B team
	Neutral_BTeam->mCreateShip (LowBPV, kClassLightCruiser, kClassLightCruiser, 20, kStartPosition_K);

	// LNF: create Neutral Listening Post
	if ( LpTeam->mGetRace() == kRomulan )
	{
		LpTeam->mCreateShip ( "R-LP", kStartPosition_L);
	}
	else if ( LpTeam->mGetRace() == kKlingon )
	{
		LpTeam->mCreateShip ( "K-LP", kStartPosition_L);
	}
	else // default Gorn
	{
		LpTeam->mCreateShip ( "G-LP", kStartPosition_L);
	}
}

//---------------------------------------------------------------------------------------------
// called at the end of mission initialization - use to return briefing message
int32 tScript::mInitializeFinished (void)
{
	return (kBriefing_msg);
}

//---------------------------------------------------------------------------------------------
// called after all ships have been created and mission is ready to start.
// use to set callback events and change default ship configuration
void tScript::mStartMission (void)
{
	tTeamInfo* PlayerTeam = fMission.mGetTeamHandle (kPlayerTeam);
	tTeamInfo* Imperial_ATeam = fMission.mGetTeamHandle (kImperial_ATeam);
	tTeamInfo* Imperial_BTeam = fMission.mGetTeamHandle (kImperial_BTeam);
	tTeamInfo* Neutral_ATeam = fMission.mGetTeamHandle (kNeutral_ATeam);
	tTeamInfo* Neutral_BTeam = fMission.mGetTeamHandle (kNeutral_BTeam);
	tTeamInfo* LpTeam = fMission.mGetTeamHandle (kLpTeam);
	tShipInfo* Ship;

	// configure Player ship(s)
	PlayerTeam->mGetFirstShip()->mSetShipPlayerControlled();
	for (Ship = PlayerTeam->mGetFirstShip(); Ship != NULL; Ship = PlayerTeam->mGetNextShip())
	{
		Ship->mSetShipThrust (5);
	}

	// configure Imperial_A ships
	for (Ship = Imperial_ATeam->mGetFirstShip(); Ship != NULL; Ship = Imperial_ATeam->mGetNextShip())
	{
		Ship->mSetCommButton (1, kButtonHail_text);
		Ship->mSetShipCallbackEvents(kNotifyDamage);
		// LNF
		Ship->mAccessSupplies( kSetSupplyCount, kSupplyMarines, 0 );
	}

	// configure Imperial_B ships
	for (Ship = Imperial_BTeam->mGetFirstShip(); Ship != NULL; Ship = Imperial_BTeam->mGetNextShip())
	{
		Ship->mSetCommButton (1, kButtonHail_text);
		Ship->mSetShipCallbackEvents(kNotifyDamage);
	}

	// configure Neutral_A ships
	for (Ship = Neutral_ATeam->mGetFirstShip(); Ship != NULL; Ship = Neutral_ATeam->mGetNextShip())
	{
		Ship->mSetCommButton (1, kButtonHail_text);
		Ship->mSetShipCallbackEvents(kNotifyDamage);
	}
	setPatrolRoute( *this, Neutral_ATeam );

	// configure Neutral_B ships
	for (Ship = Neutral_BTeam->mGetFirstShip(); Ship != NULL; Ship = Neutral_BTeam->mGetNextShip())
	{
		Ship->mSetCommButton (1, kButtonHail_text);
		Ship->mSetShipCallbackEvents(kNotifyDamage);
	}
	setPatrolRoute( *this, Neutral_BTeam );

	// configure Listening Post team
	Ship = LpTeam->mGetThisShip(1);
	Ship->mSetCommButton (1, kButtonHail_text);
	Ship->mSetShipCallbackEvents(kNotifyDamage);
	Ship->mChangeName( kListeningPost_name );

	fMission.mDisplayMessage (kStarting_msg, kNonCommScriptMessage);

	// Start a timer
	fMission.mSetTimedInterval (kTimerLimitSet, 1);

	// setup to test deep scan every second - must be called before any entities are added to be scanned
	DeepScanTracker.mSetTimer (*this, kTimerLimitSet_10, 1);	// will use kTimerLimitSet_10 as polling timer
	// deep scan ListeningPost from within kDeepScanDistance for 1 turn
	DeepScanTracker.mSetTarget (LpTeam->mGetThisShip(1), kDeepScanDistance, 1);
}

//---------------------------------------------------------------------------------------------
// called whenever a ship is created after a mission has already started
void tScript::mNewMissionShip (tShipInfo* Ship)
{
}

//---------------------------------------------------------------------------------------------
// called during mission when events occur
eGameStatus tScript::mHandleShipEvent (tShipInfo* Ship, iNotifyEvents Event)
{
	tTeamInfo* PlayerTeam = fMission.mGetTeamHandle (kPlayerTeam);
	tTeamInfo* Imperial_ATeam = fMission.mGetTeamHandle (kImperial_ATeam);
	tTeamInfo* Imperial_BTeam = fMission.mGetTeamHandle (kImperial_BTeam);
	tTeamInfo* Neutral_ATeam = fMission.mGetTeamHandle (kNeutral_ATeam);
	tTeamInfo* Neutral_BTeam = fMission.mGetTeamHandle (kNeutral_BTeam);
	tTeamInfo* LpTeam = fMission.mGetTeamHandle (kLpTeam);

	tShipInfo* PlayersTarget = fMission.mGetShipTarget(fPlayerShip);

	switch (Event)
	{
/* LNF I think the DeepScan needed to be taken out, but I don't know
		case kNotifyDeepScan:
			if ( fIsDeepScanOn == kTrue )
			{
				if (( PlayersTarget != NULL ) &&
					( PlayersTarget == LpTeam->mGetFirstShip() ) && 
					( ListeningPostScanned == 0 ) &&
					( fPlayerShip->mGetTacticalDistance(LpTeam->mGetFirstShip()) > kDeepScanDistance ))
				{
					if ( tryToScanOnce == false )
					{
						fMission.mDisplayMessage( kTooFarToScan_1_msg, kScienceScriptMessage );
						tryToScanOnce = true;
					}
					else
					{
						fMission.mDisplayMessage( kTooFarToScan_2_msg, kScienceScriptMessage );
					}
				}
			}
			break;
*/
		case kNotifyDamage:
			{
				tShipInfo* HostileShip = fMission.mFindShipID (fEventID);

				
				Ship->mSetShipCallbackEvents(kNotifyDamage);

				if ( HostileShip != NULL )
				{
					if ( HostileShip->mGetTeam() == kPlayerTeam )
					{
						if (( PlayersTarget != NULL ) && (PlayersTarget->mGetTeam() == kImperial_ATeam) && (Imperial_A_Attacked == 0))
						{
							Ship->mSetShipTarget( fPlayerShip, kVeryHighPriority );
							fMission.mSetTeamRelations (kNeutral_ATeam, kImperial_ATeam, kTeamAtWar, kGoalDestroy, 1.0, kTrue);
							Imperial_A_Attacked = 1;
							MirrorHostile = 1; // the player attacked Mirror team
							if ( goalOnNeutral_A == true )
							{
								fMission.mSetGoalIndicator( kFalse, 0, 0 );
							}
						}
						else if (( PlayersTarget != NULL ) && (PlayersTarget->mGetTeam() == kImperial_BTeam) && (Imperial_B_Attacked == 0))
						{
							Ship->mSetShipTarget( fPlayerShip, kVeryHighPriority );
							fMission.mSetTeamRelations (kNeutral_BTeam, kImperial_BTeam, kTeamAtWar, kGoalDestroy, 1.0, kTrue);
							Imperial_B_Attacked = 1;
							MirrorHostile = 1; // the player attacked Mirror team
							if ( goalOnNeutral_B == true )
							{
								fMission.mSetGoalIndicator( kFalse, 0, 0 );
							}
						}
						else if (( PlayersTarget != NULL ) && (PlayersTarget->mGetTeam() == kNeutral_ATeam) && (Neutral_AHostile == false))
						{
							// LNF maybe some message statement here?
							fMission.mSetTeamRelations (kNeutral_ATeam, kPlayerTeam, kTeamAtWar, kGoalDestroy, 1.0, kTrue);
							Neutral_AHostile = true; // the player attacks Neutral team
							if ( goalOnNeutral_A == true )
							{
								fMission.mSetGoalIndicator( kFalse, 0, 0 );
							}
						}
						else if (( PlayersTarget != NULL ) && (PlayersTarget->mGetTeam() == kNeutral_BTeam) && (Neutral_BHostile == false))
						{
							// LNF maybe some message statement here?
							fMission.mSetTeamRelations (kNeutral_BTeam, kPlayerTeam, kTeamAtWar, kGoalDestroy, 1.0, kTrue);
							Neutral_BHostile = true; // the player attacks Neutral team
							if ( goalOnNeutral_B == true )
							{
								fMission.mSetGoalIndicator( kFalse, 0, 0 );
							}
						}
					}
					else if (( HostileShip->mGetTeam() == kImperial_ATeam ) || ( HostileShip->mGetTeam() == kImperial_BTeam ))
					{
						if ((Ship->mGetTeam() == kNeutral_ATeam) && (Neutral_A_Attacked == 0))
						{
							if ( NeutralAttacked == 0 )
							{
								fMission.mDisplayMessage (kEvent2FirstBattle_msg, kScienceScriptMessage);
							}
							else if ( NeutralAttacked == 1 )
							{
								fMission.mDisplayMessage (kEvent2SecondBattle_msg, kScienceScriptMessage);
							}
							fMission.mSetGoalIndicator( Ship );
							goalOnNeutral_A = true;
							fMission.mSetTeamRelations (kImperial_ATeam, kNeutral_ATeam, kTeamAtWar, kGoalDestroy, 1.0, kTrue);
							Neutral_A_Attacked = 1;
							NeutralAttacked++;
						}
						else if ((Ship->mGetTeam() == kNeutral_BTeam) && (Neutral_B_Attacked == 0))
						{
							if ( NeutralAttacked == 0 )
							{
								fMission.mDisplayMessage (kEvent2FirstBattle_msg, kScienceScriptMessage);
							}
							else if ( NeutralAttacked == 1 )
							{
								fMission.mDisplayMessage (kEvent2SecondBattle_msg, kScienceScriptMessage);
							}
							fMission.mSetGoalIndicator( Ship );
							goalOnNeutral_B = true;
							fMission.mSetTeamRelations (kImperial_BTeam, kNeutral_BTeam, kTeamAtWar, kGoalDestroy, 1.0, kTrue);
							Neutral_B_Attacked = 1;
							NeutralAttacked++;
						}
						else if ((Ship->mGetTeam() == kLpTeam) && ( LpAttackedByImperial == false ))
						{
							fMission.mDisplayMessage (kEvent8LpAttacked_msg, kScienceScriptMessage);
							LpAttacked = 1;
							LpAttackedByImperial = true;
						}
					}
				}
			}			
			break;

		case kNotifyAtTimedInterval:
			switch (fEventID)
			{
				case kTimerLimitSet:
					if (MissionStarted == 0)
					{
						// setup team relations and target goals
						fMission.mSetTeamRelations (kPlayerTeam, kImperial_ATeam, kTeamHostile, kGoalDestroy, 1.0, kTrue);
						fMission.mSetTeamRelations (kPlayerTeam, kImperial_BTeam, kTeamHostile, kGoalDestroy, 1.0, kTrue);
						// LNF is the player allied with the Neutral?
						fMission.mSetTeamRelations (kPlayerTeam, kNeutral_ATeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);
						fMission.mSetTeamRelations (kPlayerTeam, kNeutral_BTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);
						fMission.mSetTeamRelations (kPlayerTeam, kLpTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);

						fMission.mSetTeamRelations (kImperial_ATeam, kImperial_BTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);
						fMission.mSetTeamRelations (kImperial_ATeam, kNeutral_ATeam, kTeamAtWar, kGoalDestroy, 1.0, kTrue);
						fMission.mSetTeamRelations (kImperial_ATeam, kNeutral_BTeam, kTeamAtWar, kGoalDestroy, 1.0, kTrue);
						fMission.mSetTeamRelations (kImperial_ATeam, kLpTeam, kTeamNeutral, kGoalIgnore, 1.0, kTrue);

						fMission.mSetTeamRelations (kImperial_BTeam, kNeutral_ATeam, kTeamAtWar, kGoalDestroy, 1.0, kTrue);
						fMission.mSetTeamRelations (kImperial_BTeam, kNeutral_BTeam, kTeamAtWar, kGoalDestroy, 1.0, kTrue);
						fMission.mSetTeamRelations (kImperial_BTeam, kLpTeam, kTeamNeutral, kGoalIgnore, 1.0, kTrue);
						
						fMission.mSetTeamRelations (kNeutral_ATeam, kNeutral_BTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);
						fMission.mSetTeamRelations (kNeutral_ATeam, kLpTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);

						fMission.mSetTeamRelations (kNeutral_BTeam, kLpTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);

						fMission.mDisplayMessage( kStartScenario_msg, kMissionScriptMessage );
						fMission.mSetTimedInterval( kTimerLimitSet_2, 3 );

					}
					break;

				case kTimerLimitSet_2:
					fMission.mDisplayMessage (kStartFoundLp_msg, kScienceScriptMessage);
					fMission.mSetGoalIndicator( LpTeam->mGetFirstShip() );
					break;

				case kTimerLimitSet_10:
					{
						eDeepScanFlags flag;
						tShipInfo* Object = DeepScanTracker.mTestForDeepScan (&flag);
						switch (flag)
						{
							case kOutOfRange_ScanOff:
								// player is not within any objects range and deep scan is off (Object == NULL)
								break;
							case kOutOfRange_ScanOn:
								// player is not within any objects range and deep scan is on (Object == NULL)
								break;
							case kEnteringRange_ScanOff:
								// player has just entered range and scan is off (Object points to entity)
								// notify player to turn scan on
								fMission.mDisplayMessage (kScannerOffInRange_msg, kScienceScriptMessage);
								break;
							case kEnteringRange_ScanOn_TimerStarted:
								// player has just entered range and scan is on (Object points to entity)
								// notify player that timer has begun
								fMission.mDisplayMessage (kStartingScan_1_msg, kScienceScriptMessage);
								break;
							case kInRange_ScanOff_TimerStopped:
								// player is in range and scan is off (Object points to entity)
								// notify player that timer has been turned off
								fMission.mDisplayMessage (kTurnedOffScanInRange_msg, kScienceScriptMessage);
								break;
							case kInRange_ScanOff:
								// player is still in range and scan is still off (Object points to entity)
								break;
							case kInRange_ScanOn_TimerStarted:
								// player is in range and scan is on (Object points to entity)
								// notify player that timer has begun
								fMission.mDisplayMessage (kTurnedOnScanInRange_msg, kScienceScriptMessage);
								break;
							case kInRange_ScanOn:
								// player is still in range and scan is still on (Object points to entity)
								break;
							case kLeavingRange_ScanOn_TimerStopped:
								// player has just left the range and scan is on (Object points to entity)
								// notify player that timer is now off
								fMission.mDisplayMessage (kScanOnMoveOutOfRange_msg, kScienceScriptMessage);
								break;
							case kLeavingRange_ScanOff:
								// player has just left the range and scan is off (Object points to entity)
								break;
						}
					}
					break;

				case kTimerCountdownSet:
					{
						eDeepScanFlags flag;
						tShipInfo* Object = DeepScanTracker.mTestForDeepScan (&flag);
						if (flag == kInRange_ScanOn)
						{
							// player has successfully scanned the object
							ListeningPostScanned = 1;
							fMission.mDisplayMessage (kEvent1ScanningA_msg, kScienceScriptMessage);
							fMission.mDisplayMessage (kEvent1ScanningB_msg, kScienceScriptMessage);
							if (( Imperial_BTeam->mGetShipsInPlayCount() == 0 ) &&
								( Imperial_ATeam->mGetShipsInPlayCount() == 0 ))
							{
								return kPlayerWins;
							}
							DeepScanTracker.mRemoveTarget (Object);
						}
					}
					break;

				case kTimerTurnsSet:
					break;

				case kTimerTurnsSet_7:
					// set the Neutral B Team comm buttons back to HAIL
					for (Ship = Neutral_BTeam->mGetFirstShip(); Ship != NULL; Ship = Neutral_BTeam->mGetNextShip())
					{
						Ship->mClearCommButton (2);
						Ship->mSetCommButton (1, kButtonHail_text);
					}
					break;

				case kTimerTurnsSet_8:
					// set the Neutral A Team comm buttons back to HAIL
					for (Ship = Neutral_ATeam->mGetFirstShip(); Ship != NULL; Ship = Neutral_ATeam->mGetNextShip())
					{
						Ship->mClearCommButton (2);
						Ship->mSetCommButton (1, kButtonHail_text);
					}
					break;

				case kTimerTurnsSet_9:
					// set the Imperial B Team comm buttons back to HAIL
					for (Ship = Imperial_BTeam->mGetFirstShip(); Ship != NULL; Ship = Imperial_BTeam->mGetNextShip())
					{
						Ship->mClearCommButton (2);
						Ship->mSetCommButton (1, kButtonHail_text);
					}
					break;

				case kTimerTurnsSet_10:
					// set the Imperial A Team comm buttons back to HAIL
					for (Ship = Imperial_ATeam->mGetFirstShip(); Ship != NULL; Ship = Imperial_ATeam->mGetNextShip())
					{
						Ship->mClearCommButton (2);
						Ship->mSetCommButton (1, kButtonHail_text);
					}
					break;

			} // switch
			break;

		case kNotifyOnCapture:
			fMission.mDisplayMessage( kVesselBoarded_msg, kMissionScriptMessage );

			if (Ship->mGetTeam() == kImperial_ATeam)
			{
				fMission.mAddToBonusPrestige( kCaptureBonus );

				Imperial_ADestroyed++;
				if (Imperial_ATeam->mGetShipsInPlayCount() == 0)
				{
					Neutral_ATeam->mDisengageShips( kByMapEdge, kVeryHighPriority );
					// LNF maybe some kind of message like "going home to warn others"?
					if (( Imperial_BTeam->mGetShipsInPlayCount() == 0 ) &&
						( ListeningPostScanned == 1 ))
					{
						return kPlayerWins;
					}
				}
			}
			else if (Ship->mGetTeam() == kImperial_BTeam)
			{
				fMission.mAddToBonusPrestige( kCaptureBonus );

				Imperial_BDestroyed++;
				if (Imperial_BTeam->mGetShipsInPlayCount() == 0)
				{
					Neutral_BTeam->mDisengageShips( kByMapEdge, kVeryHighPriority );
					// LNF maybe some kind of message like "going home to warn others"?
					if (( Imperial_ATeam->mGetShipsInPlayCount() == 0 ) &&
						( ListeningPostScanned == 1 ))
					{
						return kPlayerWins;
					}
				}
			}
			else if (Ship->mGetTeam() == kNeutral_ATeam)
			{
				Neutral_ADestroyed++;
				// LNF need a capture message here
				//fMission.mDisplayMessage (kEvent6NeutralDestroyed_msg, kScienceScriptMessage);
				if (Neutral_ATeam->mGetShipsInPlayCount() == 0)
				{
					// LNF might have to manually make Imperial attack Lp
					Imperial_ATeam->mClearCommands();
					fMission.mSetTeamRelations (kImperial_ATeam, kLpTeam, kTeamAtWar, kGoalDestroy, 1.0, kTrue);
					if (Neutral_BTeam->mGetShipsInPlayCount() == 0)
					{
						return kPlayerLoses;
					}
				}
			}
			else if (Ship->mGetTeam() == kNeutral_BTeam)
			{
				Neutral_BDestroyed++;
				// LNF need a capture message here
				//fMission.mDisplayMessage (kEvent6NeutralDestroyed_msg, kScienceScriptMessage);
				if (Neutral_BTeam->mGetShipsInPlayCount() == 0)
				{
					// LNF might have to manually make Imperial attack Lp
					Imperial_BTeam->mClearCommands();
					fMission.mSetTeamRelations (kImperial_BTeam, kLpTeam, kTeamAtWar, kGoalDestroy, 1.0, kTrue);
					if (Neutral_ATeam->mGetShipsInPlayCount() == 0)
					{
						return kPlayerLoses;
					}
				}
			}
			break;
					
		case kNotifyAtDeath:
			if (Ship->mGetTeam() == kImperial_ATeam)
			{
				Imperial_ADestroyed++;
				if (Imperial_ATeam->mGetShipsInPlayCount() == 0)
				{
					Neutral_ATeam->mDisengageShips( kByMapEdge, kVeryHighPriority );
					// LNF maybe some kind of message like "going home to warn others"?
					if (( Imperial_BTeam->mGetShipsInPlayCount() == 0 ) &&
						( ListeningPostScanned == 1 ))
					{
						return kPlayerWins;
					}
				}
			}
			else if (Ship->mGetTeam() == kImperial_BTeam)
			{
				Imperial_BDestroyed++;
				if (Imperial_BTeam->mGetShipsInPlayCount() == 0)
				{
					Neutral_BTeam->mDisengageShips( kByMapEdge, kVeryHighPriority );
					// LNF maybe some kind of message like "going home to warn others"?
					if (( Imperial_ATeam->mGetShipsInPlayCount() == 0 ) &&
						( ListeningPostScanned == 1 ))
					{
						return kPlayerWins;
					}
				}
			}
			else if (Ship->mGetTeam() == kPlayerTeam)
			{
				PlayerDestroyed++;
				if (PlayerTeam->mGetShipsInPlayCount() == 0)
				{
					return kPlayerDestroyed;
				}
			}
			else if (Ship->mGetTeam() == kNeutral_ATeam)
			{
				Neutral_ADestroyed++;
				fMission.mDisplayMessage (kEvent6NeutralDestroyed_msg, kScienceScriptMessage);
				if (Neutral_ATeam->mGetShipsInPlayCount() == 0)
				{
					// LNF might have to manually make Imperial attack Lp
					Imperial_ATeam->mClearCommands();
					fMission.mSetTeamRelations (kImperial_ATeam, kLpTeam, kTeamAtWar, kGoalDestroy, 1.0, kTrue);
					if (Neutral_BTeam->mGetShipsInPlayCount() == 0)
					{
						return kPlayerLoses;
					}
				}
			}
			else if (Ship->mGetTeam() == kNeutral_BTeam)
			{
				Neutral_BDestroyed++;
				fMission.mDisplayMessage (kEvent6NeutralDestroyed_msg, kScienceScriptMessage);
				if (Neutral_BTeam->mGetShipsInPlayCount() == 0)
				{
					// LNF might have to manually make Imperial attack Lp
					Imperial_BTeam->mClearCommands();
					fMission.mSetTeamRelations (kImperial_BTeam, kLpTeam, kTeamAtWar, kGoalDestroy, 1.0, kTrue);
					if (Neutral_ATeam->mGetShipsInPlayCount() == 0)
					{
						return kPlayerLoses;
					}
				}
			}
			break;

		case kNotifyDisengaged:
			break;

		case kNotifyPlayerLeaving:
			PlayerUsedESCKey = true;
			break;

		case kNotifyCommButtonPress:
			{
				switch (fEventID)
				{
					case kButtonHail_text:
						if (Ship->mGetTeam() == kImperial_ATeam)
						{
							if (MirrorHostile == 0)
							{
								fMission.mDisplayMessage (kMirrorNe_msg, kMissionScriptMessage);
							}
							else
							{
								fMission.mDisplayMessage (kMirrorEnemyOK_msg, kMissionScriptMessage);
							}
							Ship->mSetCommButton (1, kButtonTaunt_text);
							Ship->mSetCommButton (2, kButtonSurrender_text);
							// If the Taunt or Surrender buttons aren't used in X turns
							// return the buttons to Hail and blank.
							fMission.mSetTimedInterval (kTimerTurnsSet_10, 2);
						}
						else if (Ship->mGetTeam() == kImperial_BTeam)
						{
							if (MirrorHostile == 0)
							{
								fMission.mDisplayMessage (kMirrorNe_msg, kMissionScriptMessage);
							}
							else
							{
								fMission.mDisplayMessage (kMirrorEnemyOK_msg, kMissionScriptMessage);
							}
							Ship->mSetCommButton (1, kButtonTaunt_text);
							Ship->mSetCommButton (2, kButtonSurrender_text);
							// If the Taunt or Surrender buttons aren't used in X turns
							// return the buttons to Hail and blank.
							fMission.mSetTimedInterval (kTimerTurnsSet_9, 2);
						}
						else if ( Ship->mGetTeam() == kNeutral_ATeam )
						{
							if ( Neutral_ATeam->mGetRace() == kKlingon )
							{
								KlingonCommMessages(*this, fEventID, Ship);
							}
							else if ( Neutral_ATeam->mGetRace() == kRomulan )
							{
								RomulanCommMessages(*this, fEventID, Ship);
							}
							else if ( Neutral_ATeam->mGetRace() == kGorn )
							{
								GornCommMessages(*this, fEventID, Ship);
							}

							Ship->mSetCommButton (1, kButtonTaunt_text);
							Ship->mSetCommButton (2, kButtonSurrender_text);
							// If the Taunt or Surrender buttons aren't used in X turns
							// return the buttons to Hail and blank.
							fMission.mSetTimedInterval (kTimerTurnsSet_8, 2);
						}
						else if ( Ship->mGetTeam() == kNeutral_BTeam )
						{
							if ( Neutral_BTeam->mGetRace() == kKlingon )
							{
								KlingonCommMessages(*this, fEventID, Ship);
							}
							else if ( Neutral_BTeam->mGetRace() == kRomulan )
							{
								RomulanCommMessages(*this, fEventID, Ship);
							}
							else if ( Neutral_BTeam->mGetRace() == kGorn )
							{
								GornCommMessages(*this, fEventID, Ship);
							}

							Ship->mSetCommButton (1, kButtonTaunt_text);
							Ship->mSetCommButton (2, kButtonSurrender_text);
							// If the Taunt or Surrender buttons aren't used in X turns
							// return the buttons to Hail and blank.
							fMission.mSetTimedInterval (kTimerTurnsSet_7, 2);
						}
						break;

					case kButtonSurrender_text:
						if (Ship->mGetTeam() == kImperial_ATeam)
						{
							if (MirrorHostile == 0)
							{
								fMission.mDisplayMessage (kMirrorNeSurrender_msg, kMissionScriptMessage);
							}
							else
							{
								fMission.mDisplayMessage (kMirrorSurrenderDamaged_msg, kMissionScriptMessage);
							}
							Ship->mSetCommButton (2, kButtonSurrender_text);
							fMission.mSetTimedInterval (kTimerTurnsSet_10, 2);
						}
						else if (Ship->mGetTeam() == kImperial_BTeam)
						{
							if (MirrorHostile == 0)
							{
								fMission.mDisplayMessage (kMirrorNeSurrender_msg, kMissionScriptMessage);
							}
							else
							{
								fMission.mDisplayMessage (kMirrorSurrenderDamaged_msg, kMissionScriptMessage);
							}
							Ship->mSetCommButton (2, kButtonSurrender_text);
							fMission.mSetTimedInterval (kTimerTurnsSet_9, 2);
						}
						else if ( Ship->mGetTeam() == kNeutral_ATeam )
						{
							if ( Neutral_ATeam->mGetRace() == kKlingon )
							{
								KlingonCommMessages(*this, fEventID, Ship);
							}
							else if ( Neutral_ATeam->mGetRace() == kRomulan )
							{
								RomulanCommMessages(*this, fEventID, Ship);
							}
							else if ( Neutral_ATeam->mGetRace() == kGorn )
							{
								GornCommMessages(*this, fEventID, Ship);
							}
							Ship->mSetCommButton (2, kButtonSurrender_text);
							fMission.mSetTimedInterval (kTimerTurnsSet_10, 2);
						}
						else if ( Ship->mGetTeam() == kNeutral_BTeam )
						{
							if ( Neutral_BTeam->mGetRace() == kKlingon )
							{
								KlingonCommMessages(*this, fEventID, Ship);
							}
							else if ( Neutral_BTeam->mGetRace() == kRomulan )
							{
								RomulanCommMessages(*this, fEventID, Ship);
							}
							else if ( Neutral_BTeam->mGetRace() == kGorn )
							{
								GornCommMessages(*this, fEventID, Ship);
							}
							Ship->mSetCommButton (2, kButtonSurrender_text);
							fMission.mSetTimedInterval (kTimerTurnsSet_10, 2);
						}
						break;

					case kButtonTaunt_text:
						if (Ship->mGetTeam() == kImperial_ATeam)
						{
							if (MirrorHostile == 0)
							{
								fMission.mDisplayMessage (kMirrorNeTaunt_msg, kMissionScriptMessage);
							}
							else
							{
								fMission.mDisplayMessage (fMission.mRandomInt32 (kMirrorIsHostileTauntA_msg, kMirrorIsHostileTauntD_msg), kMissionScriptMessage);
							}
							Ship->mSetCommButton (1, kButtonTaunt_text);
							fMission.mSetTimedInterval (kTimerTurnsSet_10, 2);
						}
						else if (Ship->mGetTeam() == kImperial_BTeam)
						{
							if (MirrorHostile == 0)
							{
								fMission.mDisplayMessage (kMirrorNeTaunt_msg, kMissionScriptMessage);
							}
							else
							{
								fMission.mDisplayMessage (fMission.mRandomInt32 (kMirrorIsHostileTauntA_msg, kMirrorIsHostileTauntD_msg), kMissionScriptMessage);
							}
							Ship->mSetCommButton (1, kButtonTaunt_text);
							fMission.mSetTimedInterval (kTimerTurnsSet_9, 2);
						}
						else if ( Ship->mGetTeam() == kNeutral_ATeam )
						{
							if ( Neutral_ATeam->mGetRace() == kKlingon )
							{
								KlingonCommMessages(*this, fEventID, Ship);
							}
							else if ( Neutral_ATeam->mGetRace() == kRomulan )
							{
								RomulanCommMessages(*this, fEventID, Ship);
							}
							else if ( Neutral_ATeam->mGetRace() == kGorn )
							{
								GornCommMessages(*this, fEventID, Ship);
							}
							Ship->mSetCommButton (1, kButtonTaunt_text);
							fMission.mSetTimedInterval (kTimerTurnsSet_10, 2);
						}
						else if ( Ship->mGetTeam() == kNeutral_BTeam )
						{
							if ( Neutral_BTeam->mGetRace() == kKlingon )
							{
								KlingonCommMessages(*this, fEventID, Ship);
							}
							else if ( Neutral_BTeam->mGetRace() == kRomulan )
							{
								RomulanCommMessages(*this, fEventID, Ship);
							}
							else if ( Neutral_BTeam->mGetRace() == kGorn )
							{
								GornCommMessages(*this, fEventID, Ship);
							}
							Ship->mSetCommButton (1, kButtonTaunt_text);
							fMission.mSetTimedInterval (kTimerTurnsSet_10, 2);
						}
						break;
				}
			}
			break;
	}

	return fMission.mGetGameStatus();
}

//---------------------------------------------------------------------------------------------
// called when mission has ended but before debriefing and only if player is still alive
eVictoryLevels tScript::mCalcVictoryStatus (void)
{
	eVictoryLevels MyVictoryLevel = kDraw;

	int32 VictoryPoints = 0;

	// LNF need to add more victory points here to get to 100 - maybe capture stuff
	VictoryPoints = (Imperial_ADestroyed * 21) + (Imperial_BDestroyed * 21) - (Neutral_ADestroyed * 25) -
					(Neutral_BDestroyed * 25) - (ListeningPostDestroyed * 50) + (ListeningPostScanned * 25);
	
	if (VictoryPoints >= 100)
	{
		MyVictoryLevel = kAstoundingVictory;
	}
	else if ((VictoryPoints <= 99) && (VictoryPoints >= 70))
	{
		MyVictoryLevel = kVictory;
	}
	else if ((VictoryPoints <= 69) && (VictoryPoints >= 50))
	{
		MyVictoryLevel = kDraw;
	}
	else if ((VictoryPoints <= 49) && (VictoryPoints >= 35))
	{
		MyVictoryLevel = kDefeat;
	}
	else if (VictoryPoints <= 34)
	{
		MyVictoryLevel = kDevastatingDefeat;
	}

	// LNF: Add Dynaverse rating adjustments

	return (MyVictoryLevel);
}

//---------------------------------------------------------------------------------------------
// called at end of mission only if player is still alive
void tScript::mGetDebriefingList (eVictoryLevels VictoryLevel)
{
	int32 SuccessCount = 0;
	int32 FailureCount = 0;

	if ( PlayerUsedESCKey == false )
	{
		fMission.mAddToDebriefingList (VictoryLevel + kAstoundingVictory_msg);

		if (VictoryLevel == kAstoundingVictory)
		{
			fMission.mAddToDebriefingList (kVictory2_msg);
			fMission.mAddToDebriefingList (kVictory3_msg);
		}

		if (VictoryLevel < kDraw)
		{
			fMission.mAddToDebriefingList (kDismissedLong_msg);
		}
		else
		{
			fMission.mAddToDebriefingList (kDismissedShort_msg);
		}
	}
	else // player exited improperly, display a message
	{
		fMission.mAddToDebriefingList( kImproperlyExitedMission_msg );
	}

	// LNF try this out:  adding results of primary objectives
	fMission.mAddToDebriefingList( kSuccessfulObjectives_msg );

	( Imperial_ADestroyed != 0 ) ? fMission.mAddToDebriefingList( kImperial_ADestroyedTrue_msg ) : SuccessCount++;
	( Imperial_BDestroyed != 0 ) ? fMission.mAddToDebriefingList( kImperial_BDestroyedTrue_msg ) : SuccessCount++;
	( ListeningPostScanned != 0 ) ? fMission.mAddToDebriefingList( kListeningPostScannedTrue_msg ) : SuccessCount++;
	if ( SuccessCount == 3 )
	{
		fMission.mAddToDebriefingList( kNone_msg );
	}

	fMission.mAddToDebriefingList( kFailedObjectives_msg );

	( Neutral_ADestroyed == 1 ) ? fMission.mAddToDebriefingList( kNeutral_ADestroyedTrue_msg ) : FailureCount++;
	( Neutral_BDestroyed == 1 ) ? fMission.mAddToDebriefingList( kNeutral_BDestroyedTrue_msg ) : FailureCount++;
	( ListeningPostScanned == 0 ) ? fMission.mAddToDebriefingList( kListeningPostScannedFalse_msg ) : FailureCount++;
	( ListeningPostDestroyed != 0 ) ? fMission.mAddToDebriefingList( kListeningPostDestroyedTrue_msg ) : FailureCount++;
	if ( FailureCount == 4 )
	{
		fMission.mAddToDebriefingList( kNone_msg );
	}


	fMission.mScheduleMission( kNextMission_msg );
	// LNF modify the number of spacer missions?
	int32 NumberOfSpacerMissions = fMission.mRandomInt32( 0, 2 );
	switch (NumberOfSpacerMissions)
	{
		case 0:
			break;

		case 1:
			fMission.mScheduleMission( kRandomMission_msg );
			break;
			
		case 2:
			fMission.mScheduleMission( kRandomMission_msg );
			fMission.mScheduleMission( kRandomMission_msg );
			break;
	}
}

//---------------------------------------------------------------------------------------------
// called at the end of every mission
int32 tScript::mGetTechnicalSuccessLevel (tDynaverseScriptInfo& info)
{
	return 0;
}

//---------------------------------------------------------------------------------------------
// Display comm messages for Klingon
void KlingonCommMessages(tScript& tScript, int32 fEventID, tShipInfo* Ship)
{
	tTeamInfo* PlayerTeam = tScript.fMission.mGetTeamHandle (tScript.kPlayerTeam);
	tTeamInfo* Imperial_ATeam = tScript.fMission.mGetTeamHandle (kImperial_ATeam);
	tTeamInfo* Imperial_BTeam = tScript.fMission.mGetTeamHandle (kImperial_BTeam);
	tTeamInfo* Neutral_ATeam = tScript.fMission.mGetTeamHandle (kNeutral_ATeam);
	tTeamInfo* Neutral_BTeam = tScript.fMission.mGetTeamHandle (kNeutral_BTeam);
	tTeamInfo* LpTeam = tScript.fMission.mGetTeamHandle (kLpTeam);
 	
	if ( fEventID == kButtonHail_text )
	{
		if (( MirrorAttackedNeutral == false ) && ( AtWarWithNeutral == false ))
		{
			tScript.fMission.mDisplayMessage(kKlingonNeGoodNotEngaged_msg, kMissionScriptMessage);
		}
		else if (( MirrorAttackedNeutral == true ) && ( AtWarWithNeutral == false ))
		{
			tScript.fMission.mDisplayMessage(kKlingonNeGoodEngaged1_msg, kMissionScriptMessage);
			tScript.fMission.mDisplayMessage(kKlingonNeGoodEngaged2_msg, kMissionScriptMessage);
			tScript.fMission.mDisplayMessage(kKlingonNeGoodEngaged3_msg, kMissionScriptMessage);
			tScript.fMission.mDisplayMessage(kKlingonNeGoodEngaged4_msg, kMissionScriptMessage);
		}
		else
		{
			tScript.fMission.mDisplayMessage(kKlingonNeOK_msg, kMissionScriptMessage);
		}
	}
	else if ( fEventID == kButtonSurrender_text )
	{
		if ( AtWarWithNeutral == false )
		{
			tScript.fMission.mDisplayMessage(kKlingonNeSurrender_msg, kMissionScriptMessage);
			tScript.fMission.mSetTeamRelations (tScript.kPlayerTeam, kNeutral_ATeam, kTeamAtWar, kGoalDestroy, 1.0, kTrue);
			tScript.fMission.mSetTeamRelations (tScript.kPlayerTeam, kNeutral_BTeam, kTeamAtWar, kGoalDestroy, 1.0, kTrue);
		}
		else if ( AtWarWithNeutral == true )
		{
			if ( Ship->mGetDamagePercent() <= kDamageThreshold )
			{
				tScript.fMission.mDisplayMessage(kKlingonNeSurrender_msg, kMissionScriptMessage);
			}
			else
			{
				tScript.fMission.mDisplayMessage(kKlingonNeSurrender_msg, kMissionScriptMessage);
			}
		}
	}
	else if ( fEventID == kButtonTaunt_text )
	{
		if ( AtWarWithNeutral == true )
		{
			tScript.fMission.mDisplayMessage (tScript.fMission.mRandomInt32 (kKlingonTaunt1_msg, kKlingonTaunt3_msg), kMissionScriptMessage);
		}
	}
}

//---------------------------------------------------------------------------------------------
// Display comm messages for Romulan
void RomulanCommMessages(tScript& tScript, int32 fEventID, tShipInfo* Ship)
{
	tTeamInfo* PlayerTeam = tScript.fMission.mGetTeamHandle (tScript.kPlayerTeam);
	tTeamInfo* Imperial_ATeam = tScript.fMission.mGetTeamHandle (kImperial_ATeam);
	tTeamInfo* Imperial_BTeam = tScript.fMission.mGetTeamHandle (kImperial_BTeam);
	tTeamInfo* Neutral_ATeam = tScript.fMission.mGetTeamHandle (kNeutral_ATeam);
	tTeamInfo* Neutral_BTeam = tScript.fMission.mGetTeamHandle (kNeutral_BTeam);
	tTeamInfo* LpTeam = tScript.fMission.mGetTeamHandle (kLpTeam);

	if ( fEventID == kButtonHail_text )
	{
		if (( MirrorAttackedNeutral == false ) && ( AtWarWithNeutral == false ))
		{
			tScript.fMission.mDisplayMessage(kRomulanNeGoodNotEngagedHailTaunt_msg, kMissionScriptMessage);
		}
		else if (( MirrorAttackedNeutral == true ) && ( AtWarWithNeutral == false ))
		{
			tScript.fMission.mDisplayMessage(kRomulanNeGoodEngagedHailTaunt1_msg, kMissionScriptMessage);
			tScript.fMission.mDisplayMessage(kRomulanNeGoodEngagedHailTaunt2_msg, kMissionScriptMessage);
		}
		else
		{
			tScript.fMission.mDisplayMessage(kRomulanPoorHailTaunt_msg, kMissionScriptMessage);
		}
	}
	else if ( fEventID == kButtonSurrender_text )
	{
		if ( AtWarWithNeutral == false )
		{
			tScript.fMission.mDisplayMessage(kRomulanPoorHailTaunt_msg, kMissionScriptMessage);
			tScript.fMission.mSetTeamRelations (tScript.kPlayerTeam, kNeutral_ATeam, kTeamAtWar, kGoalDestroy, 1.0, kTrue);
			tScript.fMission.mSetTeamRelations (tScript.kPlayerTeam, kNeutral_BTeam, kTeamAtWar, kGoalDestroy, 1.0, kTrue);
		}
		else if ( AtWarWithNeutral == true )
		{
			tScript.fMission.mDisplayMessage(kRomulanTaunt1_msg, kMissionScriptMessage);
		}
	}
	else if ( fEventID == kButtonTaunt_text )
	{
		if ( AtWarWithNeutral == true )
		{
			tScript.fMission.mDisplayMessage (tScript.fMission.mRandomInt32 (kRomulanTaunt2_msg, kRomulanTaunt4_msg), kMissionScriptMessage);
		}
	}
}

//---------------------------------------------------------------------------------------------
// Display comm messages for Gorn
void GornCommMessages(tScript& tScript, int32 fEventID, tShipInfo* Ship)
{
	tTeamInfo* PlayerTeam = tScript.fMission.mGetTeamHandle (tScript.kPlayerTeam);
	tTeamInfo* Imperial_ATeam = tScript.fMission.mGetTeamHandle (kImperial_ATeam);
	tTeamInfo* Imperial_BTeam = tScript.fMission.mGetTeamHandle (kImperial_BTeam);
	tTeamInfo* Neutral_ATeam = tScript.fMission.mGetTeamHandle (kNeutral_ATeam);
	tTeamInfo* Neutral_BTeam = tScript.fMission.mGetTeamHandle (kNeutral_BTeam);
	tTeamInfo* LpTeam = tScript.fMission.mGetTeamHandle (kLpTeam);

	if ( fEventID == kButtonHail_text )
	{
		if (( MirrorAttackedNeutral == false ) && ( AtWarWithNeutral == false ))
		{
			tScript.fMission.mDisplayMessage(kGornNeGoodNotEngaged_msg, kMissionScriptMessage);
		}
		else if (( MirrorAttackedNeutral == true ) && ( AtWarWithNeutral == false ))
		{
			tScript.fMission.mDisplayMessage(kGornNeGoodEngaged1_msg, kMissionScriptMessage);
			tScript.fMission.mDisplayMessage(kGornNeGoodEngaged2_msg, kMissionScriptMessage);
		}
		else
		{
			tScript.fMission.mDisplayMessage(kGornNeOK_msg, kMissionScriptMessage);
		}
	}
	else if ( fEventID == kButtonSurrender_text )
	{
		tScript.fMission.mDisplayMessage(kGornSurrender_msg, kMissionScriptMessage);
	}
	else if ( fEventID == kButtonTaunt_text )
	{
		if ( AtWarWithNeutral == false )
		{
			tScript.fMission.mDisplayMessage(kGornNeTaunt_msg, kMissionScriptMessage);
		}
		else
		{
			tScript.fMission.mDisplayMessage (tScript.fMission.mRandomInt32 (kRomulanTaunt2_msg, kRomulanTaunt4_msg), kMissionScriptMessage);
		}
	}
}

//---------------------------------------------------------------------------------------------
// make the ships patrol
void setPatrolRoute(tScript& tScript, tTeamInfo* patrolRouteTeam)
{
	tTeamInfo* Neutral_ATeam = tScript.fMission.mGetTeamHandle (kNeutral_ATeam);
	tTeamInfo* Neutral_BTeam = tScript.fMission.mGetTeamHandle (kNeutral_BTeam);

	tMapPoint waypoints_1[6]= // Ship J
	{
		29, 26,
		30, 25,
		30, 28,
		27, 29,
		26, 26,
		28, 24
	};

	tMapPoint waypoints_2[6]= // Ship K
	{
		6, 7,
		8, 10,
		12, 11,
		15, 10,
		16, 6,
		11, 4
	};

	tMapPoint PatrolPoints[10];

	if ( patrolRouteTeam == Neutral_ATeam )
	{
		PatrolPoints[0] = waypoints_1[0];
		PatrolPoints[1] = waypoints_1[1];
		PatrolPoints[2] = waypoints_1[2];
		PatrolPoints[3] = waypoints_1[3];
		PatrolPoints[4] = waypoints_1[4];
		PatrolPoints[5] = waypoints_1[5];
		patrolRouteTeam->mGetThisShip( 1 )->mPatrol( kPatrolRadius, 6, &PatrolPoints[0], kHighPriority );
	}
	else if ( patrolRouteTeam == Neutral_BTeam )
	{
		PatrolPoints[0] = waypoints_2[0];
		PatrolPoints[1] = waypoints_2[1];
		PatrolPoints[2] = waypoints_2[2];
		PatrolPoints[3] = waypoints_2[3];
		PatrolPoints[4] = waypoints_2[4];
		PatrolPoints[5] = waypoints_2[5];
		patrolRouteTeam->mGetThisShip( 1 )->mPatrol( kPatrolRadius, 6, &PatrolPoints[0], kHighPriority );
	}
}

//---------------------------------------------------------------------------------------------
// randomize the ship class for the computer ships
eClassTypes NewEnemyShipClass( tScript& tScript, eClassTypes LargestEnemyShipClass )
{
/*
	kClassShuttle = 0,				// smallest hull size
	kClassFreighter,
	kClassFrigate,
	kClassDestroyer,
	kClassWarDestroyer,
	kClassLightCruiser,
	kClassNewHeavyCruiser,
	kClassHeavyCruiser,
	kClassHeavyBattlecruiser,
	kClassDreadnought,
	kClassBattleship,				// largest hull size
*/
	int32 RandomNum = tScript.fMission.mRandomInt32(1, 100);
	
	// 70% use whatever the difficulty level sets
	// 15% use a class size smaller
	// 10% use 2 class sizes smaller
	// 5% use a class size larger
	if ( RandomNum > 70 )
	{
		return LargestEnemyShipClass;
	}
	else if (( RandomNum < 30 ) && ( RandomNum >= 15 ))
	{
		LargestEnemyShipClass = (eClassTypes) ( (int32)LargestEnemyShipClass - 1 );

		if ( LargestEnemyShipClass > kClassFrigate )
		{
			return LargestEnemyShipClass;
		}
		else
		{
			return kClassFrigate;
		}
	}
	else if (( RandomNum < 15 ) && ( RandomNum >= 5 ))
	{
		LargestEnemyShipClass = (eClassTypes) ( (int32)LargestEnemyShipClass - 2 );

		if ( LargestEnemyShipClass > kClassFrigate )
		{
			return LargestEnemyShipClass;
		}
		else
		{
			return kClassFrigate;
		}
	}
	else// if (( RandomNum < 5 ) && ( RandomNum >= 1 ))
	{
		LargestEnemyShipClass = (eClassTypes) ( (int32)LargestEnemyShipClass + 1 );

		if ( LargestEnemyShipClass > kClassBattleship )
		{
			return kClassBattleship;
		}
		else
		{
			return LargestEnemyShipClass;
		}
	}
}
