#include "Gor_5EggDefender.h"

tEggDefender::tEggDefender( eTeamTypes errant, eTeamTypes kingsGuard, eTeamID playerTeam )
{
	fErrantTeam = errant;
	fKingsGuardTeam = kingsGuard;
	fPlayerTeam = playerTeam;
}

void tEggDefender::mCreateShips( tTeamInfo* errantTeam, tTeamInfo* kingsGuardTeam, int32 shipBPV, eClassTypes LargestEnemyShipClass )
{
	// LNF should I make this dependent on how many ships the player has?

	errantTeam->mCreateShip( shipBPV, kClassFrigate, LargestEnemyShipClass, 0, kStartPosition_J );
	errantTeam->mCreateShip( shipBPV, kClassFrigate, LargestEnemyShipClass, 0, kStartPosition_K );

	kingsGuardTeam->mCreateShip( shipBPV, kClassDestroyer, LargestEnemyShipClass, 0, kStartPosition_M );
	kingsGuardTeam->mCreateShip( shipBPV, kClassDestroyer, LargestEnemyShipClass, 0, kStartPosition_N );
}

void tEggDefender::mSetUpShips( tScript& tScript, tShipInfo* ship )
{
	ship->mSetCommButton (1, kButtonHail_text);
	ship->mSetShipCallbackEvents( kNotifyDamage );
	if ( ship->mGetTeam() == fErrantTeam )
	{
		ship->mChangeName( kErrant_name );
	}
	else
	{
		ship->mChangeName( kKingsGuard_name );
	}
}

int32 tEggDefender::mInitializeFinished()
{
	return kEggDefenderBriefing_msg;
}

void tEggDefender::mSetAllTeamRelations( tMissionInfo& mission )
{
	mission.mSetTeamRelations( fPlayerTeam, kOrionMeetTeam, kTeamHostile, kGoalDestroy, 1.0, kTrue );
	mission.mSetTeamRelations( fPlayerTeam, fErrantTeam, kTeamHostile, kGoalDestroy, 1.0, kTrue );
	mission.mSetTeamRelations( fPlayerTeam, fKingsGuardTeam, kTeamHostile, kGoalDestroy, 1.0, kTrue );
	mission.mSetTeamRelations( fPlayerTeam, kOrionPatrolTeam, kTeamHostile, kGoalDestroy, 1.0, kTrue );
	mission.mSetTeamRelations( fPlayerTeam, kOrionCommandTeam, kTeamHostile, kGoalDestroy, 1.0, kTrue );

	mission.mSetTeamRelations( kOrionMeetTeam, fErrantTeam, kTeamHostile, kGoalDestroy, 1.0, kTrue );
	mission.mSetTeamRelations( kOrionMeetTeam, fKingsGuardTeam, kTeamHostile, kGoalDestroy, 1.0, kTrue );
	mission.mSetTeamRelations( kOrionMeetTeam, kOrionPatrolTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue );
	mission.mSetTeamRelations( kOrionMeetTeam, kOrionCommandTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue );

	mission.mSetTeamRelations( fErrantTeam, fKingsGuardTeam, kTeamHostile, kGoalDestroy, 1.0, kTrue );
	mission.mSetTeamRelations( fErrantTeam, kOrionPatrolTeam, kTeamHostile, kGoalDestroy, 1.0, kTrue );
	mission.mSetTeamRelations( fErrantTeam, kOrionCommandTeam, kTeamHostile, kGoalDestroy, 1.0, kTrue );

	mission.mSetTeamRelations( fKingsGuardTeam, kOrionPatrolTeam, kTeamHostile, kGoalDestroy, 1.0, kTrue );
	mission.mSetTeamRelations( fKingsGuardTeam, kOrionCommandTeam, kTeamHostile, kGoalDestroy, 1.0, kTrue );

	mission.mSetTeamRelations( kOrionPatrolTeam, kOrionCommandTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue );
}

void tEggDefender::mCaptureHolyMother( tScript& tScript, tTeamInfo* ErrantTeam, tTeamInfo* KingsGuardTeam )
{
	KingsGuardTeam->mClearCommands();
	tScript.fMission.mSetTeamRelations( fKingsGuardTeam, kOrionCommandTeam, kTeamAtWar, kGoalDestroy, 1.0, kTrue );
	tScript.fMission.mSetTeamRelations( fKingsGuardTeam, kOrionMeetTeam, kTeamAtWar, kGoalIgnore, 1.0 );
	tScript.fMission.mSetTeamRelations( fErrantTeam, kOrionCommandTeam, kTeamAtWar, kGoalDestroy, 1.0, kTrue );
	tScript.fMission.mSetTeamRelations( fErrantTeam, kOrionMeetTeam, kTeamAtWar, kGoalIgnore, 1.0 );
}

void tEggDefender::mHailMessage( tScript& tScript, tTeamInfo* hailedTeam )
{
	if ( hailedTeam->mGetTeam() == fErrantTeam )
	{
		if ( fOrionAttemptCapture == false )
		{
			if ( fAtWarWith[ kAWGorn_1Team ] == false )
			{ 
				tScript.fMission.mDisplayMessage( kErrantHailNoTreachery_msg, kMissionScriptMessage );
			}
			else
			{
				tScript.fMission.mDisplayMessage( kErrantHailEnemy_msg, kMissionScriptMessage );
			}
		}
		else
		{
			if ( fAtWarWith[ kAWGorn_1Team ] == false )
			{
				tScript.fMission.mDisplayMessage( kErrantHailTreachery_msg, kMissionScriptMessage );
			}
			else
			{
				tScript.fMission.mDisplayMessage( kErrantHailEnemy_msg, kMissionScriptMessage );
			}
		}
	}
	else // kingsGuard
	{
		if ( fAtWarWith[ kAWGorn_2Team ] == false )
		{
			tScript.fMission.mDisplayMessage( kKingHailNotEnemy_msg, kMissionScriptMessage );
		}
		else
		{
			tScript.fMission.mDisplayMessage( kKingHailEnemy_msg, kMissionScriptMessage );
		}
	}
}

void tEggDefender::mTauntMessage( tScript& tScript, tTeamInfo* hailedTeam )
{
	if ( hailedTeam->mGetTeam() == fErrantTeam )
	{
		tScript.fMission.mDisplayMessage( tScript.fMission.mRandomInt32( kErrantTaunt_1_msg, kErrantTaunt_4_msg ), kMissionScriptMessage );
	}
	else
	{
		tScript.fMission.mDisplayMessage( tScript.fMission.mRandomInt32( kKingTaunt_1_msg, kKingTaunt_4_msg ), kMissionScriptMessage );
	}
}

void tEggDefender::mSurrenderMessage( tScript& tScript, tTeamInfo* hailedTeam )
{
	if ( hailedTeam->mGetTeam() == fErrantTeam )
	{
		if ( fAtWarWith[ kAWGorn_1Team ] == false )
		{
			tScript.fMission.mDisplayMessage( kErrantSurrenderNotEnemy_msg, kMissionScriptMessage );
		}
		else
		{
			tScript.fMission.mDisplayMessage( kErrantSurrenderOK_msg, kMissionScriptMessage );
		}
	}
	else // kingsGuard
	{
		if ( fAtWarWith[ kAWGorn_2Team ] == false )
		{
			tScript.fMission.mDisplayMessage( kKingSurrenderNotEnemy_msg, kMissionScriptMessage );
		}
		else
		{
			tScript.fMission.mDisplayMessage( kKingSurrenderOK_msg, kMissionScriptMessage );
		}
	}
}

void tEggDefender::mEggDetection( tScript& tScript )
{
}

void tEggDefender::mErrantPatrol( tScript& tScript )
{
	const float kPatrolAttackRadius = 20.0f;

	tMapPoint waypoints_1[7]=
	{
		12, 5,
		17, 6,
		17, 10,
		13, 12,
		11, 16,
		8, 11,
		8, 6
	};

	tMapPoint PatrolPoints[10];

	for (tShipInfo* Ship = tScript.fMission.mGetTeamHandle(fErrantTeam)->mGetFirstShip(); Ship != NULL; Ship = tScript.fMission.mGetTeamHandle(fErrantTeam)->mGetNextShip())
	{
		PatrolPoints[0] = waypoints_1[0];
		PatrolPoints[1] = waypoints_1[1];
		PatrolPoints[2] = waypoints_1[2];
		PatrolPoints[3] = waypoints_1[3];
		PatrolPoints[4] = waypoints_1[4];
		PatrolPoints[5] = waypoints_1[5];
		PatrolPoints[6] = waypoints_1[6];
		Ship->mPatrol( kPatrolAttackRadius, 7, &PatrolPoints[0], kVeryHighPriority );
	}
}

void tEggDefender::mDamageOrionCommand( tScript& tScript, eTeamTypes HostileTeam )
{
}

void tEggDefender::mEggDefenderPatrol( tScript& tScript )
{
}

void tEggDefender::mKingsGuardPatrol( tScript& tScript )
{
	const float kPatrolAttackRadius = 1.0f;
	const int32 kShipMaxSpeed = 12;

	tMapPoint waypoints_1[9]=
	{
		8, 27,
		14, 22,
		20, 20,
		24, 14,
		19, 10,
		11, 13,
		19, 10,
		24, 14,
		20, 20
	};

	tMapPoint PatrolPoints[10];

	for (tShipInfo* Ship = tScript.fMission.mGetTeamHandle(fKingsGuardTeam)->mGetFirstShip(); Ship != NULL; Ship = tScript.fMission.mGetTeamHandle(fKingsGuardTeam)->mGetNextShip())
	{
		PatrolPoints[0] = waypoints_1[0];
		PatrolPoints[1] = waypoints_1[1];
		PatrolPoints[2] = waypoints_1[2];
		PatrolPoints[3] = waypoints_1[3];
		PatrolPoints[4] = waypoints_1[4];
		PatrolPoints[5] = waypoints_1[5];
		PatrolPoints[6] = waypoints_1[6];
		PatrolPoints[7] = waypoints_1[7];
		PatrolPoints[8] = waypoints_1[8];
		Ship->mPatrol( kPatrolAttackRadius, 9, &PatrolPoints[0], kVeryHighPriority );
	}
}

void tEggDefender::mAtWarWithFaction( tScript& tScript )
{
}

