#include "Gor_5Errant.h"

tErrant::tErrant( eTeamTypes eggDefender, eTeamTypes kingsGuard, eTeamID playerTeam )
{
	fEggDefenderTeam = eggDefender;
	fKingsGuardTeam = kingsGuard;
	fPlayerTeam = playerTeam;
}

void tErrant::mCreateShips( tTeamInfo* eggDefenderTeam, tTeamInfo* kingsGuardTeam, int32 shipBPV, eClassTypes LargestEnemyShipClass )
{
	// LNF should I make this dependent on how many ships the player has?

	eggDefenderTeam->mCreateShip( shipBPV, kClassFrigate, LargestEnemyShipClass, 0, kStartPosition_M );
	eggDefenderTeam->mCreateShip( shipBPV, kClassFrigate, LargestEnemyShipClass, 0, kStartPosition_N );

	kingsGuardTeam->mCreateShip( shipBPV, kClassDestroyer, LargestEnemyShipClass, 0, kStartPosition_J );
	kingsGuardTeam->mCreateShip( shipBPV, kClassDestroyer, LargestEnemyShipClass, 0, kStartPosition_K );
}

void tErrant::mSetUpShips( tScript& tScript, tShipInfo* ship )
{
	tTeamInfo* OrionCommandTeam = tScript.fMission.mGetTeamHandle (kOrionCommandTeam);

	ship->mSetCommButton (1, kButtonHail_text);
	ship->mSetShipCallbackEvents( kNotifyDamage );

	if ( ship->mGetTeam() == fKingsGuardTeam )
	{
		ship->mChangeName( kKingsGuard_name );
		//ship->mFollowEntity( OrionCommandTeam->mGetFirstShip(), kVeryHighPriority );
		//ship->mDefendEntity( OrionCommandTeam->mGetFirstShip(), 5.0, 5.0, kVeryHighPriority );
	}
	else
	{
		ship->mChangeName( kEggDefender_name );
	}
}

int32 tErrant::mInitializeFinished()
{
	return kErrantBriefing_msg;
}

void tErrant::mSetAllTeamRelations( tMissionInfo& mission )
{
	mission.mSetTeamRelations( fPlayerTeam, kOrionMeetTeam, kTeamHostile, kGoalDestroy, 1.0, kTrue );
	mission.mSetTeamRelations( fPlayerTeam, fEggDefenderTeam, kTeamHostile, kGoalDestroy, 1.0, kTrue );
	mission.mSetTeamRelations( fPlayerTeam, fKingsGuardTeam, kTeamHostile, kGoalDestroy, 1.0, kTrue );
	mission.mSetTeamRelations( fPlayerTeam, kOrionPatrolTeam, kTeamHostile, kGoalDestroy, 1.0, kTrue );
	mission.mSetTeamRelations( fPlayerTeam, kOrionCommandTeam, kTeamHostile, kGoalDestroy, 1.0, kTrue );

	mission.mSetTeamRelations( kOrionMeetTeam, fEggDefenderTeam, kTeamHostile, kGoalDestroy, 1.0, kTrue );
	mission.mSetTeamRelations( kOrionMeetTeam, fKingsGuardTeam, kTeamHostile, kGoalDestroy, 1.0, kTrue );
	mission.mSetTeamRelations( kOrionMeetTeam, kOrionPatrolTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue );
	mission.mSetTeamRelations( kOrionMeetTeam, kOrionCommandTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue );

	mission.mSetTeamRelations( fEggDefenderTeam, fKingsGuardTeam, kTeamHostile, kGoalDestroy, 1.0, kTrue );
	mission.mSetTeamRelations( fEggDefenderTeam, kOrionPatrolTeam, kTeamHostile, kGoalDestroy, 1.0, kTrue );
	mission.mSetTeamRelations( fEggDefenderTeam, kOrionCommandTeam, kTeamHostile, kGoalDestroy, 1.0, kTrue );

	mission.mSetTeamRelations( fKingsGuardTeam, kOrionPatrolTeam, kTeamHostile, kGoalDestroy, 1.0, kTrue );
	mission.mSetTeamRelations( fKingsGuardTeam, kOrionCommandTeam, kTeamHostile, kGoalDestroy, 1.0, kTrue );

	mission.mSetTeamRelations( kOrionPatrolTeam, kOrionCommandTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue );
}

void tErrant::mCaptureHolyMother( tScript& tScript, tTeamInfo* EggDefenderTeam, tTeamInfo* KingsGuardTeam )
{
	KingsGuardTeam->mClearCommands();
	tScript.fMission.mSetTeamRelations( fKingsGuardTeam, kOrionCommandTeam, kTeamAtWar, kGoalDestroy, 1.0, kTrue );
	tScript.fMission.mSetTeamRelations( fKingsGuardTeam, kOrionMeetTeam, kTeamAtWar, kGoalIgnore, 1.0 );
	tScript.fMission.mSetTeamRelations( fEggDefenderTeam, kOrionCommandTeam, kTeamAtWar, kGoalDestroy, 1.0, kTrue );
	tScript.fMission.mSetTeamRelations( fEggDefenderTeam, kOrionMeetTeam, kTeamAtWar, kGoalIgnore, 1.0 );

	// LNF if either the Egg Defender or Kings Guard team disables the Orion command, they should get the Holy Mother back
}

void tErrant::mHailMessage( tScript& tScript, tTeamInfo* hailedTeam )
{
	if ( hailedTeam->mGetTeam() == fEggDefenderTeam )
	{
		if ( fOrionAttemptCapture == false )
		{
			if ( fAtWarWith[ kAWGorn_1Team ] == false )			{
				tScript.fMission.mDisplayMessage( kEggHailNoTreachery_msg, kMissionScriptMessage );
			}
			else
			{
				tScript.fMission.mDisplayMessage( kEggHailEnemy_msg, kMissionScriptMessage );
			}
		}
		else
		{
			if ( fAtWarWith[ kAWGorn_1Team ] == false )
			{
				tScript.fMission.mDisplayMessage( kEggHailTreachery_msg, kMissionScriptMessage );
			}
			else
			{
				tScript.fMission.mDisplayMessage( kEggHailEnemy_msg, kMissionScriptMessage );
			}
		}
	}
	else // kingsGuard
	{
		if ( fAtWarWith[ kAWGorn_2Team ] == false )
		{
			tScript.fMission.mDisplayMessage( kKingHailNotEnemy_msg, kMissionScriptMessage );
		}
		else
		{
			tScript.fMission.mDisplayMessage( kKingHailEnemy_msg, kMissionScriptMessage );
		}
	}
}

void tErrant::mTauntMessage( tScript& tScript, tTeamInfo* hailedTeam )
{
	if ( hailedTeam->mGetTeam() == fEggDefenderTeam )
	{
		tScript.fMission.mDisplayMessage( tScript.fMission.mRandomInt32( kEggTaunt_1_msg, kEggTaunt_4_msg ), kMissionScriptMessage );
	}
	else
	{
		tScript.fMission.mDisplayMessage( tScript.fMission.mRandomInt32( kKingTaunt_1_msg, kKingTaunt_4_msg ), kMissionScriptMessage );
	}
}

void tErrant::mSurrenderMessage( tScript& tScript, tTeamInfo* hailedTeam )
{
	if ( hailedTeam->mGetTeam() == fEggDefenderTeam )
	{
		if ( fAtWarWith[ kAWGorn_1Team ] == false )
		{
			tScript.fMission.mDisplayMessage( kEggSurrenderNotEnemy_msg, kMissionScriptMessage );
		}
		else
		{
			tScript.fMission.mDisplayMessage( kEggSurrenderOK_msg, kMissionScriptMessage );
		}
	}
	else // kingsGuard
	{
		if ( fAtWarWith[ kAWGorn_2Team ] == false )
		{
			tScript.fMission.mDisplayMessage( kKingSurrenderNotEnemy_msg, kMissionScriptMessage );
		}
		else
		{
			tScript.fMission.mDisplayMessage( kKingSurrenderOK_msg, kMissionScriptMessage );
		}
	}
}

void tErrant::mEggDetection( tScript& tScript )
{
	tScript.fMission.mSetTeamRelations( fPlayerTeam, fEggDefenderTeam, kTeamHostile, kGoalDestroy, 1.0 );
	tScript.fMission.mSetTeamRelations( fEggDefenderTeam, fPlayerTeam, kTeamAtWar, kGoalDestroy, 1.0 );
}

void tErrant::mErrantPatrol( tScript& tScript )
{
}

void tErrant::mDamageOrionCommand( tScript& tScript, eTeamTypes HostileTeam )
{
	// determine who/if the Holy Mother is re-captured
	if ( HostileTeam == fKingsGuardTeam )
	{
		tScript.fMission.mDisplayMessage( kKingsGuard_msg, kMissionScriptMessage );
	}
}

void tErrant::mEggDefenderPatrol( tScript& tScript )
{
	const float kPatrolAttackRadius = 1.0f;
	const int32 kShipMaxSpeed = 12;

	tMapPoint waypoints_1[5]=
	{
		17, 14,
		14, 16,
		15, 12,
		20, 14,
		23, 14
	};

	tMapPoint PatrolPoints[10];

	for (tShipInfo* Ship = tScript.fMission.mGetTeamHandle(fEggDefenderTeam)->mGetFirstShip(); Ship != NULL; Ship = tScript.fMission.mGetTeamHandle(fEggDefenderTeam)->mGetNextShip())
	{
		PatrolPoints[0] = waypoints_1[0];
		PatrolPoints[1] = waypoints_1[1];
		PatrolPoints[2] = waypoints_1[2];
		PatrolPoints[3] = waypoints_1[3];
		PatrolPoints[4] = waypoints_1[4];
		Ship->mPatrol( kPatrolAttackRadius, 5, &PatrolPoints[0], kVeryHighPriority );

		Ship->mSetShipMaxSpeed( kShipMaxSpeed );
	}
}

void tErrant::mKingsGuardPatrol( tScript& tScript )
{
	const float kPatrolAttackRadius = 1.0f;
	const int32 kShipMaxSpeed = 12;

	tMapPoint waypoints_1[9]=
	{
		8, 27,
		14, 22,
		20, 20,
		24, 14,
		19, 10,
		11, 13,
		19, 10,
		24, 14,
		20, 20
	};

	tMapPoint PatrolPoints[10];

	for (tShipInfo* Ship = tScript.fMission.mGetTeamHandle(fKingsGuardTeam)->mGetFirstShip(); Ship != NULL; Ship = tScript.fMission.mGetTeamHandle(fKingsGuardTeam)->mGetNextShip())
	{
		PatrolPoints[0] = waypoints_1[0];
		PatrolPoints[1] = waypoints_1[1];
		PatrolPoints[2] = waypoints_1[2];
		PatrolPoints[3] = waypoints_1[3];
		PatrolPoints[4] = waypoints_1[4];
		PatrolPoints[5] = waypoints_1[5];
		PatrolPoints[6] = waypoints_1[6];
		PatrolPoints[7] = waypoints_1[7];
		PatrolPoints[8] = waypoints_1[8];
		Ship->mPatrol( kPatrolAttackRadius, 9, &PatrolPoints[0], kVeryHighPriority );
	}
}

void tErrant::mAtWarWithFaction( tScript& tScript )
{
}
