#if !defined( Gor_5FactionScript_h )
#define Gor_5FactionScript_h

#include "scriptinterface.h"

#include "Gor_5MissionText.h"

enum eMissionMode
{
	kStart = 0,
	kInitialShips
};

enum eTeamTypes
{
	// the first 6 team types are reserved for player teams.
	kReserved = kTeam6,

	// add all non-player teams (enemy, allied, monsters, etc...) after this point.

	kOrionMeetTeam, 
	kGorn_1Team, // one of the other factions
	kGorn_2Team, // one of the other factions
	kOrionPatrolTeam,
	kOrionCommandTeam,
};

enum eAtWarWithTeam
{
	kAWOrionMeetTeam = 0,
	kAWGorn_1Team,
	kAWGorn_2Team,
	kAWOrionPatrolTeam,
	kAWOrionCommandTeam,

	kAWMaxTeam
};

enum eHolyMotherStatus
{
	kOnPlanet = 0,
	kOnOrionCommand,
	kOnKingsGuard,
	kDead
};

class tGornFactionScript
{
public:
	tGornFactionScript();

	virtual void mCreateShips( tTeamInfo* team1Info, tTeamInfo* team2Info, int32 lowBPV, eClassTypes LargestEnemyShipClass ) = 0;
	virtual void mSetUpShips( tScript& tScript, tShipInfo* setUpThisShip ) = 0;
	virtual int32 mInitializeFinished() = 0;
	virtual void mSetAllTeamRelations( tMissionInfo& mission ) = 0;
	virtual void mCaptureHolyMother( tScript& tScript, tTeamInfo* team1Info, tTeamInfo* team2Info ) = 0;
	virtual void mHailMessage( tScript& tScript, tTeamInfo* teamXInfo ) = 0;
	virtual void mTauntMessage( tScript& tScript, tTeamInfo* teamXInfo ) = 0;
	virtual void mSurrenderMessage( tScript& tScript, tTeamInfo* teamXInfo ) = 0;
	virtual void mEggDetection( tScript& tScript ) = 0;
	virtual void mErrantPatrol( tScript& tScript ) = 0;
	virtual void mDamageOrionCommand( tScript& tScript, eTeamTypes HostileTeam ) = 0;
	virtual void mEggDefenderPatrol( tScript& tScript ) = 0;
	virtual void mKingsGuardPatrol( tScript& tScript ) = 0;
	virtual void mAtWarWithFaction( tScript& tScript ) = 0;

	bool fAtWarWith[kAWMaxTeam];
	bool fOrionAttemptCapture;
	eHolyMotherStatus fHolyMotherStatus;
};

#endif