#include "Gor_6EggDefender.h"

tEggDefender::tEggDefender( eTeamTypes errant, eTeamTypes kingsGuard, eTeamID playerTeam )
{
	fErrantTeam = errant;
	fKingsGuardTeam = kingsGuard;
	fPlayerTeam = playerTeam;
}

void tEggDefender::mCreateShips( tTeamInfo* errantTeam, tTeamInfo* kingsGuardTeam, int32 lowBPV )
{
	errantTeam->mCreateShip( lowBPV, kClassFrigate, kClassDreadnought, 100, kStartPosition_X );

	kingsGuardTeam->mCreateShip( lowBPV, kClassDestroyer, kClassDreadnought, 100, kStartPosition_U );
}

int32 tEggDefender::mInitializeFinished()
{
	return kEggDefenderBriefing_msg;
}

void tEggDefender::mSetUpShips( tScript& tScript, tShipInfo* ship )
{
	ship->mSetCommButton (1, kButtonHail_text);
	ship->mSetShipCallbackEvents( kNotifyDamage );

	if ( ship->mGetTeam() == fErrantTeam )
	{
		ship->mChangeName( kErrant_name );
	}
	else
	{
		ship->mChangeName( kKingsGuard_name );
	}
}

void tEggDefender::mSetAllTeamRelations( tMissionInfo& mission )
{
	mission.mSetTeamRelations( fPlayerTeam, kShipyardTeam, kTeamHostile, kGoalDestroy, 1.0 );//***
	mission.mSetTeamRelations( fPlayerTeam, fErrantTeam, kTeamHostile, kGoalDestroy, 1.0, kTrue );
	mission.mSetTeamRelations( fPlayerTeam, fKingsGuardTeam, kTeamNeutral, kGoalDestroy, 1.0 );//***
	mission.mSetTeamRelations( fPlayerTeam, kRepairingTeam, kTeamHostile, kGoalDestroy, 1.0, kTrue );
	mission.mSetTeamRelations( fPlayerTeam, kMysteryTeam, kTeamHostile, kGoalDestroy, 1.0, kTrue );
	mission.mSetTeamRelations( fPlayerTeam, kPlanetTeam, kTeamNeutral, kGoalDestroy, 1.0, kTrue );

	mission.mSetTeamRelations( kShipyardTeam, fPlayerTeam, kTeamNeutral, kGoalIgnore, 1.0 );//***
	mission.mSetTeamRelations( kShipyardTeam, fErrantTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue );
	mission.mSetTeamRelations( kShipyardTeam, fKingsGuardTeam, kTeamAtWar, kGoalDestroy, 1.0, kTrue );
	mission.mSetTeamRelations( kShipyardTeam, kRepairingTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue );
	mission.mSetTeamRelations( kShipyardTeam, kMysteryTeam, kTeamNeutral, kGoalIgnore, 1.0, kTrue );
	mission.mSetTeamRelations( kShipyardTeam, kPlanetTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue );

	mission.mSetTeamRelations( fErrantTeam, fKingsGuardTeam, kTeamHostile, kGoalDestroy, 1.0, kTrue );
	mission.mSetTeamRelations( fErrantTeam, kRepairingTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue );
	mission.mSetTeamRelations( fErrantTeam, kMysteryTeam, kTeamNeutral, kGoalIgnore, 1.0, kTrue );
	mission.mSetTeamRelations( fErrantTeam, kPlanetTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue );

	mission.mSetTeamRelations( fKingsGuardTeam, fPlayerTeam, kTeamHostile, kGoalDestroy, 1.0 );//***
	mission.mSetTeamRelations( fKingsGuardTeam, kRepairingTeam, kTeamAtWar, kGoalDestroy, 1.0, kTrue );
	mission.mSetTeamRelations( fKingsGuardTeam, kMysteryTeam, kTeamNeutral, kGoalIgnore, 1.0, kTrue );
	mission.mSetTeamRelations( fKingsGuardTeam, kPlanetTeam, kTeamNeutral, kGoalIgnore, 1.0, kTrue );

	mission.mSetTeamRelations( kRepairingTeam, kMysteryTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue );
	mission.mSetTeamRelations( kRepairingTeam, kPlanetTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue );

	mission.mSetTeamRelations( kMysteryTeam, kPlanetTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue );

	mission.mDisplayMessage( kEvent6StartEgg_msg, kMissionScriptMessage );
}

void tEggDefender::mHailMessage( tScript& tScript, tTeamInfo* hailedTeam )
{
	if ( hailedTeam->mGetTeam() == fErrantTeam )
	{
		tScript.fMission.mDisplayMessage( kErrantHailOK_msg, kMissionScriptMessage );
	}
	else // fKingsGuardTeam
	{
		tScript.fMission.mDisplayMessage( kKingHailOK_msg, kMissionScriptMessage );
	}
}

void tEggDefender::mTauntMessage( tScript& tScript, tTeamInfo* hailedTeam )
{
	if ( hailedTeam->mGetTeam() == fErrantTeam )
	{
		tScript.fMission.mDisplayMessage( tScript.fMission.mRandomInt32( kErrantTaunt_1_msg, kErrantTaunt_4_msg ), kMissionScriptMessage );
	}
	else // fKingsGuardTeam
	{
		tScript.fMission.mDisplayMessage( tScript.fMission.mRandomInt32( kKingTaunt_1_msg, kKingTaunt_4_msg ), kMissionScriptMessage );
	}
}

void tEggDefender::mSurrenderMessage( tScript& tScript, tTeamInfo* hailedTeam )
{
	if ( hailedTeam->mGetTeam() == fErrantTeam )
	{
		tScript.fMission.mDisplayMessage( kErrantSurrenderOK_msg, kMissionScriptMessage );
	}
	else // fKingsGuardTeam
	{
		tScript.fMission.mDisplayMessage( kKingSurrenderOK_msg, kMissionScriptMessage );
	}
}

void tEggDefender::mSetFactionWar( tScript& tScript )
{
}

void tEggDefender::mCheckWinCondition( tScript& tScript, tTeamInfo* teamXInfo )
{
}
