#include "Gor_6Errant.h"

tErrant::tErrant( eTeamTypes eggDefender, eTeamTypes kingsGuard, eTeamID playerTeam )
{
	fEggDefenderTeam = eggDefender;
	fKingsGuardTeam = kingsGuard;
	fPlayerTeam = playerTeam;
}

void tErrant::mCreateShips( tTeamInfo* eggDefenderTeam, tTeamInfo* kingsGuardTeam, int32 lowBPV )
{
	eggDefenderTeam->mCreateShip( lowBPV, kClassFrigate, kClassDreadnought, 100, kStartPosition_U );

	kingsGuardTeam->mCreateShip( lowBPV, kClassDestroyer, kClassDreadnought, 100, kStartPosition_X );
}

int32 tErrant::mInitializeFinished()
{
	return kErrantBriefing_msg;
}

void tErrant::mSetUpShips( tScript& tScript, tShipInfo* ship )
{
	ship->mSetCommButton (1, kButtonHail_text);
	ship->mSetShipCallbackEvents( kNotifyDamage );

	if ( ship->mGetTeam() == fKingsGuardTeam )
	{
		ship->mChangeName( kKingsGuard_name );
	}
	else
	{
		ship->mChangeName( kEggDefender_name );
	}
}

void tErrant::mSetAllTeamRelations( tMissionInfo& mission )
{
	mission.mSetTeamRelations( fPlayerTeam, kShipyardTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue );
	mission.mSetTeamRelations( fPlayerTeam, fEggDefenderTeam, kTeamAtWar, kGoalDestroy, 1.0, kTrue );
	mission.mSetTeamRelations( fPlayerTeam, fKingsGuardTeam, kTeamAtWar, kGoalDestroy, 1.0, kTrue );
	mission.mSetTeamRelations( fPlayerTeam, kRepairingTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue );
	mission.mSetTeamRelations( fPlayerTeam, kMysteryTeam, kTeamHostile, kGoalDestroy, 1.0, kTrue );
	mission.mSetTeamRelations( fPlayerTeam, kPlanetTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue );

	mission.mSetTeamRelations( kShipyardTeam, fEggDefenderTeam, kTeamAtWar, kGoalDestroy, 1.0, kTrue );
	mission.mSetTeamRelations( kShipyardTeam, fKingsGuardTeam, kTeamAtWar, kGoalDestroy, 1.0, kTrue );
	mission.mSetTeamRelations( kShipyardTeam, kRepairingTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue );
	mission.mSetTeamRelations( kShipyardTeam, kMysteryTeam, kTeamNeutral, kGoalIgnore, 1.0, kTrue );
	mission.mSetTeamRelations( kShipyardTeam, kPlanetTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue );

	mission.mSetTeamRelations( fEggDefenderTeam, fKingsGuardTeam, kTeamNeutral, kGoalIgnore, 1.0, kTrue );
	mission.mSetTeamRelations( fEggDefenderTeam, kRepairingTeam, kTeamAtWar, kGoalDestroy, 1.0, kTrue );
	mission.mSetTeamRelations( fEggDefenderTeam, kMysteryTeam, kTeamNeutral, kGoalIgnore, 1.0, kTrue );
	mission.mSetTeamRelations( fEggDefenderTeam, kPlanetTeam, kTeamNeutral, kGoalIgnore, 1.0, kTrue );

	mission.mSetTeamRelations( fKingsGuardTeam, kRepairingTeam, kTeamAtWar, kGoalDestroy, 1.0, kTrue );
	mission.mSetTeamRelations( fKingsGuardTeam, kMysteryTeam, kTeamNeutral, kGoalIgnore, 1.0, kTrue );
	mission.mSetTeamRelations( fKingsGuardTeam, kPlanetTeam, kTeamNeutral, kGoalIgnore, 1.0, kTrue );

	mission.mSetTeamRelations( kRepairingTeam, kMysteryTeam, kTeamNeutral, kGoalIgnore, 1.0, kTrue );
	mission.mSetTeamRelations( kRepairingTeam, kPlanetTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue );

	mission.mSetTeamRelations( kMysteryTeam, kPlanetTeam, kTeamNeutral, kGoalIgnore, 1.0, kTrue );

	mission.mDisplayMessage( kEvent6StartErrant_msg, kMissionScriptMessage );
}

void tErrant::mHailMessage( tScript& tScript, tTeamInfo* hailedTeam )
{
	if ( hailedTeam->mGetTeam() == fEggDefenderTeam )
	{
		tScript.fMission.mDisplayMessage( kEggHailOK_msg, kMissionScriptMessage );
	}
	else // fKingsGuardTeam
	{
		tScript.fMission.mDisplayMessage( kKingHailOK_msg, kMissionScriptMessage );
	}
}

void tErrant::mTauntMessage( tScript& tScript, tTeamInfo* hailedTeam )
{
	if ( hailedTeam->mGetTeam() == fEggDefenderTeam )
	{
		tScript.fMission.mDisplayMessage( tScript.fMission.mRandomInt32( kEggTaunt_1_msg, kEggTaunt_4_msg ), kMissionScriptMessage );
	}
	else // fKingsGuardTeam
	{
		tScript.fMission.mDisplayMessage( tScript.fMission.mRandomInt32( kKingTaunt_1_msg, kKingTaunt_4_msg ), kMissionScriptMessage );
	}
}

void tErrant::mSurrenderMessage( tScript& tScript, tTeamInfo* hailedTeam )
{
	if ( hailedTeam->mGetTeam() == fEggDefenderTeam )
	{
		tScript.fMission.mDisplayMessage( kEggSurrenderOK_msg, kMissionScriptMessage );
	}
	else // fKingsGuardTeam
	{
		tScript.fMission.mDisplayMessage( kKingSurrenderOK_msg, kMissionScriptMessage );
	}
}

void tErrant::mSetFactionWar( tScript& tScript )
{
}

void tErrant::mCheckWinCondition( tScript& tScript, tTeamInfo* teamXInfo )
{
	if ( tScript.fMission.mGetTeamHandle( fEggDefenderTeam )->mGetShipsInPlayCount() == 0 )
	{
	}
}
