#if !defined( Gor_6FactionScript_h )
#define Gor_6FactionScript_h

#include "scriptinterface.h"

#include "Gor_6MissionText.h"

enum eTeamTypes
{
	// the first 6 team types are reserved for player teams.
	kReserved = kTeam6,

	// add all non-player teams (enemy, allied, monsters, etc...) after this point.

	kShipyardTeam, 
	kGorn_1Team,
	kGorn_2Team,
	kRepairingTeam,
	kMysteryTeam,
	kPlanetTeam
};

enum eMissionMode
{
	kStart = 0,
	kInitialShips,
	kMonsterAppears
};

class tGornFactionScript
{
public:
	virtual void mCreateShips( tTeamInfo* team1Info, tTeamInfo* team2Info, int32 lowBPV ) = 0;
	virtual int32 mInitializeFinished() = 0;
	virtual void mSetUpShips( tScript& tScript, tShipInfo* setUpThisShip ) = 0;
	virtual void mSetAllTeamRelations( tMissionInfo& mission ) = 0;
	virtual void mHailMessage( tScript& tScript, tTeamInfo* teamXInfo ) = 0;
	virtual void mTauntMessage( tScript& tScript, tTeamInfo* teamXInfo ) = 0;
	virtual void mSurrenderMessage( tScript& tScript, tTeamInfo* teamXInfo ) = 0;
	virtual void mSetFactionWar( tScript& tScript ) = 0;
	virtual void mCheckWinCondition( tScript& tScript, tTeamInfo* teamXInfo ) = 0;
};

#endif