int32 TotalMaps = 18;
const char* MapTypes[] = { "Open Space (Lrg)", "Open Space (Med)", "Open Space (Sml)",
	"Planets (Lrg)", "Planets (Med)", "Planet (Sml)", "Asteroid Field (Med)",
	"Asteroid Field (Sml)", "Asteroid Belt (Med)", "Asteroid Belt (Sml)",
	"Black Hole (Med)", "Black Hole (Sml)", "Black Holes (Med)", "Black Holes (Sml)",
	"Nebula (Med)", "Nebula (Sml)", "Dark Nebula (Med)", "Dark Nebula (Sml)" };
const char* MapLines[]=
{
	// Asteroids: a,A,*
	// Black Holes: b,B
	// Nebula: c,C
	// Dust clouds: d,D
	// Start positions: G,H,I,J,K,L,M,N,O,P,Q,R,S,T,U,V,W,X,Y,Z
	// End positions:   g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
	// Planets: 1-6
	// Suns: 7-9
	//
   "Mission Maps",
   "// Open Space (Lrg)",
   " +____1____2____3____4____5____6____7____8+",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "1|........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "2|........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "3|........................................|",
   " |........................................|",
   " |.......ux....J.G......U.X....gj.........|",
   " |........................................|",
   " |.......vy....K.H......V.Y....kh.........|",
   "4|........................................|",
   " |.......wz....L.I......W.Z....wz.........|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "5|........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "6|........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "7|........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "8|........................................|",
   " +----------------------------------------+",
   "      1    2    3    4    5    6    7    8",
   "// Open Space (Med)",
   " +____1____2____3____4____5+",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   "1|.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   "2|.........................|",
   " |..ux...J.G.....U.X...jg..|",
   " |.........................|",
   " |..vy...K.H.....V.Y...kh..|",
   " |.........................|",
   "3|..wz...L.I.....W.Z...li..|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   "4|.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   "5|.........................|",
   " +-------------------------+",
   "      1    2    3    4    5",
   "// Open Space (Sml)",
   " +____1____2____3+",
   " |...............|",
   " |...............|",
   " |...............|",
   " |...............|",
   "1|...............|",
   " |uxJ.G....U.X.gj|",
   " |...............|",
   " |vyK.H....V.Y.kh|",
   " |...............|",
   "2|wzL.I....W.Z.li|",
   " |...............|",
   " |...............|",
   " |...............|",
   " |...............|",
   "3|...............|",
   " +---------------+",
   "      1    2    3",
   "// Planets (Lrg)",
   " +____1____2____3____4____5____6____7____8+",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |....7...................................|",
   "1|........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "2|........................................|",
   " |........................................|",
   " |........................................|",
   " |...............6........................|",
   " |........................................|",
   "3|........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "4|........................................|",
   " |........................................|",
   " |..............3.........................|",
   " |........................................|",
   " |.................uvw....................|",
   "5|.................xyz................a...|",
   " |..................J.K.L................a|",
   " |..............................a....a....|",
   " |..................G.H.I.........A.......|",
   " |...........................a............|",
   "6|.......................a................|",
   " |...................a....................|",
   " |....a.......a..a......U.V.W.............|",
   " |........a..*............................|",
   " |..a..A................X.Y.Z.............|",
   "7|..............................2.........|",
   " |........................ghi.............|",
   " |........................jkl.............|",
   " |........................................|",
   " |........................................|",
   "8|........................................|",
   " +----------------------------------------+",
   "      1    2    3    4    5    6    7    8",
   "// Planets (Med)",
   " +____1____2____3____4____5+",
   " |.........................|",
   " |.8.......................|",
   " |.........................|",
   " |.........................|",
   "1|.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   "2|.........................|",
   " |..................1......|",
   " |.........................|",
   " |.....uvw.................|",
   " |.....xyz.................|",
   "3|........G.H.I............|",
   " |........J.K.L............|",
   " |...............U.V.W.....|",
   " |...............X.Y.Z.....|",
   " |.......4............ghi..|",
   "4|....................jkl..|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   "5|.........................|",
   " +-------------------------+",
   "      1    2    3    4    5",
   "// Planet (Sml)",
   " +____1____2____3+",
   " |...............|",
   " |...............|",
   " |..g.h.i.j.k.l..|",
   " |...............|",
   "1|......W.X......|",
   " |....V.....Y....|",
   " |..U.........Z..|",
   " |.......1.......|",
   " |..L.........K..|",
   "2|....G.....J....|",
   " |......H.I......|",
   " |...............|",
   " |..u.v.w.x.y.z..|",
   " |...............|",
   "3|...............|",
   " +---------------+",
   "      1    2    3",
   "// Asteroid Field (Med)",
   " +____1____2____3____4____5+",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   "1|.........................|",
   " |...........A...a.........|",
   " |.........................|",
   " |.a...A............A......|",
   " |...uvw......a............|",
   "2|...xyz....A..............|",
   " |A....*.........A...a..A..|",
   " |.......J.K.L.............|",
   " |....a..H.G.I..*..........|",
   " |....................a....|",
   "3|........a........A.......|",
   " |....A........U.V.W.......|",
   " |.............X.Y.Z.....A.|",
   " |..a........A....a........|",
   " |......A............ghi...|",
   "4|..............a...Ajkl...|",
   " |..........a..............|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   "5|.........................|",
   " +-------------------------+",
   "      1    2    3    4    5",
   "// Asteroid Field (Sml)",
   " +____1____2____3+",
   " |...............|",
   " |.A...a...a...A.|",
   " |...............|",
   " |..a....*....a..|",
   "1|.uvw...........|",
   " |.xyza...a......|",
   " |....JKL....a...|",
   " |..a.GHI........|",
   " |..........UVW..|",
   "2|....a..a..XYZa.|",
   " |..........a.ghi|",
   " |..a....A....jkl|",
   " |.........a..a..|",
   " |...A..a........|",
   "3|..........A....|",
   " +---------------+",
   "      1    2    3",
   "// Asteroid Belt (Med)",
   " +____1____2____3____4____5+",
   " |..A............a.........|",
   " |....a.............a......|",
   " |................A........|",
   " |.......a.......A.........|",
   "1|....A..............A.....|",
   " |................a........|",
   " |.......A...........a.....|",
   " |.....a..........*........|",
   " |.......*..........A......|",
   "2|....A................A...|",
   " |........a.......A........|",
   " |....uA....G....U.a.ga....|",
   " |.........................|",
   " |...v.....a.H...V.*..h.A..|",
   "3|......a............A.....|",
   " |..w..A...A.I....W....i...|",
   " |..................A..a...|",
   " |...x...a..*.J...X.....j..|",
   " |..................a......|",
   "4|..y....A..a.K...Y....A.k.|",
   " |......A..........*.......|",
   " |.z.....a....L...Z..a....l|",
   " |..........A...........a..|",
   " |.......A...a........A....|",
   "5|.........a..........a..A.|",
   " +-------------------------+",
   "      1    2    3    4    5",
   "// Asteroid Belt (Sml)",
   " +____1____2____3+",
   " |............a..|",
   " |...............|",
   " |..........a..a.|",
   " |.uvw........A..|",
   "1|.xyz...a..a....|",
   " |..JKL....A...a.|",
   " |..IHG..a..a....|",
   " |.....a.........|",
   " |...a....a......|",
   "2|...A.a.........|",
   " |.a......UVW....|",
   " |...a..a.XYZ....|",
   " |..A.......ghi..|",
   " |.a..a.....jkl..|",
   "3|...............|",
   " +---------------+",
   "      1    2    3",
   "// Black Hole (Med)",
   " +____1____2____3____4____5+",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   "1|.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   "2|.vx.J..H.........V..X.jh.|",
   " |.........................|",
   " |.........................|",
   " |.uy.K..G....B....U..Y.kg.|",
   " |.........................|",
   "3|.........................|",
   " |.wz.L..I.........W..Z.li.|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   "4|.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   "5|.........................|",
   " +-------------------------+",
   "      1    2    3    4    5",
   "// Black Hole (Sml)",
   " +____1____2____3+",
   " |...............|",
   " |...............|",
   " |...............|",
   " |....J.....Y....|",
   "1|...............|",
   " |...I.......W...|",
   " |...............|",
   " |.L.G...B...U.Z.|",
   " |...............|",
   "2|...H.......V...|",
   " |...............|",
   " |....K.....X....|",
   " |...............|",
   " |...............|",
   "3|...............|",
   " +---------------+",
   "      1    2    3",
   "// Black Holes (Med)",
   " +____1____2____3____4____5+",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   "1|............B............|",
   " |.........................|",
   " |....B....................|",
   " |.........................|",
   " |.........J.....Y.........|",
   "2|.........................|",
   " |........I.......W........|",
   " |.........................|",
   " |.....L..G...B...U..Z.....|",
   " |.........................|",
   "3|........H.......V........|",
   " |.........................|",
   " |.........K.....X.........|",
   " |.........................|",
   " |.........................|",
   "4|...................B.....|",
   " |............B............|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   "5|.........................|",
   " +-------------------------+",
   "      1    2    3    4    5",
   "// Black Holes (Sml)",
   " +____1____2____3+",
   " |...............|",
   " |.......B.......|",
   " |...............|",
   " |...K........Y..|",
   "1|...............|",
   " |...I...B...W...|",
   " |...............|",
   " |..L.G.....U.Z..|",
   " |...............|",
   "2|...H...B...V...|",
   " |...............|",
   " |...J........X..|",
   " |...............|",
   " |.......B.......|",
   "3|...............|",
   " +---------------+",
   "      1    2    3",
   "// Nebula (Med)",
   " +____1____2____3____4____5+",
   " |.........................|",
   " |.C.......................|",
   " |.........................|",
   " |.........................|",
   "1|.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   "2|.........................|",
   " |..ux...J.G.....U.X...jg..|",
   " |.........................|",
   " |..vy...K.H.....V.Y...kh..|",
   " |.........................|",
   "3|..wz...L.I.....W.Z...li..|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   "4|.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   "5|.........................|",
   " +-------------------------+",
   "      1    2    3    4    5",
   "// Nebula (Sml)",
   " +____1____2____3+",
   " |...............|",
   " |.C.............|",
   " |...............|",
   " |...............|",
   "1|...............|",
   " |uxJ.G....U.X.gj|",
   " |...............|",
   " |vyK.H....V.Y.kh|",
   " |...............|",
   "2|wzL.I....W.Z.li|",
   " |...............|",
   " |...............|",
   " |...............|",
   " |...............|",
   "3|...............|",
   " +---------------+",
   "      1    2    3",
   "// Dark Nebula (Med)",
   " +____1____2____3____4____5+",
   " |.........................|",
   " |.C.......................|",
   " |.........................|",
   " |.........................|",
   "1|......d..................|",
   " |...........A...a...d.....|",
   " |..d......................|",
   " |.a...A....d.......A...d..|",
   " |............a..Y.........|",
   "2|.......I..A......X.......|",
   " |A....*.........A...a..A..|",
   " |.......H.................|",
   " |....a...L.A...*.Z.d......|",
   " |......G.............a..d.|",
   "3|........a.....U..A.......|",
   " |.d..A.......a...W........|",
   " |......J.K.....V........A.|",
   " |..a........A....a........|",
   " |......A..d...............|",
   "4|..............a...A...d..|",
   " |....d.....a..............|",
   " |...............d.........|",
   " |.........d...............|",
   " |.........................|",
   "5|.........................|",
   " +-------------------------+",
   "      1    2    3    4    5",
   "// Dark Nebula (Sml)",
   " +____1____2____3+",
   " |...............|",
   " |.CA..a...a...A.|",
   " |...............|",
   " |.d.J...*.X.....|",
   "1|.......d.......|",
   " |..H.a...a.Vd...|",
   " |.uvw........Z..|",
   " |.dL.G.a..U..ghi|",
   " |.xyz.....*.Wjkl|",
   "2|..I.a..a...d...|",
   " |......d...a....|",
   " |.d..K..A...Y..d|",
   " |.........a.....|",
   " |...A..a........|",
   "3|........d.A....|",
   " +---------------+",
   "      1    2    3",
   "///",
   0
};
