int32 TotalMaps = 7;
const char* MapTypes[] = { "Open Space (Large)", "Open Space (Medium)", "Open Space (Small)", "Planets (Large)", "Planets (Medium)", "Planet (Small)", "Asteroid Base" };
const char* MapLines[]=
{
	// Asteroids: a,A,*
	// Black Holes: b,B
	// Nebula: c,C
	// Dust clouds: d,D
	// Start positions: G,H,I,J,K,L,M,N,O,P,Q,R,S,T,U,V,W,X,Y,Z
	// End positions:   g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
	// Planets: 1-6
	// Suns: 7-9
	//
   "Mission Maps",
   "// Open Space (Large)",
   " +____1____2____3____4____5____6____7____8+",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "1|........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "2|........................................|",
   " |........................................|",
   " |........................................|",
   " |................Z.....Y.................|",
   " |........................................|",
   "3|..............W....M....X...............|",
   " |........................................|",
   " |................V.....U.................|",
   " |........................................|",
   " |........................................|",
   "4|................uvwxyz..................|",
   " |.............k..h..g..i..j..............|",
   " |........................................|",
   " |........................................|",
   " |.............K..H.....I..J..............|",
   "5|...................G....................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "6|........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "7|........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "8|........................................|",
   " +----------------------------------------+",
   "      1    2    3    4    5    6    7    8",
   "// Open Space (Medium)",
   " +____1____2____3____4____5+",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   " |..........i...h..........|",
   "1|........Z.g.Y.j..........|",
   " |.........................|",
   " |............M...X........|",
   " |.........V...............|",
   " |............k..W.........|",
   "2|............U............|",
   " |.........................|",
   " |..........xvuwy..........|",
   " |............z............|",
   " |..........G...H..........|",
   "3|.........................|",
   " |..........I...J..........|",
   " |.........................|",
   " |............K............|",
   " |.........................|",
   "4|.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   "5|.........................|",
   " +-------------------------+",
   "      1    2    3    4    5",
   "// Open Space (Small)",
   " +____1____2____3+",
   " |...............|",
   " |.......H..J....|",
   " |...............|",
   " |...............|",
   "1|...............|",
   " |.....Z..W......|",
   " |...............|",
   " |.....U.gMh.X...|",
   " |.......ijku....|",
   "2|.......V...Y...|",
   " |...............|",
   " |.............K.|",
   " |...............|",
   " |....I..G.......|",
   "3|...............|",
   " +---------------+",
   "      1    2    3",
   "// Planets (Large)",
   " +____1____2____3____4____5____6____7____8+",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |....7...................................|",
   "1|........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "2|........................................|",
   " |........................................|",
   " |........................................|",
   " |...............6........................|",
   " |........................................|",
   "3|........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "4|........................................|",
   " |........................................|",
   " |..............3.........................|",
   " |...................hgi..................|",
   " |.....................Z...Y..............|",
   "5|...............V......j.............a...|",
   " |....................M..k..X............a|",
   " |..............................a....a....|",
   " |.................U....W.........A.......|",
   " |...........................a............|",
   "6|.J.....................a................|",
   " |....K..............a....................|",
   " |....a.......a..a........................|",
   " |........a..*............................|",
   " |..a..A............I..G..H...............|",
   "7|..............................2.........|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "8|........................................|",
   " +----------------------------------------+",
   "      1    2    3    4    5    6    7    8",
   "// Planets (Medium)",
   " +____1____2____3____4____5+",
   " |.........................|",
   " |.8.......................|",
   " |.........................|",
   " |.........................|",
   "1|.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   " |.................3.......|",
   "2|.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   "3|.........................|",
   " |.........................|",
   " |...........Z.X.W.....K...|",
   " |..............kj.........|",
   " |............MYghi....J...|",
   "4|......6..................|",
   " |............V.U..........|",
   " |.....................G...|",
   " |...................H.....|",
   " |.................I.......|",
   "5|.........................|",
   " +-------------------------+",
   "      1    2    3    4    5",
   "// Planet (Small)",
   " +____1____2____3+",
   " |...............|",
   " |.............K.|",
   " |...............|",
   " |.......1.......|",
   "1|...............|",
   " |...Y.Z....V....|",
   " |.....M.........|",
   " |...X.W..U......|",
   " |.....ghijk.....|",
   "2|...............|",
   " |...............|",
   " |...............|",
   " |...............|",
   " |..I..G..H..J...|",
   "3|...............|",
   " +---------------+",
   "      1    2    3",
   "// Asteroid Base",
   " +____1____2____3____4____5+",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   " |......a..................|",
   "1|...................a.....|",
   " |...........A...a.........|",
   " |.......a.................|",
   " |.a...A............A......|",
   " |............a............|",
   "2|..........A..............|",
   " |A....*.........A...a..A..|",
   " |........ghijkY...........|",
   " |....a...X.M..............|",
   " |.............U......a....|",
   "3|.........W.V.............|",
   " |....A....................|",
   " |.......................A.|",
   " |..a........A.............|",
   " |......A..........G..H..I.|",
   "4|........Z.....a..........|",
   " |....a.....a.......J..K...|",
   " |........a................|",
   " |................a........|",
   " |.........................|",
   "5|.........................|",
   " +-------------------------+",
   "      1    2    3    4    5",
   "///",
   0
};
