#include "scriptinterface.h"

#include "Kli_8MissionText.h"
#include "Kli_8MissionMaps.h"

/**********************************
LNF
is there a limit on how many ships I can use with
Deep Scan tracker? nope, change the enum from 5 to whatever

AFAIK, this is the only thing to add for this mission
**********************************/

//***      balance      ***
eClassTypes PlayerShipClass = kClassShuttle;
eClassTypes LargestEnemyShipClass = kClassFrigate;
eClassTypes NewEnemyShipClass( tScript& tScript, eClassTypes LargestEnemyShipClass );
//***                   ***

int32 checkthisout = 0;

int32 AtWarWithKraa = 0;
int32 PlayerDestroyed = 0;
int32 Fed_ADestroyed = 0;
int32 Fed_BDestroyed = 0;
int32 Klingon_ADestroyed = 0;
int32 Klingon_BDestroyed = 0;
int32 GornDestroyed = 0;
int32 HydranDestroyed = 0;
int32 KraaDestroyed = 0;
int32 KraaCaptured = 0;
int32 Message = 0;
int32 WormholeX = 0;
int32 WormholeY = 0;
const float kDeepScanDistance = 30.0;
const float kWormholeWarningDistance = 30.0;
const float kWormholeDistance = 0.0;
bool AllFed_ADestroyed = false;
bool AllFed_BDestroyed = false;
bool AllKlingon_ADestroyed = false;
bool AllKlingon_BDestroyed = false;
bool AllGornDestroyed = false;
bool AllHydranDestroyed = false;
bool PlayerUsedESCKey = false; // if the player Ends Mission with the ESC key


void configureShips(tTeamInfo* TeamName);
void setFedPatrolRoute(tTeamInfo* TeamName, tScript& tScript);
void setKlingonPatrolRoute(tTeamInfo* TeamName, tScript& tScript);
void setOtherPatrolRoute(tTeamInfo* TeamName, tScript& tScript);

// include this file after all other includes
#include "DeepScanTracker.h"
tDeepScanTracker DeepScanTracker;

//---------------------------------------------------------------------------------------------
// the following enum is used to identify all non-player teams in the script
// (use kPlayerTeam to access the current players team.)
enum eTeamTypes
{
	// the first 6 team types are reserved for player teams.
	kReserved = kTeam6,

	// add all non-player teams (enemy, allied, monsters, etc...) after this point.

	kFed_ATeam, 
	kFed_BTeam, 
	kKlingon_ATeam,
	kKlingon_BTeam,
	kGornTeam,
	kHydranTeam,
	kKraaTeam,
	kPlanetTeam
};
//---------------------------------------------------------------------------------------------
// called by script interface - 
// should return whatever team is considered to be the primary enemy
int32 tScript::mGetEnemyTeamID (void)
{
	return kPlayerTeam;
}

//---------------------------------------------------------------------------------------------
// returns mission specs used by Dynaverse to build campaigns
void tScript::mScriptSpecs (tMissionSpec* Specs)
{
	Specs->fMissionType = kCampaignMission;
	Specs->fMissionTitle = Messages[kMissionTitle_msg].mCharStr();
	Specs->fSectorType = kAllSectors;
	Specs->fPlayerRace = kKlingMission; //LNF change this for Klingons
	Specs->fEnemyRace = kAllRaceMission; //LNF should only be Hydran or Lyran
	Specs->fNumShips = MissSpecAllShips;
	Specs->fMinBPV = 0;
	Specs->fMaxBPV = kMaxBPV;
	Specs->fMinDate = 9999;
	Specs->fMaxDate = 9999;
	Specs->fWait = kUniqueMission;
	Specs->fEnableSupplyDock = kTrue;
}

//---------------------------------------------------------------------------------------------
// called at the start of mission initialization - use to set prestige points 
// and override mission defaults such as:
//		allied race
//		enemy race
//		system name
// and also returns map index to use
int32 tScript::mInitializeStart (tDynaverseScriptInfo& info)
{
	fMission.mSetPrestigePoints (200, 160, 100, 40, 0);

	// must set up the races of the teams in the script
	info.fEnemyRace = kFederation;
	fMission.mSetTeamRace (kPlayerTeam, info.fPlayerRace);
	fMission.mSetTeamRace (kFed_ATeam, kFederation);
	fMission.mSetTeamRace (kFed_BTeam, kFederation);
	fMission.mSetTeamRace (kKlingon_ATeam, kKlingon);
	fMission.mSetTeamRace (kKlingon_BTeam, kKlingon);
	fMission.mSetTeamRace (kGornTeam, kGorn);
	fMission.mSetTeamRace (kHydranTeam, kHydran);
	fMission.mSetTeamRace (kKraaTeam, kGorn);
	fMission.mSetTeamRace (kPlanetTeam, kNeutralRace);
	

	// Set team relations to show up on Tactical map
	fMission.mSetTeamRelations (kPlayerTeam, kFed_ATeam, kTeamHostile, kGoalIgnore, 1.0, kTrue);
	fMission.mSetTeamRelations (kPlayerTeam, kFed_BTeam, kTeamHostile, kGoalIgnore, 1.0, kTrue);
	fMission.mSetTeamRelations (kPlayerTeam, kKlingon_ATeam, kTeamHostile, kGoalIgnore, 1.0, kTrue);
	fMission.mSetTeamRelations (kPlayerTeam, kKlingon_BTeam, kTeamHostile, kGoalIgnore, 1.0, kTrue);
	fMission.mSetTeamRelations (kPlayerTeam, kGornTeam, kTeamHostile, kGoalIgnore, 1.0, kTrue);
	fMission.mSetTeamRelations (kPlayerTeam, kHydranTeam, kTeamHostile, kGoalIgnore, 1.0, kTrue);
	fMission.mSetTeamRelations (kPlayerTeam, kKraaTeam, kTeamHostile, kGoalIgnore, 1.0, kTrue);
	fMission.mSetTeamRelations (kPlayerTeam, kPlanetTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);

	fMission.mSetTeamRelations (kFed_ATeam, kFed_BTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);
	fMission.mSetTeamRelations (kFed_ATeam, kKlingon_ATeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);
	fMission.mSetTeamRelations (kFed_ATeam, kKlingon_BTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);
	fMission.mSetTeamRelations (kFed_ATeam, kGornTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);
	fMission.mSetTeamRelations (kFed_ATeam, kHydranTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);
	fMission.mSetTeamRelations (kFed_ATeam, kKraaTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);
	fMission.mSetTeamRelations (kFed_ATeam, kPlanetTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);

	fMission.mSetTeamRelations (kFed_BTeam, kKlingon_ATeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);
	fMission.mSetTeamRelations (kFed_BTeam, kKlingon_BTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);
	fMission.mSetTeamRelations (kFed_BTeam, kGornTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);
	fMission.mSetTeamRelations (kFed_BTeam, kHydranTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);
	fMission.mSetTeamRelations (kFed_BTeam, kKraaTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);
	fMission.mSetTeamRelations (kFed_BTeam, kPlanetTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);

	fMission.mSetTeamRelations (kKlingon_ATeam, kKlingon_BTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);
	fMission.mSetTeamRelations (kKlingon_ATeam, kGornTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);
	fMission.mSetTeamRelations (kKlingon_ATeam, kHydranTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);
	fMission.mSetTeamRelations (kKlingon_ATeam, kKraaTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);
	fMission.mSetTeamRelations (kKlingon_ATeam, kPlanetTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);
	
	fMission.mSetTeamRelations (kKlingon_BTeam, kGornTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);
	fMission.mSetTeamRelations (kKlingon_BTeam, kHydranTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);
	fMission.mSetTeamRelations (kKlingon_BTeam, kKraaTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);
	fMission.mSetTeamRelations (kKlingon_BTeam, kPlanetTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);

	fMission.mSetTeamRelations (kGornTeam, kHydranTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);
	fMission.mSetTeamRelations (kGornTeam, kKraaTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);
	fMission.mSetTeamRelations (kGornTeam, kPlanetTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);

	fMission.mSetTeamRelations (kHydranTeam, kKraaTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);
	fMission.mSetTeamRelations (kHydranTeam, kPlanetTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);

	fMission.mSetTeamRelations (kKraaTeam, kPlanetTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);


	// Get global variable information here.  there are currently 16 of them
	// int32 info.fScriptValues[0];

	checkthisout = info.fScriptValues[0];

	checkthisout = 5;

	return 1;
}

//---------------------------------------------------------------------------------------------
// return kTrue if players ship should be created for this mission
iTruth tScript::mUsePlayerShip (tShipInGame& Ship)
{
	return kTrue;
}

//---------------------------------------------------------------------------------------------
// called to create ships before or during the mission
// Mode is user supplied value (expect for 0, which is initial setup call)
void tScript::mCreateMissionShips (int32 Mode)
{
	tTeamInfo* PlayerTeam = fMission.mGetTeamHandle (kPlayerTeam);
	tTeamInfo* Fed_ATeam = fMission.mGetTeamHandle (kFed_ATeam);
	tTeamInfo* Fed_BTeam = fMission.mGetTeamHandle (kFed_BTeam);
	tTeamInfo* Klingon_ATeam = fMission.mGetTeamHandle (kKlingon_ATeam);
	tTeamInfo* Klingon_BTeam = fMission.mGetTeamHandle (kKlingon_BTeam);
	tTeamInfo* GornTeam = fMission.mGetTeamHandle (kGornTeam);
	tTeamInfo* HydranTeam = fMission.mGetTeamHandle (kHydranTeam);
	tTeamInfo* KraaTeam = fMission.mGetTeamHandle (kKraaTeam);
	tTeamInfo* PlanetTeam = fMission.mGetTeamHandle (kPlanetTeam);

	tShipInfo* Ship = NULL;

	// Get the total BPV of the player and modify by a low and high percentage
	int32 LowBPV = PlayerTeam->mGetCombatBPV() * .75;
	int32 HighBPV = PlayerTeam->mGetCombatBPV() * 1.25;
	int32 TotalBPV = fMission.mRandomInt32 (LowBPV, HighBPV);

	// balance
	int32 NumberOfPlayersShips = PlayerTeam->mGetShipsInPlayCount();
	int32 DifLev = fMission.mGetDifficultyLevel();

	// determine the biggest ship class the player has
	for (Ship = PlayerTeam->mGetFirstShip(); Ship != NULL; Ship = PlayerTeam->mGetNextShip())
	{
		if (PlayerShipClass < Ship->mGetClassType())
		{
			PlayerShipClass = Ship->mGetClassType();
		}
	}

	switch ( DifLev )
	{
		case 0:
			{
				TotalBPV *= 0.60f;

				// set LargestEnemyShipClass to one SMALLER than the player
				if ( PlayerShipClass > kClassFrigate )
				{
					LargestEnemyShipClass = (eClassTypes) ((int32)PlayerShipClass - 1);
				}
			}
			break;
		case 1:
			{
				// do nothing
				LargestEnemyShipClass = PlayerShipClass;
			}
			break;
		case 2:
			{
				TotalBPV *= 1.5f;

				// set LargestEnemyShipClass to one LARGER than the player
				if ( PlayerShipClass < kClassBattleship )
				{
					LargestEnemyShipClass = (eClassTypes) ((int32)PlayerShipClass + 1);
				}
			}
			break;
	}

	int32 AveragePlayerBPV = TotalBPV / NumberOfPlayersShips;

	Fed_ATeam->mCreateFleet (1, AveragePlayerBPV, kClassFrigate, LargestEnemyShipClass, 20, kStartPosition_Specified, 27, 24); // Z
	Fed_BTeam->mCreateFleet (1, AveragePlayerBPV, kClassFrigate, LargestEnemyShipClass, 20, kStartPosition_Specified, 25, 10); // W
	Klingon_ATeam->mCreateFleet (1, AveragePlayerBPV, kClassFrigate, LargestEnemyShipClass, 20, kStartPosition_Specified, 12, 23); // U
	Klingon_BTeam->mCreateFleet (1, AveragePlayerBPV, kClassFrigate, LargestEnemyShipClass, 20, kStartPosition_Specified, 19, 14); // X
	//GornTeam->mCreateFleet (1, AveragePlayerBPV, kClassHeavyCruiser, kClassHeavyCruiser, 20, kStartPosition_Specified, 33, 19); // Y
	HydranTeam->mCreateFleet (1, AveragePlayerBPV, kClassFrigate, LargestEnemyShipClass, 20, kStartPosition_Specified, 7, 17); // V
	KraaTeam->mCreateShip (kMaxBPV, kClassHeavyCruiser, kClassHeavyCruiser, 20, kStartPosition_T); // T
	PlanetTeam->mCreateShip ("PL1", kStartPosition_Specified, 20, 20);
}

//---------------------------------------------------------------------------------------------
// called at the end of mission initialization - use to return briefing message
int32 tScript::mInitializeFinished (void)
{
	return (kBriefing_msg);
}

//---------------------------------------------------------------------------------------------
// called after all ships have been created and mission is ready to start.
// use to set callback events and change default ship configuration
void tScript::mStartMission (void)
{
	tTeamInfo* PlayerTeam = fMission.mGetTeamHandle (kPlayerTeam);
	tTeamInfo* Fed_ATeam = fMission.mGetTeamHandle (kFed_ATeam);
	tTeamInfo* Fed_BTeam = fMission.mGetTeamHandle (kFed_BTeam);
	tTeamInfo* Klingon_ATeam = fMission.mGetTeamHandle (kKlingon_ATeam);
	tTeamInfo* Klingon_BTeam = fMission.mGetTeamHandle (kKlingon_BTeam);
	tTeamInfo* GornTeam = fMission.mGetTeamHandle (kGornTeam);
	tTeamInfo* HydranTeam = fMission.mGetTeamHandle (kHydranTeam);
	tTeamInfo* KraaTeam = fMission.mGetTeamHandle (kKraaTeam);

	tShipInfo* Ship;

	// configure Player ship(s)
	PlayerTeam->mGetFirstShip()->mSetShipPlayerControlled();
	for (Ship = PlayerTeam->mGetFirstShip(); Ship != NULL; Ship = PlayerTeam->mGetNextShip())
	{
		Ship->mSetShipThrust (5);
		Ship->mTrackTacticalDistance(kWormholeWarningDistance, WormholeX, WormholeY); // distance to wormhole
		Ship->mSetShipCallbackEvents( kNotifyDamage );
	}

	// configure ships
	configureShips(Fed_ATeam);
	configureShips(Fed_BTeam);
	configureShips(Klingon_ATeam);
	configureShips(Klingon_BTeam);
	//configureShips(GornTeam);
	configureShips(HydranTeam);

	// feds are always supposed to attack the player
	//setFedPatrolRoute(Fed_ATeam, *this);
	//setFedPatrolRoute(Fed_BTeam, *this);
	setKlingonPatrolRoute(Klingon_ATeam, *this);
	setKlingonPatrolRoute(Klingon_BTeam, *this);
	//setOtherPatrolRoute(GornTeam, *this);
	setOtherPatrolRoute(KraaTeam, *this);
	setOtherPatrolRoute(HydranTeam, *this);
	
	// configure Kraa ship
	for (Ship = KraaTeam->mGetFirstShip(); Ship != NULL; Ship = KraaTeam->mGetNextShip())
	{
		Ship->mSetCommButton (1, kButtonHail_text);
		Ship->mSetShipCallbackEvents (kNotifyDamage);
		Ship->mSetShipMaxSpeed( 12 );
		//Ship->mSetFinalDestination();
	}

	// Start a timer
	fMission.mSetTimedInterval (kTimerLimitSet, 3);

	// timer to check the distance from the player ship to anyone
	fMission.mSetTimedInterval( kTimerLimitSet_2, 1 );

	// set the end game pause delay
	fMission.mSetTimedInterval (kTimerEndGamePause, 0);

	// setup to test deep scan every second - must be called before any entities are added to be scanned
	DeepScanTracker.mSetTimer (*this, kTimerLimitSet_10, 1);	// will use kTimerLimitSet_10 as polling timer
	// deep scan ListeningPost from within kDeepScanDistance for 1 turn
	DeepScanTracker.mSetTarget (Fed_ATeam->mGetThisShip(1), kDeepScanDistance, 1);
	//DeepScanTracker.mSetTarget (Fed_ATeam->mGetThisShip(2), kDeepScanDistance, 1);
	DeepScanTracker.mSetTarget (Fed_BTeam->mGetThisShip(1), kDeepScanDistance, 1);
	//DeepScanTracker.mSetTarget (Fed_BTeam->mGetThisShip(2), kDeepScanDistance, 1);
	DeepScanTracker.mSetTarget (Klingon_ATeam->mGetThisShip(1), kDeepScanDistance, 1);
	//DeepScanTracker.mSetTarget (Klingon_ATeam->mGetThisShip(2), kDeepScanDistance, 1);
	DeepScanTracker.mSetTarget (Klingon_BTeam->mGetThisShip(1), kDeepScanDistance, 1);
	//DeepScanTracker.mSetTarget (Klingon_BTeam->mGetThisShip(2), kDeepScanDistance, 1);
	//DeepScanTracker.mSetTarget (GornTeam->mGetThisShip(1), kDeepScanDistance, 1);
	DeepScanTracker.mSetTarget (KraaTeam->mGetThisShip(1), kDeepScanDistance, 1);
	DeepScanTracker.mSetTarget (HydranTeam->mGetThisShip(1), kDeepScanDistance, 1);
	//DeepScanTracker.mSetTarget (HydranTeam->mGetThisShip(2), kDeepScanDistance, 1);
}

//---------------------------------------------------------------------------------------------
// called whenever a ship is created after a mission has already started
void tScript::mNewMissionShip (tShipInfo* Ship)
{
}

//---------------------------------------------------------------------------------------------
// called during mission when events occur
eGameStatus tScript::mHandleShipEvent (tShipInfo* Ship, iNotifyEvents Event)
{
	tTeamInfo* PlayerTeam = fMission.mGetTeamHandle (kPlayerTeam);
	tTeamInfo* Fed_ATeam = fMission.mGetTeamHandle (kFed_ATeam);
	tTeamInfo* Fed_BTeam = fMission.mGetTeamHandle (kFed_BTeam);
	tTeamInfo* Klingon_ATeam = fMission.mGetTeamHandle (kKlingon_ATeam);
	tTeamInfo* Klingon_BTeam = fMission.mGetTeamHandle (kKlingon_BTeam);
	tTeamInfo* GornTeam = fMission.mGetTeamHandle (kGornTeam);
	tTeamInfo* HydranTeam = fMission.mGetTeamHandle (kHydranTeam);
	tTeamInfo* KraaTeam = fMission.mGetTeamHandle (kKraaTeam);

	tShipInfo* PlayersTarget = fMission.mGetShipTarget(fPlayerShip);

	switch (Event)
	{
		case kNotifyDamage:
			{
				tShipInfo* HostileShip = fMission.mFindShipID (fEventID);
				// if the player is damaged by any of the other teams because
				// the player moved within the patrol attack radius, set that
				// team AtWar with the player.  OR if the player attacks a team
				// set AtWar.
				if ( HostileShip != NULL )
				{
					if (( Ship->mGetTeam() == kKraaTeam ) && ( HostileShip->mGetTeam() == kPlayerTeam ))
					{
						Ship->mSetShipMaxSpeed( 31 );

						// LNF I should take this out.  these ships should attack player only after Kraa is captured?
/*						if (AtWarWithKraa == 0)
						{
							// if Kraa is attacked, everyone goes after player
							//fMission.mSetTeamRelations (kPlayerTeam, kFed_ATeam, kTeamAtWar, kGoalDestroy, 1.0, kTrue);
							//fMission.mSetTeamRelations (kPlayerTeam, kFed_BTeam, kTeamAtWar, kGoalDestroy, 1.0, kTrue);
							Klingon_ATeam->mClearCommands();
							Klingon_BTeam->mClearCommands();
							GornTeam->mClearCommands();
							HydranTeam->mClearCommands();
							KraaTeam->mClearCommands();
							fMission.mSetTeamRelations (kPlayerTeam, kKlingon_ATeam, kTeamAtWar, kGoalDestroy, 1.0, kTrue);
							fMission.mSetTeamRelations (kPlayerTeam, kKlingon_BTeam, kTeamAtWar, kGoalDestroy, 1.0, kTrue);
							fMission.mSetTeamRelations (kPlayerTeam, kGornTeam, kTeamAtWar, kGoalDestroy, 1.0, kTrue);
							fMission.mSetTeamRelations (kPlayerTeam, kHydranTeam, kTeamAtWar, kGoalDestroy, 1.0, kTrue);
							fMission.mSetTeamRelations (kPlayerTeam, kKraaTeam, kTeamAtWar, kGoalDestroy, 1.0, kTrue);
							AtWarWithKraa = 1;
						}
*/					}
					else if (( Ship->mGetTeam() == kFed_ATeam ) && ( HostileShip->mGetTeam() == kPlayerTeam ))
					{
						Ship->mSetShipMaxSpeed( 31 );
					}
					else if (( Ship->mGetTeam() == kFed_BTeam ) && ( HostileShip->mGetTeam() == kPlayerTeam ))
					{
						Ship->mSetShipMaxSpeed( 31 );
					}
					else if (( Ship->mGetTeam() == kKlingon_ATeam ) && ( HostileShip->mGetTeam() == kPlayerTeam ))
					{
						Ship->mClearCommands();
						Ship->mSetShipMaxSpeed( 31 );
						fMission.mSetTeamRelations (kPlayerTeam, kKlingon_ATeam, kTeamAtWar, kGoalDestroy, 1.0, kTrue);
					}
					else if (( Ship->mGetTeam() == kKlingon_BTeam ) && ( HostileShip->mGetTeam() == kPlayerTeam ))
					{
						Ship->mClearCommands();
						Ship->mSetShipMaxSpeed( 31 );
						fMission.mSetTeamRelations (kPlayerTeam, kKlingon_BTeam, kTeamAtWar, kGoalDestroy, 1.0, kTrue);
					}
					else if (( Ship->mGetTeam() == kGornTeam ) && ( HostileShip->mGetTeam() == kPlayerTeam ))
					{
						Ship->mClearCommands();
						Ship->mSetShipMaxSpeed( 31 );
						fMission.mSetTeamRelations (kPlayerTeam, kGornTeam, kTeamAtWar, kGoalDestroy, 1.0, kTrue);
						KraaTeam->mClearCommands();
						fMission.mSetTeamRelations (kPlayerTeam, kKraaTeam, kTeamAtWar, kGoalDestroy, 1.0, kTrue);
					}
					else if (( Ship->mGetTeam() == kHydranTeam ) && ( HostileShip->mGetTeam() == kPlayerTeam ))
					{
						Ship->mClearCommands();
						Ship->mSetShipMaxSpeed( 31 );
						fMission.mSetTeamRelations (kPlayerTeam, kHydranTeam, kTeamAtWar, kGoalDestroy, 1.0, kTrue);
					}
					else
					{
						Ship->mSetShipCallbackEvents( kNotifyDamage );
					}
				}
			}
			break;

		// This is how the player finishes mission
		case kNotifyAtDistance: 
			if (fPlayerShip->mGetTrackingDistance() == kWormholeWarningDistance)
			{
				// warn player approaching wormhole
				fMission.mDisplayMessage(kWormholeWarning_msg, kScienceScriptMessage);
				fPlayerShip->mTrackTacticalDistance(kWormholeDistance, WormholeX, WormholeY);
			}
			else if (fPlayerShip->mGetTrackingDistance() == kWormholeDistance)
			{
				fMission.mDisplayMessage( kEnteringWormhole_msg, kMissionScriptMessage );
				fMission.mSetGoalIndicator( kFalse, 0, 0 );
				return kPlayerDisengaged;
			}
			break;
	

		case kNotifyAtTimedInterval:
			switch (fEventID)
			{
				case kTimerLimitSet:

					//fMission.mDisplayMessage (kStarting_msg, kNonCommScriptMessage);

					// Set team relations
/*					fMission.mSetTeamRelations (kPlayerTeam, kFed_ATeam, kTeamNeutral, kGoalIgnore, 1.0, kTrue);
					fMission.mSetTeamRelations (kPlayerTeam, kFed_BTeam, kTeamNeutral, kGoalIgnore, 1.0, kTrue);
					fMission.mSetTeamRelations (kPlayerTeam, kKlingon_ATeam, kTeamNeutral, kGoalIgnore, 1.0, kTrue);
					fMission.mSetTeamRelations (kPlayerTeam, kKlingon_BTeam, kTeamNeutral, kGoalIgnore, 1.0, kTrue);
					fMission.mSetTeamRelations (kPlayerTeam, kGornTeam, kTeamNeutral, kGoalIgnore, 1.0, kTrue);
					fMission.mSetTeamRelations (kPlayerTeam, kHydranTeam, kTeamNeutral, kGoalIgnore, 1.0, kTrue);
					fMission.mSetTeamRelations (kPlayerTeam, kKraaTeam, kTeamNeutral, kGoalIgnore, 1.0, kTrue);
					fMission.mSetTeamRelations (kPlayerTeam, kPlanetTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);
*/
					fMission.mSetTeamRelations (kPlayerTeam, kFed_ATeam, kTeamHostile, kGoalDestroy, 1.0);//***
					fMission.mSetTeamRelations (kPlayerTeam, kFed_BTeam, kTeamHostile, kGoalDestroy, 1.0);//***
					fMission.mSetTeamRelations (kPlayerTeam, kKlingon_ATeam, kTeamAtWar, kGoalIgnore, 1.0, kTrue);
					fMission.mSetTeamRelations (kPlayerTeam, kKlingon_BTeam, kTeamAtWar, kGoalIgnore, 1.0, kTrue);
					fMission.mSetTeamRelations (kPlayerTeam, kGornTeam, kTeamAtWar, kGoalIgnore, 1.0, kTrue);
					fMission.mSetTeamRelations (kPlayerTeam, kHydranTeam, kTeamAtWar, kGoalIgnore, 1.0, kTrue);
					fMission.mSetTeamRelations (kPlayerTeam, kKraaTeam, kTeamAtWar, kGoalIgnore, 1.0, kTrue);
					fMission.mSetTeamRelations (kPlayerTeam, kPlanetTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);

					fMission.mSetTeamRelations (kFed_ATeam, kPlayerTeam, kTeamAtWar, kGoalDestroy, 1.0);//***
					fMission.mSetTeamRelations (kFed_ATeam, kFed_BTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);
					fMission.mSetTeamRelations (kFed_ATeam, kKlingon_ATeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);
					fMission.mSetTeamRelations (kFed_ATeam, kKlingon_BTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);
					fMission.mSetTeamRelations (kFed_ATeam, kGornTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);
					fMission.mSetTeamRelations (kFed_ATeam, kHydranTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);
					fMission.mSetTeamRelations (kFed_ATeam, kKraaTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);
					fMission.mSetTeamRelations (kFed_ATeam, kPlanetTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);

					fMission.mSetTeamRelations (kFed_BTeam, kPlayerTeam, kTeamAtWar, kGoalDestroy, 1.0);//***
					fMission.mSetTeamRelations (kFed_BTeam, kKlingon_ATeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);
					fMission.mSetTeamRelations (kFed_BTeam, kKlingon_BTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);
					fMission.mSetTeamRelations (kFed_BTeam, kGornTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);
					fMission.mSetTeamRelations (kFed_BTeam, kHydranTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);
					fMission.mSetTeamRelations (kFed_BTeam, kKraaTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);
					fMission.mSetTeamRelations (kFed_BTeam, kPlanetTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);

					fMission.mSetTeamRelations (kKlingon_ATeam, kKlingon_BTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);
					fMission.mSetTeamRelations (kKlingon_ATeam, kGornTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);
					fMission.mSetTeamRelations (kKlingon_ATeam, kHydranTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);
					fMission.mSetTeamRelations (kKlingon_ATeam, kKraaTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);
					fMission.mSetTeamRelations (kKlingon_ATeam, kPlanetTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);
					
					fMission.mSetTeamRelations (kKlingon_BTeam, kGornTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);
					fMission.mSetTeamRelations (kKlingon_BTeam, kHydranTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);
					fMission.mSetTeamRelations (kKlingon_BTeam, kKraaTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);
					fMission.mSetTeamRelations (kKlingon_BTeam, kPlanetTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);

					fMission.mSetTeamRelations (kGornTeam, kHydranTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);
					fMission.mSetTeamRelations (kGornTeam, kKraaTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);
					fMission.mSetTeamRelations (kGornTeam, kPlanetTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);

					fMission.mSetTeamRelations (kHydranTeam, kKraaTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);
					fMission.mSetTeamRelations (kHydranTeam, kPlanetTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);

					fMission.mSetTeamRelations (kKraaTeam, kPlanetTeam, kTeamAllied, kGoalIgnore, 1.0, kTrue);

					// Start scenario message
					fMission.mDisplayMessage( kStartScenario_msg, kMissionScriptMessage );

					break;

				case kTimerLimitSet_2:
					// if player gets too close to psi ships, they attack player
					{
						for (Ship = Klingon_ATeam->mGetFirstShip(); Ship != NULL; Ship = Klingon_ATeam->mGetNextShip())
						{
							if ( fPlayerShip->mGetTacticalDistance(Ship) <= 10.0 )
							{
								Klingon_ATeam->mClearCommands();
								fMission.mSetTeamRelations (kPlayerTeam, kKlingon_ATeam, kTeamAtWar, kGoalDestroy, 1.0, kTrue);
								Klingon_BTeam->mClearCommands();
								fMission.mSetTeamRelations (kPlayerTeam, kKlingon_BTeam, kTeamAtWar, kGoalDestroy, 1.0, kTrue);
							}
						}
						for (Ship = Klingon_BTeam->mGetFirstShip(); Ship != NULL; Ship = Klingon_BTeam->mGetNextShip())
						{
							if ( fPlayerShip->mGetTacticalDistance(Ship) <= 10.0 )
							{
								Klingon_BTeam->mClearCommands();
								fMission.mSetTeamRelations (kPlayerTeam, kKlingon_BTeam, kTeamAtWar, kGoalDestroy, 1.0, kTrue);
								Klingon_ATeam->mClearCommands();
								fMission.mSetTeamRelations (kPlayerTeam, kKlingon_ATeam, kTeamAtWar, kGoalDestroy, 1.0, kTrue);
							}
						}
						for (Ship = GornTeam->mGetFirstShip(); Ship != NULL; Ship = GornTeam->mGetNextShip())
						{
							if ( fPlayerShip->mGetTacticalDistance(Ship) <= 10.0 )
							{
								GornTeam->mClearCommands();
								fMission.mSetTeamRelations (kPlayerTeam, kGornTeam, kTeamAtWar, kGoalDestroy, 1.0, kTrue);
								KraaTeam->mClearCommands();
								fMission.mSetTeamRelations (kPlayerTeam, kKraaTeam, kTeamAtWar, kGoalDestroy, 1.0, kTrue);
							}
						}
						for (Ship = HydranTeam->mGetFirstShip(); Ship != NULL; Ship = HydranTeam->mGetNextShip())
						{
							if ( fPlayerShip->mGetTacticalDistance(Ship) <= 10.0 )
							{
								HydranTeam->mClearCommands();
								fMission.mSetTeamRelations (kPlayerTeam, kHydranTeam, kTeamAtWar, kGoalDestroy, 1.0, kTrue);
							}
						}
						for (Ship = KraaTeam->mGetFirstShip(); Ship != NULL; Ship = KraaTeam->mGetNextShip())
						{
							if ( fPlayerShip->mGetTacticalDistance(Ship) <= 10.0 )
							{
								KraaTeam->mClearCommands();
								fMission.mSetTeamRelations (kPlayerTeam, kKraaTeam, kTeamAtWar, kGoalDestroy, 1.0, kTrue);
								GornTeam->mClearCommands();
								fMission.mSetTeamRelations (kPlayerTeam, kGornTeam, kTeamAtWar, kGoalDestroy, 1.0, kTrue);
							}
						}
						fMission.mSetTimedInterval( kTimerLimitSet_2, 1 );
					}
					break;

				case kTimerLimitSet_10:
					{
						eDeepScanFlags flag;
						tMapPoint		MapPoint;
						tShipInfo* Object = DeepScanTracker.mTestForDeepScan (&flag, &MapPoint);
						switch (flag)
						{
							case kOutOfRange_ScanOff:
								// player is not within any objects range and deep scan is off (Object == NULL)
								break;
							case kOutOfRange_ScanOn:
								// player is not within any objects range and deep scan is on (Object == NULL)
								break;
							case kEnteringRange_ScanOff:
								// player has just entered range and scan is off (Object points to entity)
								// notify player to turn scan on
								fMission.mDisplayMessage (kScannerOffInRange_msg, kScienceScriptMessage, Object);
								break;
							case kEnteringRange_ScanOn_TimerStarted:
								// player has just entered range and scan is on (Object points to entity)
								// notify player that timer has begun
								fMission.mDisplayMessage (kEvent2_D_msg, kScienceScriptMessage);
								break;
							case kInRange_ScanOff_TimerStopped:
								// player is in range and scan is off (Object points to entity)
								// notify player that timer has been turned off
								fMission.mDisplayMessage (kIncompleteScan_msg, kScienceScriptMessage);
								break;
							case kInRange_ScanOff:
								// player is still in range and scan is still off (Object points to entity)
								break;
							case kInRange_ScanOn_TimerStarted:
								// player is in range and scan is on (Object points to entity)
								// notify player that timer has begun
								fMission.mDisplayMessage (kEvent2_D_msg, kScienceScriptMessage);
								break;
							case kInRange_ScanOn:
								// player is still in range and scan is still on (Object points to entity)
								break;
							case kLeavingRange_ScanOn_TimerStopped:
								// player has just left the range and scan is on (Object points to entity)
								// notify player that timer is now off
								fMission.mDisplayMessage (kIncompleteScan_msg, kScienceScriptMessage);
								break;
							case kLeavingRange_ScanOff:
								// player has just left the range and scan is off (Object points to entity)
								break;
						}
					}
					break;

				case kTimerCountdownSet:
					{
						eDeepScanFlags flag;
						tMapPoint		MapPoint;
						tShipInfo* Object = DeepScanTracker.mTestForDeepScan (&flag, &MapPoint);
						if (flag == kInRange_ScanOn)
						{
							// player has successfully scanned the object
							// LNF do i need a message if I scanned something and the player rescans?
							if ( Object->mGetTeam() == kKraaTeam )
							{
								fMission.mDisplayMessage( kEvent3_msg, kMissionScriptMessage );
								Object->mChangeName( kDrKraa_name );
							}
							else
							{
								fMission.mDisplayMessage( kEvent2_C_msg, kMissionScriptMessage );
							}
							// (Object points to entity or if NULL then MapPoint has location)
							if (Object)
							{
								DeepScanTracker.mRemoveTarget (Object);
							}
							else
							{
								DeepScanTracker.mRemoveLocation (MapPoint.x, MapPoint.y);
							}
						}
					}
					break;

				case kTimerTurnsSet:
					// make all ships attack player
					// if any ships remain ( except Kraa )
					if (( AllFed_ADestroyed == false ) || ( AllFed_BDestroyed == false ) ||
						( AllKlingon_ADestroyed == false ) || ( AllKlingon_BDestroyed == false ) ||
						( AllGornDestroyed == false ) || ( AllHydranDestroyed == false ))
					{
						fMission.mDisplayMessage( kEvent4_AllShipsConverge_msg, kMissionScriptMessage );
						Klingon_ATeam->mClearCommands();
						Klingon_BTeam->mClearCommands();
						GornTeam->mClearCommands();
						HydranTeam->mClearCommands();
						KraaTeam->mClearCommands();
						fMission.mSetTeamRelations (kPlayerTeam, kKlingon_ATeam, kTeamAtWar, kGoalDestroy, 1.0, kTrue);
						fMission.mSetTeamRelations (kPlayerTeam, kKlingon_BTeam, kTeamAtWar, kGoalDestroy, 1.0, kTrue);
						fMission.mSetTeamRelations (kPlayerTeam, kGornTeam, kTeamAtWar, kGoalDestroy, 1.0, kTrue);
						fMission.mSetTeamRelations (kPlayerTeam, kHydranTeam, kTeamAtWar, kGoalDestroy, 1.0, kTrue);
						fMission.mSetTeamRelations (kPlayerTeam, kKraaTeam, kTeamAtWar, kGoalDestroy, 1.0, kTrue);

						// timer to find the wormhole
						fMission.mSetTimedInterval( kTimerTurnsSet_2, 1 );
					}
					else
					{
						// find the wormhole immediately
						fMission.mSetTimedInterval( kTimerTurnsSet_2, 0 );
					}
					break;

				case kTimerTurnsSet_2:
					{
						// pop in wormhole and point to it
						fMission.mDisplayMessage( kFoundWormhole_msg, kScienceScriptMessage );
						switch ( fMission.mRandomInt32( 1, 3 ) )
						{
							case 1:
								WormholeX = 13;
								WormholeY = 27;
								break;

							case 2:
								WormholeX = 17;
								WormholeY = 9;
								break;

							case 3:
								WormholeX = 31;
								WormholeY = 23;
								break;
						}
						fMission.mCreateMapObject( 'E', WormholeX, WormholeY );
						fMission.mSetGoalIndicator( kTrue, WormholeX, WormholeY );
						for (Ship = PlayerTeam->mGetFirstShip(); Ship != NULL; Ship = PlayerTeam->mGetNextShip())
						{
							Ship->mTrackTacticalDistance(kWormholeWarningDistance, WormholeX, WormholeY ); // Track wormhole
						}
					}
					break;
			}
			break;

		
		case kNotifyAtDeath:
			if (Ship->mGetOriginalTeam() == kPlayerTeam)
			{
				PlayerDestroyed++;
				if (PlayerTeam->mGetShipsInPlayCount() == 0)
				{
					return kPlayerDestroyed;
				}
			}

			switch (Ship->mGetOriginalTeam())
			{
				case kFed_ATeam:
					Fed_ADestroyed++;
					if (Fed_ATeam->mGetShipsInPlayCount() == 0)
					{
						AllFed_ADestroyed = true;
					}
					break;

				case kFed_BTeam:
					Fed_BDestroyed++;
					if (Fed_BTeam->mGetShipsInPlayCount() == 0)
					{
						AllFed_BDestroyed = true;
					}
					break;

				case kKlingon_ATeam:
					Klingon_ADestroyed++;
					if (Klingon_ATeam->mGetShipsInPlayCount() == 0)
					{
						AllKlingon_ADestroyed = true;
					}
					break;

				case kKlingon_BTeam:
					Klingon_BDestroyed++;
					if (Klingon_BTeam->mGetShipsInPlayCount() == 0)
					{
						AllKlingon_BDestroyed = true;
					}
					break;

				case kGornTeam:
					GornDestroyed++;
					if (GornTeam->mGetShipsInPlayCount() == 0)
					{
						// this is not necessarily true because of Kraa
						AllGornDestroyed = true;
/*						if ( KraaTeam->mGetShipsInPlayCount() == 0 )
						{
							AllGornDestroyed = true;
						}
*/					}
					break;

				case kHydranTeam:
					HydranDestroyed++;
					if (HydranTeam->mGetShipsInPlayCount() == 0)
					{
						AllHydranDestroyed = true;
					}
					break;

				case kKraaTeam:
					KraaDestroyed++;
					if (KraaTeam->mGetShipsInPlayCount() == 0)
					{
						if ( GornTeam->mGetShipsInPlayCount() == 0 )
						{
							AllGornDestroyed = true;
						}
					}
					break;
			}
			break;

		case kNotifyOnCapture:

			fMission.mAddToBonusPrestige( kCaptureBonus );

			if (Ship->mGetOriginalTeam() == kKraaTeam)
			{
				fMission.mDisplayMessage (kEvent4_A_msg, kScienceScriptMessage);
				KraaCaptured = 1;
				fMission.mDisplayMessage( kEvent4_FindWayHome_msg, kMissionScriptMessage );
				// make ships attack player
				fMission.mSetTimedInterval( kTimerTurnsSet, 1 );
			}
			else
			{
				fMission.mDisplayMessage( kVesselCaptured_msg, kMissionScriptMessage );
			}

			// LNF replace all this stuff with XXCaptured instead of teamDestroyed??
			switch (Ship->mGetOriginalTeam())
			{
				case kFed_ATeam:
					Fed_ADestroyed++;
					if (Fed_ATeam->mGetShipsInPlayCount() == 0)
					{
						AllFed_ADestroyed = true;
					}
					break;

				case kFed_BTeam:
					Fed_BDestroyed++;
					if (Fed_BTeam->mGetShipsInPlayCount() == 0)
					{
						AllFed_BDestroyed = true;
					}
					break;

				case kKlingon_ATeam:
					Klingon_ADestroyed++;
					if (Klingon_ATeam->mGetShipsInPlayCount() == 0)
					{
						AllKlingon_ADestroyed = true;
					}
					break;

				case kKlingon_BTeam:
					Klingon_BDestroyed++;
					if (Klingon_BTeam->mGetShipsInPlayCount() == 0)
					{
						AllKlingon_BDestroyed = true;
					}
					break;

				case kGornTeam:
					GornDestroyed++;
					if (GornTeam->mGetShipsInPlayCount() == 0)
					{
						// this is not necessarily true because of Kraa
						AllGornDestroyed = true;
/*						if ( KraaTeam->mGetShipsInPlayCount() == 0 )
						{
							AllGornDestroyed = true;
						}
*/					}
					break;

				case kHydranTeam:
					HydranDestroyed++;
					if (HydranTeam->mGetShipsInPlayCount() == 0)
					{
						AllHydranDestroyed = true;
					}
					break;

				case kKraaTeam:
					KraaDestroyed++;
					if (KraaTeam->mGetShipsInPlayCount() == 0)
					{
						if ( GornTeam->mGetShipsInPlayCount() == 0 )
						{
							AllGornDestroyed = true;
						}
					}
					break;
			}

			break;

		case kNotifyDisengaged:
			break;

		case kNotifyPlayerLeaving:
			PlayerUsedESCKey = true;
			break;

		case kNotifyCommButtonPress:
			{
				switch (fEventID)
				{
					case kButtonHail_text:
						// LNF if Kraa is captured? or leaves? ships say nothing?
						fMission.mDisplayMessage(kHail_msg, kMissionScriptMessage);
						Ship->mSetCommButton (1, kButtonTaunt_text);
						Ship->mSetCommButton (2, kButtonSurrender_text);
						break;

					case kButtonSurrender_text:
						fMission.mDisplayMessage(kSurrender_msg, kMissionScriptMessage);
						Ship->mSetCommButton (1, kButtonTaunt_text);
						Ship->mSetCommButton (2, kButtonSurrender_text);
						break;

					case kButtonTaunt_text:
						fMission.mDisplayMessage (fMission.mRandomInt32 (kTaunt1_msg, kTaunt4_msg), kMissionScriptMessage);
						Ship->mSetCommButton (1, kButtonTaunt_text);
						Ship->mSetCommButton (2, kButtonSurrender_text);
						break;

				}
			}
			break;
	}

	return fMission.mGetGameStatus();
	//return kGameInProgress;
}

//---------------------------------------------------------------------------------------------
// called when mission has ended but before debriefing and only if player is still alive
eVictoryLevels tScript::mCalcVictoryStatus (void)
{
	eVictoryLevels MyVictoryLevel = kDraw;

	int32 VictoryPoints = 0;

	VictoryPoints = ( KraaCaptured * 99 ) + ( Fed_ADestroyed * 5 ) + ( Fed_BDestroyed * 5 ) +
					( Klingon_ADestroyed * 5 ) + ( Klingon_BDestroyed * 5 ) + ( GornDestroyed * 5 ) +
					( HydranDestroyed * 5 );
	
	if (VictoryPoints >= 100)
	{
		MyVictoryLevel = kAstoundingVictory;
	}
	else if ((VictoryPoints <= 99) && (VictoryPoints >= 70))
	{
		MyVictoryLevel = kVictory;
	}
	else if ((VictoryPoints <= 69) && (VictoryPoints >= 50))
	{
		MyVictoryLevel = kDraw;
	}
	else if (VictoryPoints <= 49)
	{
		MyVictoryLevel = kDevastatingDefeat;
	}

	// LNF: Add Dynaverse rating adjustments

	return (MyVictoryLevel);
}

//---------------------------------------------------------------------------------------------
// called at end of mission only if player is still alive
void tScript::mGetDebriefingList (eVictoryLevels VictoryLevel)
{
	int32 SuccessCount = 0;
	int32 FailureCount = 0;

	if ( PlayerUsedESCKey == false )
	{
		fMission.mAddToDebriefingList (VictoryLevel + kAstoundingVictory_msg);

		if (VictoryLevel > kVictory)
		{
			fMission.mAddToDebriefingList (kDismissedShort_msg);
		}
		else
		{
			fMission.mAddToDebriefingList (kDismissedLong_msg);
		}
	}
	else // player exited improperly, display a message
	{
		fMission.mAddToDebriefingList( kImproperlyExitedMission_msg );
	}

	// LNF try this out:  adding results of primary objectives
	fMission.mAddToDebriefingList( kSuccessfulObjectives_msg );

	( KraaCaptured != 0 ) ? fMission.mAddToDebriefingList( kKraaCapturedTrue_msg ) : SuccessCount++;
	if ( SuccessCount == 1 )
	{
		fMission.mAddToDebriefingList( kNone_msg );
	}

	fMission.mAddToDebriefingList( kFailedObjectives_msg );

	( KraaCaptured == 0 ) ? fMission.mAddToDebriefingList( kKraaCapturedFalse_msg ) : FailureCount++;
	if ( FailureCount == 1 )
	{
		fMission.mAddToDebriefingList( kNone_msg );
	}

	fMission.mScheduleMission( kNextMission_msg );
	// LNF modify the number of spacer missions?
	int32 NumberOfSpacerMissions = fMission.mRandomInt32( 0, 2 );
	switch (NumberOfSpacerMissions)
	{
		case 0:
			break;

		case 1:
			fMission.mScheduleMission( kRandomMission_msg );
			break;
			
		case 2:
			fMission.mScheduleMission( kRandomMission_msg );
			fMission.mScheduleMission( kRandomMission_msg );
			break;
	}
}

//---------------------------------------------------------------------------------------------
// called at the end of every mission
int32 tScript::mGetTechnicalSuccessLevel (tDynaverseScriptInfo& info)
{
	// Write back global variable information here.  there are currently 16 of them
	// int32 info.fScriptValues[0];

	info.fScriptValues[0] = checkthisout;

	return 0;
}

//---------------------------------------------------------------------------------------------
// configure the fleets
void configureShips(tTeamInfo* TeamName)
{
	tShipInfo* Ship;

	for (Ship = TeamName->mGetFirstShip(); Ship != NULL; Ship = TeamName->mGetNextShip())
	{
		Ship->mSetCommButton (1, kButtonHail_text);
		Ship->mSetShipCallbackEvents (kNotifyDamage);
		Ship->mSetShipMaxSpeed( 12 );
	}
}

//---------------------------------------------------------------------------------------------
// set patrol for Federation vessels
void setFedPatrolRoute(tTeamInfo* TeamName, tScript& tScript)
{
	// LNF patrol attack radius should be = 10 
	const float kPatrolAttackRadius = 10.0;

	tTeamInfo* Fed_ATeam = tScript.fMission.mGetTeamHandle (kFed_ATeam); // Z
	tTeamInfo* Fed_BTeam = tScript.fMission.mGetTeamHandle (kFed_BTeam); // W
	tShipInfo* Ship;

	tMapPoint waypoints1[7]= // ship
	{
		28, 24,
		24, 24,
		19, 23,
		18, 19,
		21, 16,
		26, 17,
		29, 19
	};

	tMapPoint waypoints2[7]= // ship
	{
		26, 10,
		28, 13,
		27, 19,
		24, 23,
		20, 23,
		18, 18,
		21, 12
	};

	tMapPoint PatrolPoints[2][10];

	if ( TeamName == Fed_ATeam )
	{
		for (Ship = TeamName->mGetFirstShip(); Ship != NULL; Ship = TeamName->mGetNextShip())
		{
			PatrolPoints[0][0] = waypoints1[0];
			PatrolPoints[0][1] = waypoints1[1];
			PatrolPoints[0][2] = waypoints1[2];
			PatrolPoints[0][3] = waypoints1[3];
			PatrolPoints[0][4] = waypoints1[4];
			PatrolPoints[0][5] = waypoints1[5];
			PatrolPoints[0][6] = waypoints1[6];
			Ship->mPatrol (kPatrolAttackRadius, 7, &PatrolPoints[0][0], kMediumPriority);
		}
	}
	else if ( TeamName == Fed_BTeam )
	{
		for (Ship = TeamName->mGetFirstShip(); Ship != NULL; Ship = TeamName->mGetNextShip())
		{
			PatrolPoints[1][0] = waypoints2[0];
			PatrolPoints[1][1] = waypoints2[1];
			PatrolPoints[1][2] = waypoints2[2];
			PatrolPoints[1][3] = waypoints2[3];
			PatrolPoints[1][4] = waypoints2[4];
			PatrolPoints[1][5] = waypoints2[5];
			PatrolPoints[1][6] = waypoints2[6];
			Ship->mPatrol (kPatrolAttackRadius, 7, &PatrolPoints[1][0], kMediumPriority);
		}
	}
}

//---------------------------------------------------------------------------------------------
// set patrol for Klingon vessels
void setKlingonPatrolRoute(tTeamInfo* TeamName, tScript& tScript)
{
	// LNF what should the patrol attack radius be?
	const float kPatrolAttackRadius = 10.0;

	tTeamInfo* Klingon_ATeam = tScript.fMission.mGetTeamHandle (kKlingon_ATeam); // U
	tTeamInfo* Klingon_BTeam = tScript.fMission.mGetTeamHandle (kKlingon_BTeam); // X
	tShipInfo* Ship;

	tMapPoint waypoints1[7]= // ship U
	{
		13, 23,
		12, 20,
		13, 16,
		17, 13,
		22, 15,
		25, 19,
		21, 24
	};

	tMapPoint waypoints2[7]= // ship X
	{
		20, 14,
		24, 15,
		27, 18,
		26, 22,
		22, 25,
		18, 24,
		17, 20
	};

	tMapPoint PatrolPoints[2][10];

	if ( TeamName == Klingon_ATeam )
	{
		for (Ship = TeamName->mGetFirstShip(); Ship != NULL; Ship = TeamName->mGetNextShip())
		{
			PatrolPoints[0][0] = waypoints1[0];
			PatrolPoints[0][1] = waypoints1[1];
			PatrolPoints[0][2] = waypoints1[2];
			PatrolPoints[0][3] = waypoints1[3];
			PatrolPoints[0][4] = waypoints1[4];
			PatrolPoints[0][5] = waypoints1[5];
			PatrolPoints[0][6] = waypoints1[6];
			Ship->mPatrol (kPatrolAttackRadius, 7, &PatrolPoints[0][0], kMediumPriority);
		}
	}
	else if ( TeamName == Klingon_BTeam )
	{
		for (Ship = TeamName->mGetFirstShip(); Ship != NULL; Ship = TeamName->mGetNextShip())
		{
			PatrolPoints[1][0] = waypoints2[0];
			PatrolPoints[1][1] = waypoints2[1];
			PatrolPoints[1][2] = waypoints2[2];
			PatrolPoints[1][3] = waypoints2[3];
			PatrolPoints[1][4] = waypoints2[4];
			PatrolPoints[1][5] = waypoints2[5];
			PatrolPoints[1][6] = waypoints2[6];
			Ship->mPatrol (kPatrolAttackRadius, 7, &PatrolPoints[1][0], kMediumPriority);
		}
	}
}

//---------------------------------------------------------------------------------------------
// set patrol for Other vessels
void setOtherPatrolRoute(tTeamInfo* TeamName, tScript& tScript)
{
	// LNF what should the patrol attack radius be?
	const float kPatrolAttackRadius = 10.0;

	tTeamInfo* GornTeam = tScript.fMission.mGetTeamHandle (kGornTeam); // Y
	tTeamInfo* HydranTeam = tScript.fMission.mGetTeamHandle (kHydranTeam); // V
	tTeamInfo* KraaTeam = tScript.fMission.mGetTeamHandle (kKraaTeam); // T
	tShipInfo* Ship;

	tMapPoint waypoints1[8]= // ship YT
	{
		34, 19,
		33, 16,
		30, 14,
		25, 13,
		21, 14,
		22, 17,
		26, 20,
		30, 21
	};

	tMapPoint waypoints2[6]= // ship V
	{
		8, 17,
		14, 15,
		18, 16,
		18, 20,
		15, 22,
		11, 21
	};

	tMapPoint PatrolPoints[2][10];

	if (( TeamName == GornTeam ) || ( TeamName == KraaTeam ))
	{
		for (Ship = TeamName->mGetFirstShip(); Ship != NULL; Ship = TeamName->mGetNextShip())
		{
			PatrolPoints[0][0] = waypoints1[0];
			PatrolPoints[0][1] = waypoints1[1];
			PatrolPoints[0][2] = waypoints1[2];
			PatrolPoints[0][3] = waypoints1[3];
			PatrolPoints[0][4] = waypoints1[4];
			PatrolPoints[0][5] = waypoints1[5];
			PatrolPoints[0][6] = waypoints1[6];
			PatrolPoints[0][7] = waypoints1[7];
			Ship->mPatrol (kPatrolAttackRadius, 8, &PatrolPoints[0][0], kMediumPriority);
		}
	}
	else if ( TeamName == HydranTeam )
	{
		for (Ship = TeamName->mGetFirstShip(); Ship != NULL; Ship = TeamName->mGetNextShip())
		{
			PatrolPoints[1][0] = waypoints2[0];
			PatrolPoints[1][1] = waypoints2[1];
			PatrolPoints[1][2] = waypoints2[2];
			PatrolPoints[1][3] = waypoints2[3];
			PatrolPoints[1][4] = waypoints2[4];
			PatrolPoints[1][5] = waypoints2[5];
			Ship->mPatrol (kPatrolAttackRadius, 6, &PatrolPoints[1][0], kMediumPriority);
		}
	}
}