int32 TotalMaps = 24;
const char* MapTypes[] = { "Open Space (L)", "Open Space (M)", "Open Space (S)", "Planets (L)",
	"Planets (M)", "Planet (S)", "Asteroid Field (L)", "Asteroid Field (M)", "Asteroid Field (S)",
	"Asteroid Belt (L)", "Asteroid Belt (M)", "Asteroid Belt (S)", "Black Hole (L)", "Black Hole (M)",
	"Black Hole (S)", "Black Holes (L)", "Black Holes (M)", "Black Holes (S)", "Nebula (L)",
	"Nebula (M)", "Nebula (S)", "Dark Nebula (L)", "Dark Nebula (M)", "Dark Nebula (S)" };
const char* MapLines[]=
{
	// Asteroids: a,A,*
	// Black Holes: b,B
	// Nebula: c,C
	// Dust clouds: d,D
	// Start positions: G,H,I,J,K,L,M,N,O,P,Q,R,S,T,U,V,W,X,Y,Z
	// End positions:   g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
	// Planets: 1-6
	// Suns: 7-9
	//
   "Multiplayer Free For All Maps",
   "// Open Space (L)",
   " +____1____2____3____4____5____6____7____8+",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "1|........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "2|........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "3|................I......J................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "4|........................................|",
   " |........................................|",
   " |................G......H................|",
   " |........................................|",
   " |........................................|",
   "5|........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |................L......K................|",
   "6|........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "7|........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "8|........................................|",
   " +----------------------------------------+",
   "      1    2    3    4    5    6    7    8",
   "// Open Space (M)",
   " +____1____2____3____4____5+",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   "1|.........................|",
   " |.........................|",
   " |.........I.....J.........|",
   " |.........................|",
   " |.........................|",
   "2|.........................|",
   " |.........................|",
   " |.........................|",
   " |.........G.....H.........|",
   " |.........................|",
   "3|.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   " |.........L.....K.........|",
   "4|.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   "5|.........................|",
   " +-------------------------+",
   "      1    2    3    4    5",
   "// Open Space (S)",
   " +____1____2____3+",
   " |...............|",
   " |...............|",
   " |....I....J.....|",
   " |...............|",
   "1|...............|",
   " |...............|",
   " |...............|",
   " |....G....H.....|",
   " |...............|",
   "2|...............|",
   " |...............|",
   " |...............|",
   " |....L....K.....|",
   " |...............|",
   "3|...............|",
   " +---------------+",
   "      1    2    3",
   "// Planets (L)",
   " +____1____2____3____4____5____6____7____8+",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |....7...................................|",
   "1|........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "2|........................................|",
   " |........................................|",
   " |........................................|",
   " |...............6........................|",
   " |........................................|",
   "3|........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "4|........................................|",
   " |........................................|",
   " |..............3.........................|",
   " |........................................|",
   " |........................................|",
   "5|..........................I.........a...|",
   " |.......................................a|",
   " |.....................H........a....a....|",
   " |................................A.......|",
   " |................G..........a............|",
   "6|.......................a........L.......|",
   " |...................a....................|",
   " |....a.......a..a...........K............|",
   " |........a..*............................|",
   " |..a..A................J.................|",
   "7|..............................2.........|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "8|........................................|",
   " +----------------------------------------+",
   "      1    2    3    4    5    6    7    8",
   "// Planets (M)",
   " +____1____2____3____4____5+",
   " |.........................|",
   " |.8.......................|",
   " |.........................|",
   " |.........................|",
   "1|.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   "2|.........................|",
   " |............J.....1......|",
   " |.........................|",
   " |.........................|",
   " |...L.............H.......|",
   "3|.........G...............|",
   " |.........................|",
   " |......................K..|",
   " |...............I.........|",
   " |.......4.................|",
   "4|.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   "5|.........................|",
   " +-------------------------+",
   "      1    2    3    4    5",
   "// Planet (S)",
   " +____1____2____3+",
   " |...............|",
   " |...............|",
   " |...............|",
   " |.......K.......|",
   "1|..J.........L..|",
   " |...............|",
   " |...............|",
   " |.......1.......|",
   " |...............|",
   "2|...............|",
   " |..G.........I..|",
   " |.......H.......|",
   " |...............|",
   " |...............|",
   "3|...............|",
   " +---------------+",
   "      1    2    3",
   "// Asteroid Field (L)",
   " +____1____2____3____4____5____6____7____8+",
   " |........................................|",
   " |........................................|",
   " |.........................a....A.........|",
   " |........................................|",
   "1|...............................a........|",
   " |........................A...a...........|",
   " |........................................|",
   " |........................................|",
   " |........................a...*...a.......|",
   "2|........................................|",
   " |........................................|",
   " |..................A...a.....a...........|",
   " |........................................|",
   " |........a...A............A..............|",
   "3|...................a....................|",
   " |.................A......................|",
   " |.......A....*.........A...a..A..........|",
   " |........................................|",
   " |...........a.....A...*..................|",
   "4|......A....................a............|",
   " |...............a........A...............|",
   " |...........A.......H....................|",
   " |.....a........................A.........|",
   " |.........a...G...........I..............|",
   "5|........................................|",
   " |.....a...................A......A.......|",
   " |..............L.........................|",
   " |...........*...........J.....A..........|",
   " |...A....a.........K.....................|",
   "6|..............a......a..................|",
   " |......a....................a............|",
   " |..........A.............a......A........|",
   " |.............a....a.....................|",
   " |......A...............a.................|",
   "7|.........a..............................|",
   " |..............a.........................|",
   " |.......a...............a....A...........|",
   " |...........a....A.......................|",
   " |...................a........a...........|",
   "8|........................................|",
   " +----------------------------------------+",
   "      1    2    3    4    5    6    7    8",
   "// Asteroid Field (M)",
   " +____1____2____3____4____5+",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   "1|.........................|",
   " |...........A...a.........|",
   " |.........................|",
   " |.a...A............A......|",
   " |............a............|",
   "2|..........A..............|",
   " |A....*........I....a..A..|",
   " |........H................|",
   " |....a.............J......|",
   " |....................a....|",
   "3|.................A.......|",
   " |....A...G................|",
   " |............L...K......A.|",
   " |..a........A....a........|",
   " |......A..................|",
   "4|..............a...A......|",
   " |..........a..............|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   "5|.........................|",
   " +-------------------------+",
   "      1    2    3    4    5",
   "// Asteroid Field (S)",
   " +____1____2____3+",
   " |...............|",
   " |.A...a...}...A.|",
   " |...............|",
   " |...K...!...J...|",
   "1|...............|",
   " |.{..a...a....a.|",
   " |...............|",
   " |..G.........I..|",
   " |...............|",
   "2|.a.....H.....a.|",
   " |....*.....}....|",
   " |.......A.......|",
   " |.........a.....|",
   " |...}..a......L.|",
   "3|..........A....|",
   " +---------------+",
   "      1    2    3",
   "// Asteroid Belt (L)",
   " +____1____2____3____4____5____6____7____8+",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "1|........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "2|.....................................A..|",
   " |........................................|",
   " |................................A....a..|",
   " |..........................A...a........A|",
   " |.................................A......|",
   "3|.....................A...a..A........a..|",
   " |................................A.......|",
   " |...............A...a...A..A.............|",
   " |........A....a..........................|",
   " |......a..........A......................|",
   "4|........a..A..L.....A........K......A...|",
   " |...A..................I........a.......A|",
   " |.a....A.....A...............a....A......|",
   " |...a................................A...|",
   " |.......A...G......H......A...A..........|",
   "5|..A..................A..........A.......|",
   " |.................a.....a...A............|",
   " |........J...........A...A...............|",
   " |............a..A.A......................|",
   " |.........a..A...........................|",
   "6|.....A.........A........................|",
   " |........A..A............................|",
   " |..A..a..................................|",
   " |......A.................................|",
   " |........................................|",
   "7|..A.....................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "8|........................................|",
   " +----------------------------------------+",
   "      1    2    3    4    5    6    7    8",
   "// Asteroid Belt (M)",
   " +____1____2____3____4____5+",
   " |..A............a.........|",
   " |....a.............a......|",
   " |................A........|",
   " |.......a..L....A.........|",
   "1|....A..............A.....|",
   " |................a........|",
   " |.......A...........a.....|",
   " |.....a.......H..*........|",
   " |.......*..........A......|",
   "2|....A................A...|",
   " |........a.......A........|",
   " |.....A....G......a..a....|",
   " |.........................|",
   " |.........a.......*....A..|",
   "3|......a.......I....A.....|",
   " |.....A...A...............|",
   " |..................A..a...|",
   " |.......a..*..............|",
   " |.............J....a......|",
   "4|.......A..a..........A...|",
   " |......A..........*.......|",
   " |.......a...........a.....|",
   " |..........A...........a..|",
   " |.......A...a...K....A....|",
   "5|.........a..........a..A.|",
   " +-------------------------+",
   "      1    2    3    4    5",
   "// Asteroid Belt (S)",
   " +____1____2____3+",
   " |............a..|",
   " |.........I.....|",
   " |.............a.|",
   " |............A..|",
   "1|.....H....a....|",
   " |.........A...a.|",
   " |.......a..a....|",
   " |.G...a........L|",
   " |...a....a......|",
   "2|...A.a.........|",
   " |.a........J....|",
   " |...a..a........|",
   " |..A............|",
   " |.a...a.........|",
   "3|........K......|",
   " +---------------+",
   "      1    2    3",
   "// Black Hole (L)",
   " +____1____2____3____4____5____6____7____8+",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "1|........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "2|........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "3|........................................|",
   " |........................................|",
   " |................L.....K.................|",
   " |........................................|",
   " |........................................|",
   "4|..............G....B....J...............|",
   " |........................................|",
   " |........................................|",
   " |................H.....I.................|",
   " |........................................|",
   "5|........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "6|........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "7|........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "8|........................................|",
   " +----------------------------------------+",
   "      1    2    3    4    5    6    7    8",
   "// Black Hole (M)",
   " +____1____2____3____4____5+",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   "1|.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   "2|.........................|",
   " |.........L.....I.........|",
   " |.........................|",
   " |.........................|",
   " |.......G....B....K.......|",
   "3|.........................|",
   " |.........................|",
   " |.........J.....H.........|",
   " |.........................|",
   " |.........................|",
   "4|.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   "5|.........................|",
   " +-------------------------+",
   "      1    2    3    4    5",
   "// Black Hole (S)",
   " +____1____2____3+",
   " |...............|",
   " |...............|",
   " |...............|",
   " |...............|",
   "1|....L.....I....|",
   " |...............|",
   " |...............|",
   " |..G....B....K..|",
   " |...............|",
   "2|...............|",
   " |....J.....H....|",
   " |...............|",
   " |...............|",
   " |...............|",
   "3|...............|",
   " +---------------+",
   "      1    2    3",
   "// Black Holes (L)",
   " +____1____2____3____4____5____6____7____8+",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "1|........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "2|........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |...................B....................|",
   "3|........................................|",
   " |........................................|",
   " |................L.....I.................|",
   " |........................................|",
   " |........................................|",
   "4|.........B....G....B....K....B..........|",
   " |........................................|",
   " |........................................|",
   " |................J.....H.................|",
   " |........................................|",
   "5|........................................|",
   " |...................B....................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "6|........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "7|........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "8|........................................|",
   " +----------------------------------------+",
   "      1    2    3    4    5    6    7    8",
   "// Black Holes (M)",
   " +____1____2____3____4____5+",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   "1|.....B.............B.....|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   "2|.........L.....I.........|",
   " |.........................|",
   " |.........................|",
   " |.B.....G....B....K.....B.|",
   " |.........................|",
   "3|.........................|",
   " |.........J.....H.........|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   "4|.....B.............B.....|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   "5|.........................|",
   " +-------------------------+",
   "      1    2    3    4    5",
   "// Black Holes (S)",
   " +____1____2____3+",
   " |...............|",
   " |.......B.......|",
   " |...............|",
   " |...L.......K...|",
   "1|...............|",
   " |.......B.......|",
   " |...............|",
   " |...G.......H...|",
   " |...............|",
   "2|.......B.......|",
   " |...............|",
   " |...J.......I...|",
   " |...............|",
   " |.......B.......|",
   "3|...............|",
   " +---------------+",
   "      1    2    3",
   "// Nebula (L)",
   " +____1____2____3____4____5____6____7____8+",
   " |........................................|",
   " |.C......................................|",
   " |........................................|",
   " |........................................|",
   "1|........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "2|........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "3|........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "4|..................J.......K.............|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "5|...............G.....H..................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "6|...........L......I.....................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "7|........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "8|........................................|",
   " +----------------------------------------+",
   "      1    2    3    4    5    6    7    8",
   "// Nebula (M)",
   " +____1____2____3____4____5+",
   " |.........................|",
   " |.C.......................|",
   " |.........................|",
   " |.........................|",
   "1|.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   "2|.........................|",
   " |.......G....H....I.......|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   "3|.........................|",
   " |.......J....K....L.......|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   "4|.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   "5|.........................|",
   " +-------------------------+",
   "      1    2    3    4    5",
   "// Nebula (S)",
   " +____1____2____3+",
   " |...............|",
   " |.C.............|",
   " |.....J....K....|",
   " |...............|",
   "1|...............|",
   " |...............|",
   " |...............|",
   " |.....G....H....|",
   " |...............|",
   "2|...............|",
   " |...............|",
   " |...............|",
   " |.....L....I....|",
   " |...............|",
   "3|...............|",
   " +---------------+",
   "      1    2    3",
   "// Dark Nebula (L)",
   " +____1____2____3____4____5____6____7____8+",
   " |........................................|",
   " |.C......................................|",
   " |........................................|",
   " |.............................d..........|",
   "1|........................................|",
   " |........................................|",
   " |........................................|",
   " |.............d..........................|",
   " |......................d.................|",
   "2|........................................|",
   " |........................................|",
   " |........................................|",
   " |....d..........d............d...........|",
   " |........................................|",
   "3|........................................|",
   " |.........................d..............|",
   " |...............B........................|",
   " |........................................|",
   " |.........d...........d..................|",
   "4|..............................d.........|",
   " |...............d........................|",
   " |..................K....J....G...........|",
   " |.........d..............................|",
   " |...B......................d......d......|",
   "5|..............d......d..................|",
   " |..................................d.....|",
   " |........d.........L....I....H...........|",
   " |........................................|",
   " |...............d........................|",
   "6|............................d...........|",
   " |.................d......................|",
   " |....d..........................d........|",
   " |......................d.................|",
   " |........................................|",
   "7|.............................d..........|",
   " |..........d...........B.................|",
   " |................d.......................|",
   " |.........................d..............|",
   " |........................................|",
   "8|........................................|",
   " +----------------------------------------+",
   "      1    2    3    4    5    6    7    8",
   "// Dark Nebula (M)",
   " +____1____2____3____4____5+",
   " |.........................|",
   " |.C.......................|",
   " |..........d..............|",
   " |.........................|",
   "1|.........d...............|",
   " |...d..........d..........|",
   " |.........................|",
   " |.......I....J......B.....|",
   " |.........................|",
   "2|...d......d..............|",
   " |.........................|",
   " |.........G....H...d......|",
   " |.........................|",
   " |............d............|",
   "3|....d....................|",
   " |...........K....L........|",
   " |.........d..........d....|",
   " |.........................|",
   " |.............d...........|",
   "4|...d.....................|",
   " |....................d....|",
   " |.........................|",
   " |.......B.....d...........|",
   " |.........................|",
   "5|.........................|",
   " +-------------------------+",
   "      1    2    3    4    5",
   "// Dark Nebula (S)",
   " +____1____2____3+",
   " |...............|",
   " |.C...d....d....|",
   " |...............|",
   " |...I.......J...|",
   "1|.......d.......|",
   " |..d.........d..|",
   " |...............|",
   " |..G....B....H..|",
   " |...............|",
   "2|............d..|",
   " |.d.....d.......|",
   " |...L.......K...|",
   " |...............|",
   " |......d...d....|",
   "3|...............|",
   " +---------------+",
   "      1    2    3",
   "///",
   0
};
