int32 TotalMaps = 11;
const char* MapTypes[] = { "Open Space (L)", "Open Space (M)", "Open Space (S)", "Asteroids (L)", 
	"Asteroids (M)", "Asteroids (S)", "Planets (L)", "Planets (M)", "Planets (S)", "Dust Clouds (M)", "Dust Clouds (S)" };
const char* MapLines[]=
{
	// Asteroids: a,A,*
	// Black Holes: b,B
	// Nebula: c,C
	// Dust clouds: d,D
	// Start positions: G,H,I,J,K,L,M,N,O,P,Q,R,S,T,U,V,W,X,Y,Z
	// End positions:   g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
	// Planets: 1-6
	// Suns: 7-9
	//
   "Mission Maps",
   "// Open Space (L)",
   " +____1____2____3____4____5____6____7____8+",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "1|........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "2|........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "3|................I......J................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "4|........................................|",
   " |........................................|",
   " |................G......H................|",
   " |........................................|",
   " |........................................|",
   "5|........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |................L......K................|",
   "6|........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "7|........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "8|........................................|",
   " +----------------------------------------+",
   "      1    2    3    4    5    6    7    8",
   "// Open Space (M)",
   " +____1____2____3____4____5+",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   "1|.........................|",
   " |.........................|",
   " |.........I.....J.........|",
   " |.........................|",
   " |.........................|",
   "2|.........................|",
   " |.........................|",
   " |.........................|",
   " |.........G.....H.........|",
   " |.........................|",
   "3|.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   " |.........L.....K.........|",
   "4|.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   "5|.........................|",
   " +-------------------------+",
   "      1    2    3    4    5",
   "// Open Space (S)",
   " +____1____2____3+",
   " |...............|",
   " |...............|",
   " |....I....J.....|",
   " |...............|",
   "1|...............|",
   " |...............|",
   " |...............|",
   " |....G....H.....|",
   " |...............|",
   "2|...............|",
   " |...............|",
   " |...............|",
   " |....L....K.....|",
   " |...............|",
   "3|...............|",
   " +---------------+",
   "      1    2    3",
   "// Asteroids (L)",
   " +____1____2____3____4____5____6____7____8+",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "1|........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "2|.....................................A..|",
   " |........................................|",
   " |................................A....a..|",
   " |..........................A...a........A|",
   " |.................................A......|",
   "3|.....................A...a..A........a..|",
   " |................................A.......|",
   " |...............A...a...A..A.............|",
   " |........A....a..........................|",
   " |......a..........A......................|",
   "4|........a..A..L.....A........K......A...|",
   " |...A..................I........a.......A|",
   " |.a....A.....A...............a....A......|",
   " |...a................................A...|",
   " |.......A...G......H......A...A..........|",
   "5|..A..................A..........A.......|",
   " |.................a.....a...A............|",
   " |........J...........A...A...............|",
   " |............a..A.A......................|",
   " |.........a..A...........................|",
   "6|.....A.........A........................|",
   " |........A..A............................|",
   " |..A..a..................................|",
   " |......A.................................|",
   " |........................................|",
   "7|..A.....................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "8|........................................|",
   " +----------------------------------------+",
   "      1    2    3    4    5    6    7    8",
   "// Asteroids (M)",
   " +____1____2____3____4____5+",
   " |..A............a.........|",
   " |....a.............a......|",
   " |................A........|",
   " |.......a..L....A.........|",
   "1|....A..............A.....|",
   " |................a........|",
   " |.......A...........a.....|",
   " |.....a.......H..*........|",
   " |.......*..........A......|",
   "2|....A................A...|",
   " |........a.......A........|",
   " |.....A....G......a..a....|",
   " |.........................|",
   " |.........a.......*....A..|",
   "3|......a.......I....A.....|",
   " |.....A...A...............|",
   " |..................A..a...|",
   " |.......a..*..............|",
   " |.............J....a......|",
   "4|.......A..a..........A...|",
   " |......A..........*.......|",
   " |.......a...........a.....|",
   " |..........A...........a..|",
   " |.......A...a...K....A....|",
   "5|.........a..........a..A.|",
   " +-------------------------+",
   "      1    2    3    4    5",
   "// Asteroids (S)",
   " +____1____2____3+",
   " |...............|",
   " |...............|",
   " |.......A.......|",
   " |....I.....J....|",
   "1|...............|",
   " |..A....A....A..|",
   " |...............|",
   " |....G.....H....|",
   " |...............|",
   "2|..A....A....A..|",
   " |...............|",
   " |....L.....K....|",
   " |.......A.......|",
   " |...............|",
   "3|...............|",
   " +---------------+",
   "      1    2    3",
   "// Planets (L)",
   " +____1____2____3____4____5____6____7____8+",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |....7...................................|",
   "1|........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "2|........................................|",
   " |........................................|",
   " |........................................|",
   " |...............6........................|",
   " |........................................|",
   "3|........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "4|........................................|",
   " |........................................|",
   " |..............3.........................|",
   " |........................................|",
   " |........................................|",
   "5|..........................I.........a...|",
   " |.......................................a|",
   " |.....................H........a....a....|",
   " |................................A.......|",
   " |................G..........a............|",
   "6|.......................a........L.......|",
   " |...................a....................|",
   " |....a.......a..a...........K............|",
   " |........a..*............................|",
   " |..a..A................J.................|",
   "7|..............................2.........|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "8|........................................|",
   " +----------------------------------------+",
   "      1    2    3    4    5    6    7    8",
   "// Planets (M)",
   " +____1____2____3____4____5+",
   " |.........................|",
   " |.8.......................|",
   " |.........................|",
   " |.........................|",
   "1|.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   "2|.........................|",
   " |............J.....1......|",
   " |.........................|",
   " |.........................|",
   " |...L.............H.......|",
   "3|.........G...............|",
   " |.........................|",
   " |......................K..|",
   " |...............I.........|",
   " |.......4.................|",
   "4|.........................|",
   " |............0............|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   "5|.........................|",
   " +-------------------------+",
   "      1    2    3    4    5",
   "// Planets (S)",
   " +____1____2____3+",
   " |...............|",
   " |...............|",
   " |.....3.........|",
   " |...............|",
   "1|...............|",
   " |...............|",
   " |.....G.L.J.....|",
   " |...............|",
   " |.....I.K.H.....|",
   "2|...............|",
   " |...............|",
   " |...............|",
   " |........6......|",
   " |...............|",
   "3|...............|",
   " +---------------+",
   "      1    2    3",
   "// Dust Clouds (M)",
   " +____1____2____3____4____5+",
   " |..d............d.........|",
   " |....d.............d......|",
   " |................d........|",
   " |.......d..L....d.........|",
   "1|....d........d.....d.....|",
   " |.........d..d...d........|",
   " |.......d...........d.....|",
   " |.....d.......H..d........|",
   " |.......d........d.d......|",
   "2|....d.....d..d.......d...|",
   " |........d.......d........|",
   " |.....d....G......d..d....|",
   " |.............d.d.........|",
   " |.........d.d.....d....d..|",
   "3|......d.......I....d.....|",
   " |.....d...d......d........|",
   " |...........d.d....d..d...|",
   " |.......d..d..............|",
   " |.............J....d......|",
   "4|.......d..d..........d...|",
   " |......d......d.d.d.......|",
   " |.......d....d......d.....|",
   " |..........d...........d..|",
   " |.......d...d...K....d....|",
   "5|.........d..........d..d.|",
   " +-------------------------+",
   "      1    2    3    4    5",
   "// Dust Clouds (S)",
   " +____1____2____3+",
   " |.......d.......|",
   " |ddddddddddddddd|",
   " |.......d.......|",
   " |....I..d..J....|",
   "1|.......d.......|",
   " |ddddddddddddddd|",
   " |.......d.......|",
   " |....G..d..H....|",
   " |.......d.......|",
   "2|ddddddddddddddd|",
   " |.......d.......|",
   " |....L..d..K....|",
   " |.......d.......|",
   " |ddddddddddddddd|",
   "3|.......d.......|",
   " +---------------+",
   "      1    2    3",
   "///",
   0
};
