int32 TotalMaps = 17;
int32 FirstBlackHoleMap = 11;
const char* MapTypes[] = { "Open Space (Lrg)", "Open Space (Med)", "Open Space (Sml)",
	"Planets (Med)", "Planet (Sml)", "Asteroid Field (Med)", "Asteroid Field (Sml)",
	"Asteroid Belt (Med)", "Asteroid Belt (Sml)", "Nebula (Med)", "Nebula (Sml)",
	"Dark Nebula (Med)", "Dark Nebula (Sml)", "Black Hole (Med)", "Black Hole (Sml)",
	"Black Holes (Med)", "Black Holes (Sml)" };
const char* MapLines[]=
{
	// Asteroids: a,A,*
	// Black Holes: b,B
	// Nebula: c,C
	// Dust clouds: d,D
	// Start positions: G,H,I,J,K,L,M,N,O,P,Q,R,S,T,U,V,W,X,Y,Z
	// End positions:   g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
	// Planets: 1-6
	// Suns: 7-9
	//
   "Multiplayer Tourneyfest Lite Maps",
   "// Open Space (Lrg)",
   " +____1____2____3____4____5____6____7____8+",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "1|........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "2|........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "3|................I......J................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "4|........................................|",
   " |........................................|",
   " |................G......H................|",
   " |........................................|",
   " |........................................|",
   "5|........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |................L......K................|",
   "6|........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "7|........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   " |........................................|",
   "8|........................................|",
   " +----------------------------------------+",
   "      1    2    3    4    5    6    7    8",
   "// Open Space (Med)",
   " +____1____2____3____4____5+",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   "1|.........................|",
   " |.........I......J........|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   "2|.........................|",
   " |.........................|",
   " |.........................|",
   " |.........G......H........|",
   " |.........................|",
   "3|.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   "4|.........L......K........|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   "5|.........................|",
   " +-------------------------+",
   "      1    2    3    4    5",
   "// Open Space (Sml)",
   " +____1____2____3+",
   " |...............|",
   " |...............|",
   " |....I....J.....|",
   " |...............|",
   "1|...............|",
   " |...............|",
   " |...............|",
   " |....G....H.....|",
   " |...............|",
   "2|...............|",
   " |...............|",
   " |...............|",
   " |....L....K.....|",
   " |...............|",
   "3|...............|",
   " +---------------+",
   "      1    2    3",
   "// Planets (Med)",
   " +____1____2____3____4____5+",
   " |.........................|",
   " |.8.......................|",
   " |.........................|",
   " |.........................|",
   "1|.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   "2|.........................|",
   " |............J.....1......|",
   " |....L....................|",
   " |.........................|",
   " |.................H.......|",
   "3|.........G...............|",
   " |.........................|",
   " |......................K..|",
   " |...............I.........|",
   " |.......2.................|",
   "4|.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   "5|.........................|",
   " +-------------------------+",
   "      1    2    3    4    5",
   "// Planet (Sml)",
   " +____1____2____3+",
   " |...............|",
   " |...............|",
   " |...............|",
   " |.......K.......|",
   "1|..J.........L..|",
   " |...............|",
   " |...............|",
   " |.......1.......|",
   " |...............|",
   "2|...............|",
   " |..G.........I..|",
   " |.......H.......|",
   " |...............|",
   " |...............|",
   "3|...............|",
   " +---------------+",
   "      1    2    3",
   "// Asteroid Field (Med)",
   " +____1____2____3____4____5+",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   "1|.........................|",
   " |...........A...a.........|",
   " |........A.....L..........|",
   " |.a...A............A......|",
   " |.........a...............|",
   "2|................A........|",
   " |A....*......H......a..A..|",
   " |.........................|",
   " |....a..G........*........|",
   " |....................a....|",
   "3|.J...............A.......|",
   " |....A...a...I............|",
   " |..............a....K...A.|",
   " |..a........A....a........|",
   " |......A..................|",
   "4|..............a...A......|",
   " |..........a..............|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   "5|.........................|",
   " +-------------------------+",
   "      1    2    3    4    5",
   "// Asteroid Field (Sml)",
   " +____1____2____3+",
   " |...............|",
   " |.A...a...a...A.|",
   " |...............|",
   " |...K...*...J...|",
   "1|...............|",
   " |.a..a...a....a.|",
   " |...............|",
   " |..G.........I..|",
   " |...............|",
   "2|.a.....H.....a.|",
   " |....a.....a....|",
   " |.......A.......|",
   " |.........a.....|",
   " |...A..a......L.|",
   "3|..........A....|",
   " +---------------+",
   "      1    2    3",
   "// Asteroid Belt (Med)",
   " +____1____2____3____4____5+",
   " |..A............a.........|",
   " |....a.............a......|",
   " |................A........|",
   " |.......a..L....A.........|",
   "1|....A..............A.....|",
   " |................a........|",
   " |.......A...........a.....|",
   " |.....a.......H..*........|",
   " |.......*..........A......|",
   "2|....A................A...|",
   " |........a.......A........|",
   " |.....A....G......a..a....|",
   " |.........................|",
   " |.........a.......*....A..|",
   "3|......a.......I....A.....|",
   " |.....A...A...............|",
   " |..................A..a...|",
   " |.......a..*..............|",
   " |.............J....a......|",
   "4|.......A..a..........A...|",
   " |......A..........*.......|",
   " |.......a...........a.....|",
   " |..........A...........a..|",
   " |.......A...a...K....A....|",
   "5|.........a..........a..A.|",
   " +-------------------------+",
   "      1    2    3    4    5",
   "// Asteroid Belt (Sml)",
   " +____1____2____3+",
   " |............a..|",
   " |.........I.....|",
   " |.............a.|",
   " |............A..|",
   "1|.....H....a....|",
   " |.........A...a.|",
   " |.......a..a....|",
   " |.G...a........L|",
   " |...a....a......|",
   "2|...A.a.........|",
   " |.a........J....|",
   " |...a..a........|",
   " |..A............|",
   " |.a...a.........|",
   "3|........K......|",
   " +---------------+",
   "      1    2    3",
   "// Nebula (Med)",
   " +____1____2____3____4____5+",
   " |.........................|",
   " |.C.......................|",
   " |.........................|",
   " |.........................|",
   "1|.........................|",
   " |.........I......J........|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   "2|.........................|",
   " |.........................|",
   " |.........................|",
   " |.........G......H........|",
   " |.........................|",
   "3|.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   "4|.........L......K........|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   "5|.........................|",
   " +-------------------------+",
   "      1    2    3    4    5",
   "// Nebula (Sml)",
   " +____1____2____3+",
   " |...............|",
   " |.C.............|",
   " |....I....J.....|",
   " |...............|",
   "1|...............|",
   " |...............|",
   " |...............|",
   " |....G....H.....|",
   " |...............|",
   "2|...............|",
   " |...............|",
   " |...............|",
   " |....L....K.....|",
   " |...............|",
   "3|...............|",
   " +---------------+",
   "      1    2    3",
   "// Dark Nebula (Med)",
   " +____1____2____3____4____5+",
   " |.........................|",
   " |.C.......................|",
   " |..........d..............|",
   " |.........................|",
   "1|.........d...............|",
   " |...d..........d..........|",
   " |.........................|",
   " |.......I....J......B.....|",
   " |.........................|",
   "2|...d......d..............|",
   " |.........................|",
   " |.........G....H...d......|",
   " |.........................|",
   " |............d............|",
   "3|....d....................|",
   " |...........K....L........|",
   " |.........d..........d....|",
   " |.........................|",
   " |.............d...........|",
   "4|...d.....................|",
   " |....................d....|",
   " |.........................|",
   " |.......B.....d...........|",
   " |.........................|",
   "5|.........................|",
   " +-------------------------+",
   "      1    2    3    4    5",
   "// Dark Nebula (Sml)",
   " +____1____2____3+",
   " |...............|",
   " |.C...d....d....|",
   " |...............|",
   " |...I.......J...|",
   "1|.......d.......|",
   " |..d.........d..|",
   " |...............|",
   " |..G....B....H..|",
   " |...............|",
   "2|............d..|",
   " |.d.....d.......|",
   " |...L.......K...|",
   " |...............|",
   " |......d...d....|",
   "3|...............|",
   " +---------------+",
   "      1    2    3",
   "// Black Hole (Med)",
   " +____1____2____3____4____5+",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   "1|.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   "2|.........L.....K.........|",
   " |.........................|",
   " |.........................|",
   " |.......G....B....J.......|",
   " |.........................|",
   "3|.........................|",
   " |.........H.....I.........|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   "4|.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   "5|.........................|",
   " +-------------------------+",
   "      1    2    3    4    5",
   "// Black Hole (Sml)",
   " +____1____2____3+",
   " |...............|",
   " |...............|",
   " |...............|",
   " |...L.......K...|",
   "1|...............|",
   " |...............|",
   " |...............|",
   " |..G....B....H..|",
   " |...............|",
   "2|...............|",
   " |...............|",
   " |...J.......I...|",
   " |...............|",
   " |...............|",
   "3|...............|",
   " +---------------+",
   "      1    2    3",
   "// Black Holes (Med)",
   " +____1____2____3____4____5+",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   "1|.....B.............B.....|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   "2|.........L.....K.........|",
   " |.........................|",
   " |.........................|",
   " |.B.....G....B....J.....B.|",
   " |.........................|",
   "3|.........................|",
   " |.........H.....I.........|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   "4|.....B.............B.....|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   " |.........................|",
   "5|.........................|",
   " +-------------------------+",
   "      1    2    3    4    5",
   "// Black Holes (Sml)",
   " +____1____2____3+",
   " |...............|",
   " |.......B.......|",
   " |...............|",
   " |...L.......K...|",
   "1|...............|",
   " |.......B.......|",
   " |...............|",
   " |...G.......H...|",
   " |...............|",
   "2|.......B.......|",
   " |...............|",
   " |...J.......I...|",
   " |...............|",
   " |.......B.......|",
   "3|...............|",
   " +---------------+",
   "      1    2    3",
   "///",
   0
};
