//	<Name>	StateNormal.cpp
//
//	<Info>	DESCRIPTION
//

#include "tclient.h"
#include "StateBase.h"
#include "MissionText.h"


tStateBase::tStateBase( tUni_Sabotage* script, int32 difficultyLevel )
{
	fScript = script;
	fPlayerTeamID = script->kPlayerTeam;
	fPlayerTeam = fScript->fMission.mGetTeamHandle( fPlayerTeamID );
	fEnemyTeam = fScript->fMission.mGetTeamHandle( kEnemyTeam );
	fDiffLevel = difficultyLevel;
	fMissionAct = kStarting; 
}

//Events -------------------------------------------------------------------------------------------
/*
eGameStatus tStateNormal::mOnTimedInterval( tShipInfo* ship, int32 timerID )
{
	switch (fMissionAct)
	{
		case kStarting:
			fScript->fMission.mDisplayMessage( kCaptStart_msg, kMissionScriptMessage );
			fScript->fMission.mSetTimedInterval( kTimerLimitSet, 5 );
			fScript->mGotoState( new tStateSabotage( fScript, fDiffLevel ) );
			fMissionAct = kSabotage;
			break;

		case kSabotage:
			fScript->fMission.mDisplayMessage (kSabotage_msg, kEngineerScriptMessage);
			ship = fPlayerTeam->mGetFirstShip();
			ship->mDamageSystem (kDamageLeftWarpEngine, 100.0);
			ship->mDamageSystem (kDamageRightWarpEngine, 100.0);
			ship->mDamageSystem (kDamageCenterWarpEngine, 100.0);
			fScript->fMission.mSetTimedInterval (kTimerTurnsSet, 1);
			fMissionAct = kRepairing;
			break;

		case kRepairing:
			fRepairTotal = fRepairTotal + fScript->fMission.mRandomInt32( 1, 6 );
			if (fRepairTotal >= 13)
			{
				fScript->fMission.mDisplayMessage (kRepaired_msg, kEngineerScriptMessage);
				ship = fPlayerTeam->mGetFirstShip();
				ship->mDamageSystem (kDamageLeftWarpEngine, 0.0);
				ship->mDamageSystem (kDamageRightWarpEngine, 0.0);
				ship->mDamageSystem (kDamageCenterWarpEngine, 0.0);
				fMissionAct = kRepaired;
				int32 randomTurn = fScript->fMission.mRandomInt32( 3 + fDiffLevel, 6 + fDiffLevel );
				fScript->fMission.mSetTimedInterval( kTimerTurnsSet, randomTurn );
			}
			else
			{
				fScript->fMission.mDisplayMessage( fScript->fMission.mRandomInt32( kRepairingA_msg, kRepairingE_msg ), kEngineerScriptMessage );
				fScript->fMission.mSetTimedInterval( kTimerTurnsSet, 1);
			}
			break;

		case kRepaired:
			fScript->fMission.mDisplayMessage (kLeaving_msg, kScienceScriptMessage);
			fEnemyTeam->mGetFirstShip()->mDisengage(kByMapEdge, kAbsolutePriority);
			break;
	}

	return fScript->fMission.mGetGameStatus();
}
*/

eGameStatus tStateBase::mOnCapture( tShipInfo* capturedShip, tShipInfo* hostileShip )
{
	if( capturedShip->mGetTeam() == kEnemyTeam )
	{
		fScript->mEnemyCaptured();
		fScript->mGiveBonusBalancePoints();
		return kEnemyCaptured;
	}

	return fScript->fMission.mGetGameStatus();
}

eGameStatus tStateBase::mOnDeath( tShipInfo* ship )
{
	if( ship->mGetOriginalTeam() == fPlayerTeamID )
	{
		return kPlayerDestroyed;
	}
	else
	{
		fScript->mGiveBonusBalancePoints();
		
		return kPlayerWins;
	}
}


eGameStatus tStateBase::mOnDisengaged( tShipInfo* ship )
{
	tTeamInfo* playerTeam = fScript->fMission.mGetTeamHandle( fPlayerTeamID );

	if(( ship->mGetOriginalTeam() == fPlayerTeamID ) && ( playerTeam->mGetShipsInPlayCount() == 0 ))
	{
		fScript->mPlayerDisengaged();
	}

	return kPlayerWins;
}


// 8Nov99	zdrummond	Added Comment Header and Footer's