//	<Name>	StateRepairing.cpp
//
//
//	<Info>	DESCRIPTION
//

#include "tclient.h"
#include "StateRepairing.h"
#include "StateRepaired.h"
#include "MissionText.h"

//Define state name
const char* tStateStarting::kName = "Repairing";
const char* tStateStarting::mGetName()
{
	return kName; 
}


tStateRepairing::tStateRepairing( tUni_Sabotage* script, int32 difficultyLevel )
	: tStateBase( script, difficultyLevel )
{}

eGameStatus tStateRepairing::mOnTimedInterval( tShipInfo* ship, int32 timerID )
{
	fRepairTotal = fRepairTotal + fScript->fMission.mRandomInt32( 1, 6 );
	if (fRepairTotal >= 13)
	{
		fScript->fMission.mDisplayMessage (kRepaired_msg, kEngineerScriptMessage);
		ship = fPlayerTeam->mGetFirstShip();
		ship->mDamageSystem (kDamageLeftWarpEngine, 0.0);
		ship->mDamageSystem (kDamageRightWarpEngine, 0.0);
		ship->mDamageSystem (kDamageCenterWarpEngine, 0.0);
		int32 randomTurn = fScript->fMission.mRandomInt32( 3 + fDiffLevel, 6 + fDiffLevel );
		fScript->fMission.mSetTimedInterval( kTimerTurnsSet, randomTurn );
		
		fScript->mGotoState( tStateRepaired::kName );
	}
	else
	{
		fScript->fMission.mDisplayMessage( fScript->fMission.mRandomInt32( kRepairingA_msg, kRepairingE_msg ), kEngineerScriptMessage );
		fScript->fMission.mSetTimedInterval( kTimerTurnsSet, 1);
	}

	return fScript->fMission.mGetGameStatus();
}


// 8Nov99	zdrummond	Added Comment Header and Footer's