//	<Name>	Uni_Sabotage.h
//
//	<Legal>	Copyright (c) 1997-1998 by Quicksilver Software, Inc. ALL RIGHTS RESERVED.
//	This document contains CONFIDENTIAL, PROPRIETARY, TRADE SECRET information
//	belonging to Quicksilver Software, Inc. and may not be reproduced, in whole
//	or in part, without prior written permission from Quicksilver Software, Inc.
//
//	<Info>	DESCRIPTION
//

#if !defined( Uni_Sabotage_h )
#define Uni_Sabotage_h

#include "ScriptInterface.h"

class tUni_Sabotage : public tScriptInterface
{
public:
	tUni_Sabotage();

	int32	mInitializeStart( tDynaverseScriptInfo& info );
	iTruth	mUsePlayerShip( tShipInGame& Ship );
	void	mCreateMissionShips( int32 Mode );
	int32	mInitializeFinished();
	void	mStartMission();
	void	mNewMissionShip( tShipInfo* Ship );
	void	mGetDebriefingList( eVictoryLevels VictoryLevel );
	void	mScriptSpecs( tMissionSpec* Specs );
	eGameStatus	   mHandleShipEvent( tShipInfo* Ship, iNotifyEvents Event );
	eVictoryLevels mCalcVictoryStatus();
	int32	mGetTechnicalSuccessLevel( tDynaverseScriptInfo& info );
	int32	mGetEnemyTeamID();

protected:
	enum eMissionAct
	{
		kStarting = 0,
		kSabotage,
		kRepairing,
		kRepaired
	};

	//---------------------------------------------------------------------------------------------
	// the following enum is used to identify all non-player teams in the script
	// (use kPlayerTeam to access the current players team.)
	enum eTeamTypes
	{
		// the first 6 team types are reserved for player teams.
		kReserved = kTeam6,

		// add all non-player teams (enemy, allied, monsters, etc...) after this point.

		kEnemyTeam,
	};


	eMissionAct	fMissionAct;
	int32 fRepairTotal;
	int32 fBonusBalancePoints;
	int32 fDiffLevel;
	float fPlayerHealth;
	float fEnemyHealth;
	bool fPlayerDisengaged;
	bool fEnemyCaptured;

};

#endif


// 4Nov99	zdrummond	Added Comment Header and Footer's