//	<Name>	Script.h
//
//	<Legal>	Copyright (c) 1997-1998 by Quicksilver Software, Inc. ALL RIGHTS RESERVED.
//	This document contains CONFIDENTIAL, PROPRIETARY, TRADE SECRET information
//	belonging to Quicksilver Software, Inc. and may not be reproduced, in whole
//	or in part, without prior written permission from Quicksilver Software, Inc.
//
//	<Info>	DESCRIPTION
//

#if !defined( Script_h )
#define Script_h

class tScript
{
	//-------------------------------------------------------
	// private routines - not for script use
	//-------------------------------------------------------
public:
	virtual int32	mInitializeStart( tDynaverseScriptInfo& info ) = 0;
	virtual iTruth	mUsePlayerShip( tShipInGame& Ship ) = 0;
	virtual void	mCreateMissionShips( int32 Mode ) = 0;
	virtual int32	mInitializeFinished() = 0;
	virtual void	mStartMission() = 0;
	virtual void	mNewMissionShip( tShipInfo* Ship ) = 0;
	virtual void	mGetDebriefingList( eVictoryLevels VictoryLevel ) = 0;
	virtual void	mScriptSpecs( tMissionSpec* Specs ) = 0;
	virtual eVictoryLevels mCalcVictoryStatus() = 0;
	virtual int32	mGetTechnicalSuccessLevel( tDynaverseScriptInfo& info ) = 0;
	virtual int32	mGetEnemyTeamID() = 0;

	virtual eGameStatus mHandleShipEvent( tShipInfo* Ship, iNotifyEvents Event );
	virtual eGameStatus mOnDeath( tShipInfo* ship );
	virtual eGameStatus mOnCapture( tShipInfo* ship );
	virtual eGameStatus mOnDisengaged( tShipInfo* ship );
	virtual eGameStatus mAtDistance( tShipInfo* ship );
	virtual eGameStatus mAtDestination( tShipInfo* ship );
	virtual eGameStatus mOnTimedInterval( tShipInfo* ship );
	virtual eGameStatus mOnCommButtonPress( tShipInfo* ship );
	virtual eGameStatus mOnDamage( tShipInfo* ship );
	virtual eGameStatus mOnDeepScan( tShipInfo* ship );
	virtual eGameStatus mOnAlertStatusChange( tShipInfo* ship );
	virtual eGameStatus mOnProbeLaunch( tShipInfo* ship );
	virtual eGameStatus mOnBeginOrbit( tShipInfo* ship );
	virtual eGameStatus mOnEndOrbit( tShipInfo* ship );
	virtual eGameStatus mOnBeginTractor( tShipInfo* ship );
	virtual eGameStatus mOnEndTractor( tShipInfo* ship );
	virtual eGameStatus mOnFlashingButtonPressed( tShipInfo* ship );
	virtual eGameStatus mOnTransportedItemTo( tShipInfo* ship );
	virtual eGameStatus mOnTransportedItemFrom( tShipInfo* ship );
	virtual eGameStatus mOnChangingShip( tShipInfo* ship );
	virtual eGameStatus mOnSpecialTransport( tShipInfo* ship );
	virtual eGameStatus mOnPlayerLeaving( tShipInfo* ship );
	virtual eGameStatus mOnHostChanged( tShipInfo* ship );

	eTeamID			kPlayerTeam;
	tShipInfo*		fPlayerShip;
	iTruth			fIsDeepScanOn;
	iTruth			fThisScriptIsTheHost;

public:
	tMissionInfo			fMission;
	int32					fEventID;
	int32					fEventItem0;
	int32					fEventItem1;
	int32					fEventItem2;
	int32					fEventItem3;
};

#endif


// 4Nov99	zdrummond	Added Comment Header and Footer's